// T3DCONSOLE2.CPP - First Template for Tricks 3D Volume II
// Use this as a template for your applications if you wish
// you may want to change things like the resolution of the
// application, if it's windowed, the directinput devices
// that are acquired and so forth...
// currently the app creates a 640x480x16 windowed display
// hence, you must be in 16 bit color before running the application
// if you want fullscreen mode then simple change the WINDOWED_APP
// value in the #defines below value to FALSE (0). Similarly, if
// you want another bitdepth, maybe 8-bit for 256 colors then 
// change that in the call to DDraw_Init() in the function
// Game_Init() within this file.
	
// READ THIS!
// To compile make sure to include DDRAW.LIB, DSOUND.LIB,
// DINPUT.LIB, WINMM.LIB in the project link list, and of course 
// the C++ source modules T3DLIB1.CPP,T3DLIB2.CPP, and T3DLIB3.CPP
// and the headers T3DLIB1.H,T3DLIB2.H, and T3DLIB3.H must
// be in the working directory of the compiler


// INCLUDES ///////////////////////////////////////////////

#define INITGUID       // make sure all the COM interfaces are available
                       // instead of this you can include the .LIB file
                       // DXGUID.LIB

#define WIN32_LEAN_AND_MEAN  


#include <windows.h>   // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <iostream> // include important C/C++ stuff
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string>
#include <stdarg.h>
#include <stdio.h> 
#include <math.h>
#include <io.h>
#include <fcntl.h>
#include <vector>

#include <ddraw.h>  // directX includes
#include <dsound.h>
#include <dmksctrl.h>
#include <dmusici.h>
#include <dmusicc.h>
#include <dmusicf.h>
#include <dinput.h>
#include "t3dlib1.h" // game library includes
#include "t3dlib2.h"
#include "t3dlib3.h"

using namespace std;

// DEFINES ////////////////////////////////////////////////

// defines for windows interface
#define WINDOW_CLASS_NAME "WIN3DCLASS"  // class name
#define WINDOW_TITLE      "Operation: Omega Strike pre-ALPHA"

#define WINDOW_WIDTH	800	// size of window 
#define WINDOW_HEIGHT	600  

#define WINDOW_BPP        16    // bitdepth of window (8,16,24 etc.)
                                // note: if windowed and not
                                // fullscreen then bitdepth must
                                // be same as system bitdepth
                                // also if 8-bit the a pallete
                                // is created and attached

#define WINDOWED_APP      0     // 0 not windowed, 1 windowed


// TYPES //////////////////////////////////////////////////

// holder for enemy objects
typedef struct OBJECTS
{
	BOB_PTR object_ptr; // holds type of enemy
	
	// hold position of enemy
	int type;
	int x;
	int y;
	int deathanim;
	int target_x;
	int target_y;
	string soldier_face;
	string action;
	int action_timer;
	int playshot;
} *OBJECTS_PTR;


// PROTOTYPES /////////////////////////////////////////////

// game console
int Game_Init(void *parms=NULL);
int Game_Shutdown(void *parms=NULL);
int Game_Main(void *parms=NULL);
void Add_Enemy(int xpos, int ypos, int Etype);
void Add_Friend(int xpos, int ypos);
int Title_Screen(void *parms=NULL);
void tutorial();
int Load_Level_One(void *parms=NULL);
int Load_Level_Two(void *parms=NULL);
int Load_Level_Three(void *parms=NULL);

int level;
bool endLevel = false;
bool endMission = false;
int missionComplete = 300;
int enemycounter = 0;
int soldiershot[256];
int numEnemies = 0;
int numFriends = 0;
int addEnemy = 0;
int addFriend = 0;


// FUNCTIONS //////////////////////////////////////////////
int random_range(int lowest_number, int highest_number)
{
    if(lowest_number > highest_number)
	{
		int temp = lowest_number;
		lowest_number = highest_number;
		highest_number = temp;
    }

    int range = highest_number - lowest_number + 1;
    return lowest_number + int(range * rand()/(RAND_MAX + 1.0));
}

float Get_Angle(float x1, float y1, int quad)
{
	float temp;

	temp = ((acos((sqrt(x1*x1)) / (sqrt((x1*x1) + (y1*y1))))) * (180/3.14159265));

	if(quad == 2)
		temp = 180 - temp;
	else if(quad == 3)
		temp = temp + 180;
	else if(quad == 4)
		temp = 360 - temp;
	
	return temp;
}

void Soldier_Action(OBJECTS &Soldier);
int Shot_Line(int origin_x, int origin_y, int target_x, int target_y, int shoottype);
void Damage_BOB(BOB_PTR xBob, int damage);
void Soldier_Shot(int &shot)
{
	DSound_Play(soldiershot[shot]);
	if(shot > 63)
		shot = 0;
	else
		shot++;
}

// GLOBALS ////////////////////////////////////////////////

HWND main_window_handle           = NULL; // save the window handle
int window_closed = 0;					  // tracks if window is closed
HINSTANCE main_instance           = NULL; // save the instance
char buffer[256];                          // used to print text

// BOB Globals
BOB titlescreen;
BOB menu1;
BOB menu2;
BOB menuchoice;
BOB missionAccomplished;
BOB cursor;	  // Crosshair for cursor
BOB textures; // texture memory
BOB mainchar; // BOB for the good guys
BOB enemysoldier; // BOB for the enemy soldiers
BOB zombie; // BOB for the zombies
BOB zombiesoldier; // BOB for the zombie soldiers
BOB sandbags;
BOB barbedwire;
BOB barbedwireblood;
BOB bush;
BOB rock;
BOB twistedmetal;
BOB buildings;


OBJECTS Scenery[256];   // holds data for 256 pieces of scenery
OBJECTS Buildings[64];
OBJECTS EnemyPos[256];	// holds data for 256 enemies
OBJECTS Player;			// holds data for the player's character
OBJECTS FriendPos[256];

int lives = 10;  // number of lives player has
CHAR moving = 'N';

int FRIEND_LOW = 0;
int FRIEND_HIGH = 0;
int ENEMY_LOW = 0;
int ENEMY_HIGH = 0;
int SCENERY_LOW = 0;
int SCENERY_HIGH = 256;
int BUILDING_HIGH = 0;
BOB_PTR texturePTR = new BOB;

///////// SOUNDS //////////
int gunshot;
int hurt;
int death_sounds[8];
int soldiershotindex = 0;
int play_gunshot = 2;

// use an array of string pointers, could have used an
// array of chars or int, but harder to initialize
// the characters '0' - '9' represent bitmaps 0-9 in some texture memory

vector<vector<int> > world; // two dimensional vector which holds the terrain data

int WORLD_TILES;
int WORLD_WIDTH;     // add an extra column to the world so the program doesn't crash
int WORLD_MAX_WIDTH;  // always keep world_width -1 so the program doesn't crash
int WORLD_MAX_HEIGHT; // always keep world_tiles -1 so the program doesn't crash

int world_x;
int world_y; // current position of viewing window
int dead_y;
int mouse_x;		// x position of the mouse 
int mouse_y;		// y position of the mouse
string face;        // to determine which way the player is facing

//vector< vector<BOB_PTR> > 
BOB_PTR world_ptrs[8000][3000];//[WORLD_MAX_WIDTH][WORLD_MAX_HEIGHT];

// FUNCTIONS //////////////////////////////////////////////

LRESULT CALLBACK WindowProc(HWND hwnd, 
						    UINT msg, 
                            WPARAM wparam, 
                            LPARAM lparam)
{
// this is the main message handler of the system
PAINTSTRUCT	ps;		   // used in WM_PAINT
HDC			hdc;	   // handle to a device context

// what is the message 
switch(msg)
	{	
	case WM_CREATE: 
        {
		// do initialization stuff here
		return(0);
		} break;

    case WM_PAINT:
         {
         // start painting
         hdc = BeginPaint(hwnd,&ps);

         // end painting
         EndPaint(hwnd,&ps);
         return(0);
        } break;

	case WM_DESTROY: 
		{
		// kill the application			
		PostQuitMessage(0);
		return(0);
		} break;

	default:break;

    } // end switch

// process any messages that we didn't take care of 
return (DefWindowProc(hwnd, msg, wparam, lparam));

} // end WinProc

// WINMAIN ////////////////////////////////////////////////

int WINAPI WinMain(	HINSTANCE hinstance,
					HINSTANCE hprevinstance,
					LPSTR lpcmdline,
					int ncmdshow)
{
// this is the winmain function
WNDCLASSEX winclass; // this will hold the class we create
HWND	   hwnd;	 // generic window handle
MSG		   msg;		 // generic message
HDC        hdc;      // graphics device context

// first fill in the window class stucture
winclass.cbSize         = sizeof(WNDCLASSEX);
winclass.style			= CS_DBLCLKS | CS_OWNDC | 
                          CS_HREDRAW | CS_VREDRAW;
winclass.lpfnWndProc	= WindowProc;
winclass.cbClsExtra		= 0;
winclass.cbWndExtra		= 0;
winclass.hInstance		= hinstance;
winclass.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
winclass.hCursor		= LoadCursor(NULL, IDC_ARROW); 
winclass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
winclass.lpszMenuName	= NULL;
winclass.lpszClassName	= WINDOW_CLASS_NAME;
winclass.hIconSm        = LoadIcon(NULL, IDI_APPLICATION);


// register the window class
if (!RegisterClassEx(&winclass))
	return(0);


// create the window
if (!(hwnd = CreateWindowEx(NULL,              // extended style
                            WINDOW_CLASS_NAME, // class
						    WINDOW_TITLE, // title
						    (WINDOWED_APP ? (WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION) : (WS_POPUP | WS_VISIBLE)), 
					 	    0,0,	  // initial x,y
						    WINDOW_WIDTH,WINDOW_HEIGHT,  // initial width, height
						    NULL,	  // handle to parent 
						    NULL,	  // handle to menu
						    hinstance,// instance of this application
						    NULL)))   // extra creation parms
return(0);

// save the window handle and instance in a global
main_window_handle = hwnd;
main_instance      = hinstance;

// resize the window so that client is really width x height
if (WINDOWED_APP)
{
// now resize the window, so the client area is the actual size requested
// since there may be borders and controls if this is going to be a windowed app
// if the app is not windowed then it won't matter
RECT window_rect = {0,0,WINDOW_WIDTH-1,WINDOW_HEIGHT-1};


// make the call to adjust window_rect
AdjustWindowRectEx(&window_rect,
     GetWindowStyle(main_window_handle),
     GetMenu(main_window_handle) != NULL,
     GetWindowExStyle(main_window_handle));

// save the global client offsets, they are needed in DDraw_Flip()
window_client_x0 = -window_rect.left;
window_client_y0 = -window_rect.top;

// now resize the window with a call to MoveWindow()
MoveWindow(main_window_handle,
           0, // x position
           0, // y position
           window_rect.right - window_rect.left, // width
           window_rect.bottom - window_rect.top, // height
           FALSE);

// show the window, so there's no garbage on first render
ShowWindow(main_window_handle, SW_SHOW);
} // end if windowed


// perform all game console specific initialization
Game_Init();

Title_Screen();

// enter main event loop
while(1)
	{
	if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
		{ 
		// test if this is a quit
        if (msg.message == WM_QUIT)
           break;
	
		// translate any accelerator keys
		TranslateMessage(&msg);

		// send the message to the window proc
		DispatchMessage(&msg);
		} // end if
    
    // main game processing goes here

    Game_Main();

	} // end while

// shutdown game and release all resources
Game_Shutdown();


// return to Windows like this
return(msg.wParam);

} // end WinMain

//////////////// T3D II GAME PROGRAMMING CONSOLE FUNCTIONS ////////////////

int Game_Init(void *parms)
{
// this function is where you do all the initialization 
// for your game

// start up DirectDraw (replace the parms as you desire)
DDraw_Init(WINDOW_WIDTH, WINDOW_HEIGHT, WINDOW_BPP, WINDOWED_APP);

// initialize directinput
DInput_Init();

// acquire the keyboard 
DInput_Init_Keyboard();

// acquire the mouse
DInput_Init_Mouse();

// add calls to acquire other directinput devices here...


// initialize directsound and directmusic
DSound_Init();
DMusic_Init();

// hide the mouse
if (!WINDOWED_APP)
    ShowCursor(false);


// seed random number generator
srand(Start_Clock());


///////////////**** INITIALIZATION CODE ****///////////////

int index;
char filename[80]; // used to build up files names

//////////////************* TITLE SCREEN *******************////////////////////////
Load_Bitmap_File(&bitmap16bit, "resources/titlescreen.bmp");

if (FAILED(Create_BOB(&titlescreen,0,0,1024,768,1, BOB_ATTR_VISIBLE , DDSCAPS_SYSTEMMEMORY,RGB16Bit565(0,255,0),16)))
	return(0);

Load_Frame_BOB16(&titlescreen, &bitmap16bit, 0, 0, 0, BITMAP_EXTRACT_MODE_CELL);

Unload_Bitmap_File(&bitmap16bit);

Load_Bitmap_File(&bitmap16bit, "resources/menu1.bmp");

if (FAILED(Create_BOB(&menu1,0,0,190,123,1, BOB_ATTR_VISIBLE , DDSCAPS_SYSTEMMEMORY,RGB16Bit565(255,255,255),16)))
	return(0);

Load_Frame_BOB16(&menu1, &bitmap16bit, 0, 0, 0, BITMAP_EXTRACT_MODE_CELL);

Unload_Bitmap_File(&bitmap16bit);

Load_Bitmap_File(&bitmap16bit, "resources/menu2.bmp");

if (FAILED(Create_BOB(&menu2,0,0,608,43,1, BOB_ATTR_VISIBLE , DDSCAPS_SYSTEMMEMORY,RGB16Bit565(255,255,255),16)))
	return(0);

Load_Frame_BOB16(&menu2, &bitmap16bit, 0, 0, 0, BITMAP_EXTRACT_MODE_CELL);

Unload_Bitmap_File(&bitmap16bit);

Load_Bitmap_File(&bitmap16bit, "resources/choice.bmp");

if (FAILED(Create_BOB(&menuchoice,0,0,283,45,1, BOB_ATTR_VISIBLE , DDSCAPS_SYSTEMMEMORY,RGB16Bit565(0,80,46),16)))
	return(0);

Load_Frame_BOB16(&menuchoice, &bitmap16bit, 0, 0, 0, BITMAP_EXTRACT_MODE_CELL);

Unload_Bitmap_File(&bitmap16bit);

Load_Bitmap_File(&bitmap16bit, "resources/mcomp.bmp");

if (FAILED(Create_BOB(&missionAccomplished,0,0,481,198,1, BOB_ATTR_VISIBLE , DDSCAPS_SYSTEMMEMORY, RGB16Bit565(20,20,20), 16)))
{
	return(0);
}

Load_Frame_BOB16(&missionAccomplished, &bitmap16bit, 0, 0, 0, BITMAP_EXTRACT_MODE_CELL);

Unload_Bitmap_File(&bitmap16bit);

missionAccomplished.x = 160;
missionAccomplished.y = 200;

//////////////************* CURSOR *****************/////////////////////////
Load_Bitmap_File(&bitmap16bit, "resources/crosshair.bmp");

if (FAILED(Create_BOB(&cursor,0,0,32,32,1, BOB_ATTR_VISIBLE , DDSCAPS_SYSTEMMEMORY,0,16)))
	return(0);

Load_Frame_BOB16(&cursor, &bitmap16bit, 0, 0, 0, BITMAP_EXTRACT_MODE_CELL);

Unload_Bitmap_File(&bitmap16bit);


///////////////************ GOOD GUYS SPRITES *************////////////////////
// load in Character sprites
Load_Bitmap_File(&bitmap16bit, "resources/soldiersprites.bmp");

// create the good guy bob
if (FAILED(Create_BOB(&mainchar,0,0,32,32,126, BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM, DDSCAPS_VIDEOMEMORY,RGB16Bit565(255,255,255),16)))
{
	return(0);
}

// load each good guy bitmap into the mainchar BOB object
for (index = 0; index < 126; index++)
{
	Load_Frame_BOB16(&mainchar, &bitmap16bit, index, index%9, index/9, BITMAP_EXTRACT_MODE_CELL);
}

// unlaod good guy bitmap
Unload_Bitmap_File(&bitmap16bit);

// load in enemy soldier sprites
Load_Bitmap_File(&bitmap16bit, "resources/enemysprites.bmp");

// create the enemy bob
if (FAILED(Create_BOB(&enemysoldier,0,0,32,32,126, BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM, DDSCAPS_VIDEOMEMORY,RGB16Bit565(255,255,255),16)))
{
	return(0);
}

// load each enemy sprite bitmap into the enemy BOB object
for (index = 0; index < 126; index++)
{
	Load_Frame_BOB16(&enemysoldier, &bitmap16bit, index, index%9, index/9, BITMAP_EXTRACT_MODE_CELL);
}

// unload enemy sprite bitmap
Unload_Bitmap_File(&bitmap16bit);

// load in zombie sprites
Load_Bitmap_File(&bitmap16bit, "resources/zombie.bmp");

// create the zombie bob
if (FAILED(Create_BOB(&zombie,0,0,32,32,123, BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM, DDSCAPS_VIDEOMEMORY,RGB16Bit565(255,255,255),16)))
{
	return(0);
}

// load each zombie sprite bitmap into the zombie BOB object
for (index = 0; index < 123; index++)
{
	Load_Frame_BOB16(&zombie, &bitmap16bit, index, index%9, index/9, BITMAP_EXTRACT_MODE_CELL);
}

// unload zombie sprite bitmap
Unload_Bitmap_File(&bitmap16bit);


// load in zombie soldier sprites
Load_Bitmap_File(&bitmap16bit, "resources/zombiesoldier.bmp");

// create the zombie soldier bob
if (FAILED(Create_BOB(&zombiesoldier,0,0,32,32,123, BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM, DDSCAPS_VIDEOMEMORY,RGB16Bit565(255,255,255),16)))
{
	return(0);
}

// load each zombie soldier sprite bitmap into the zombie BOB object
for (index = 0; index < 123; index++)
{
	Load_Frame_BOB16(&zombiesoldier, &bitmap16bit, index, index%9, index/9, BITMAP_EXTRACT_MODE_CELL);
}

// unload zombie sprite bitmap
Unload_Bitmap_File(&bitmap16bit);


// SPRITE ANIMATIONS FOR BOTH SOLDIERS
int soldier_walkNfwd[] = {0, 1, 2, 1, 0, 3, 4, 3};
int soldier_walkNbwd[] = {0, 3, 4, 3, 0, 1, 2, 1};
int soldier_walkEfwd[] = {5, 6, 7, 6, 5, 8, 9, 8};
int soldier_walkEbwd[] = {5, 8, 9, 8, 5, 6, 7, 6};
int soldier_walkSfwd[] = {10, 11, 12, 11, 10, 13, 14, 13};
int soldier_walkSbwd[] = {10, 13, 14, 13, 10, 11, 12, 11};
int soldier_walkWfwd[] = {15, 16, 17, 16, 15, 18, 19, 18};
int soldier_walkWbwd[] = {15, 18, 19, 18, 15, 16, 17, 16};
int soldier_walkNEfwd[] = {20, 21, 22, 21, 20, 23, 24, 23};
int soldier_walkNEbwd[] = {20, 23, 24, 23, 20, 21, 22, 21};
int soldier_walkSEfwd[] = {25, 26, 27, 26, 25, 28, 29, 28};
int soldier_walkSEbwd[] = {25, 28, 29, 28, 25, 26, 27, 26};
int soldier_walkSWfwd[] = {30, 31, 32, 31, 30, 33, 34, 33};
int soldier_walkSWbwd[] = {30, 33, 34, 33, 30, 31, 32, 31};
int soldier_walkNWfwd[] = {35, 36, 37, 36, 35, 38, 39, 38};
int soldier_walkNWbwd[] = {35, 38, 39, 38, 35, 36, 37, 36};
int soldier_shootN[] = {40, 41};
int soldier_shootE[] = {42, 43};
int soldier_shootS[] = {44, 45};
int soldier_shootW[] = {46, 47};
int soldier_runshootN[] = {40, 41, 48, 49, 50, 51, 48, 49, 40, 41, 52, 53, 54, 55, 52, 53};
int soldier_runshootE[] = {42, 43, 56, 57, 58, 59, 56, 57, 42, 43, 60, 61, 62, 63, 60, 61};
int soldier_runshootS[] = {44, 45, 64, 65, 66, 67, 64, 65, 44, 45, 68, 69, 70, 71, 68, 69};
int soldier_runshootW[] = {46, 47, 72, 73, 74, 75, 72, 73, 46, 47, 76, 77, 78, 79, 76, 77};
int soldier_shootNE[] = {80, 81};
int soldier_shootSE[] = {90, 91};
int soldier_shootSW[] = {100, 101};
int soldier_shootNW[] = {110, 111};
int soldier_runshootNE[] = {80, 81, 82, 83, 84, 85, 82, 83, 80, 81, 86, 87, 88, 89, 86, 87};
int soldier_runshootSE[] = {90, 91, 92, 93, 94, 95, 92, 93, 90, 91, 96, 97 ,98, 99, 96, 97};
int soldier_runshootSW[] = {100, 101, 102, 103, 104, 105, 102, 103, 100, 101, 106, 107, 108, 109, 106, 107};
int soldier_runshootNW[] = {110, 111, 112, 113, 114, 115, 112, 113, 110, 111, 116, 117, 118, 119, 116, 117};
int soldier_dying[] = {120, 121, 122};

// load animations into BOB for good guys
Load_Animation_BOB(&mainchar, 0, 8, soldier_walkNfwd);
Load_Animation_BOB(&mainchar, 1, 8, soldier_walkNbwd);
Load_Animation_BOB(&mainchar, 2, 8, soldier_walkEfwd);
Load_Animation_BOB(&mainchar, 3, 8, soldier_walkEbwd);
Load_Animation_BOB(&mainchar, 4, 8, soldier_walkSfwd);
Load_Animation_BOB(&mainchar, 5, 8, soldier_walkSbwd);
Load_Animation_BOB(&mainchar, 6, 8, soldier_walkWfwd);
Load_Animation_BOB(&mainchar, 7, 8, soldier_walkWbwd);
Load_Animation_BOB(&mainchar, 8, 8, soldier_walkNEfwd);
Load_Animation_BOB(&mainchar, 9, 8, soldier_walkNEbwd);
Load_Animation_BOB(&mainchar, 10, 8, soldier_walkSEfwd);
Load_Animation_BOB(&mainchar, 11, 8, soldier_walkSEbwd);
Load_Animation_BOB(&mainchar, 12, 8, soldier_walkSWfwd);
Load_Animation_BOB(&mainchar, 13, 8, soldier_walkSWbwd);
Load_Animation_BOB(&mainchar, 14, 8, soldier_walkNWfwd);
Load_Animation_BOB(&mainchar, 15, 8, soldier_walkNWbwd);
Load_Animation_BOB(&mainchar, 16, 2, soldier_shootN);
Load_Animation_BOB(&mainchar, 17, 2, soldier_shootE);
Load_Animation_BOB(&mainchar, 18, 2, soldier_shootS);
Load_Animation_BOB(&mainchar, 19, 2, soldier_shootW);
Load_Animation_BOB(&mainchar, 20, 16, soldier_runshootN);
Load_Animation_BOB(&mainchar, 21, 16, soldier_runshootE);
Load_Animation_BOB(&mainchar, 22, 16, soldier_runshootS);
Load_Animation_BOB(&mainchar, 23, 16, soldier_runshootW);
Load_Animation_BOB(&mainchar, 24, 2, soldier_shootNE);
Load_Animation_BOB(&mainchar, 25, 2, soldier_shootSE);
Load_Animation_BOB(&mainchar, 26, 2, soldier_shootSW);
Load_Animation_BOB(&mainchar, 27, 2, soldier_shootNW);
Load_Animation_BOB(&mainchar, 28, 16, soldier_runshootNE);
Load_Animation_BOB(&mainchar, 29, 16, soldier_runshootSE);
Load_Animation_BOB(&mainchar, 30, 16, soldier_runshootSW);
Load_Animation_BOB(&mainchar, 31, 16, soldier_runshootNW);
Load_Animation_BOB(&mainchar, 32, 3, soldier_dying);


// load animations into BOB for enemy soldier
Load_Animation_BOB(&enemysoldier, 0, 8, soldier_walkNfwd);
Load_Animation_BOB(&enemysoldier, 1, 8, soldier_walkNbwd);
Load_Animation_BOB(&enemysoldier, 2, 8, soldier_walkEfwd);
Load_Animation_BOB(&enemysoldier, 3, 8, soldier_walkEbwd);
Load_Animation_BOB(&enemysoldier, 4, 8, soldier_walkSfwd);
Load_Animation_BOB(&enemysoldier, 5, 8, soldier_walkSbwd);
Load_Animation_BOB(&enemysoldier, 6, 8, soldier_walkWfwd);
Load_Animation_BOB(&enemysoldier, 7, 8, soldier_walkWbwd);
Load_Animation_BOB(&enemysoldier, 8, 8, soldier_walkNEfwd);
Load_Animation_BOB(&enemysoldier, 9, 8, soldier_walkNEbwd);
Load_Animation_BOB(&enemysoldier, 10, 8, soldier_walkSEfwd);
Load_Animation_BOB(&enemysoldier, 11, 8, soldier_walkSEbwd);
Load_Animation_BOB(&enemysoldier, 12, 8, soldier_walkSWfwd);
Load_Animation_BOB(&enemysoldier, 13, 8, soldier_walkSWbwd);
Load_Animation_BOB(&enemysoldier, 14, 8, soldier_walkNWfwd);
Load_Animation_BOB(&enemysoldier, 15, 8, soldier_walkNWbwd);
Load_Animation_BOB(&enemysoldier, 16, 2, soldier_shootN);
Load_Animation_BOB(&enemysoldier, 17, 2, soldier_shootE);
Load_Animation_BOB(&enemysoldier, 18, 2, soldier_shootS);
Load_Animation_BOB(&enemysoldier, 19, 2, soldier_shootW);
Load_Animation_BOB(&enemysoldier, 20, 16, soldier_runshootN);
Load_Animation_BOB(&enemysoldier, 21, 16, soldier_runshootE);
Load_Animation_BOB(&enemysoldier, 22, 16, soldier_runshootS);
Load_Animation_BOB(&enemysoldier, 23, 16, soldier_runshootW);
Load_Animation_BOB(&enemysoldier, 24, 2, soldier_shootNE);
Load_Animation_BOB(&enemysoldier, 25, 2, soldier_shootSE);
Load_Animation_BOB(&enemysoldier, 26, 2, soldier_shootSW);
Load_Animation_BOB(&enemysoldier, 27, 2, soldier_shootNW);
Load_Animation_BOB(&enemysoldier, 28, 16, soldier_runshootNE);
Load_Animation_BOB(&enemysoldier, 29, 16, soldier_runshootSE);
Load_Animation_BOB(&enemysoldier, 30, 16, soldier_runshootSW);
Load_Animation_BOB(&enemysoldier, 31, 16, soldier_runshootNW);
Load_Animation_BOB(&enemysoldier, 32, 3, soldier_dying);

// load animations into BOB for zombie soldier
Load_Animation_BOB(&zombiesoldier, 0, 8, soldier_walkNfwd);
Load_Animation_BOB(&zombiesoldier, 1, 8, soldier_walkNbwd);
Load_Animation_BOB(&zombiesoldier, 2, 8, soldier_walkEfwd);
Load_Animation_BOB(&zombiesoldier, 3, 8, soldier_walkEbwd);
Load_Animation_BOB(&zombiesoldier, 4, 8, soldier_walkSfwd);
Load_Animation_BOB(&zombiesoldier, 5, 8, soldier_walkSbwd);
Load_Animation_BOB(&zombiesoldier, 6, 8, soldier_walkWfwd);
Load_Animation_BOB(&zombiesoldier, 7, 8, soldier_walkWbwd);
Load_Animation_BOB(&zombiesoldier, 8, 8, soldier_walkNEfwd);
Load_Animation_BOB(&zombiesoldier, 9, 8, soldier_walkNEbwd);
Load_Animation_BOB(&zombiesoldier, 10, 8, soldier_walkSEfwd);
Load_Animation_BOB(&zombiesoldier, 11, 8, soldier_walkSEbwd);
Load_Animation_BOB(&zombiesoldier, 12, 8, soldier_walkSWfwd);
Load_Animation_BOB(&zombiesoldier, 13, 8, soldier_walkSWbwd);
Load_Animation_BOB(&zombiesoldier, 14, 8, soldier_walkNWfwd);
Load_Animation_BOB(&zombiesoldier, 15, 8, soldier_walkNWbwd);
Load_Animation_BOB(&zombiesoldier, 16, 2, soldier_shootN);
Load_Animation_BOB(&zombiesoldier, 17, 2, soldier_shootE);
Load_Animation_BOB(&zombiesoldier, 18, 2, soldier_shootS);
Load_Animation_BOB(&zombiesoldier, 19, 2, soldier_shootW);
Load_Animation_BOB(&zombiesoldier, 20, 16, soldier_runshootN);
Load_Animation_BOB(&zombiesoldier, 21, 16, soldier_runshootE);
Load_Animation_BOB(&zombiesoldier, 22, 16, soldier_runshootS);
Load_Animation_BOB(&zombiesoldier, 23, 16, soldier_runshootW);
Load_Animation_BOB(&zombiesoldier, 24, 2, soldier_shootNE);
Load_Animation_BOB(&zombiesoldier, 25, 2, soldier_shootSE);
Load_Animation_BOB(&zombiesoldier, 26, 2, soldier_shootSW);
Load_Animation_BOB(&zombiesoldier, 27, 2, soldier_shootNW);
Load_Animation_BOB(&zombiesoldier, 28, 16, soldier_runshootNE);
Load_Animation_BOB(&zombiesoldier, 29, 16, soldier_runshootSE);
Load_Animation_BOB(&zombiesoldier, 30, 16, soldier_runshootSW);
Load_Animation_BOB(&zombiesoldier, 31, 16, soldier_runshootNW);
Load_Animation_BOB(&zombiesoldier, 32, 3, soldier_dying);

// load animations into BOB for zombie
Load_Animation_BOB(&zombie, 0, 8, soldier_walkNfwd);
Load_Animation_BOB(&zombie, 1, 8, soldier_walkNbwd);
Load_Animation_BOB(&zombie, 2, 8, soldier_walkEfwd);
Load_Animation_BOB(&zombie, 3, 8, soldier_walkEbwd);
Load_Animation_BOB(&zombie, 4, 8, soldier_walkSfwd);
Load_Animation_BOB(&zombie, 5, 8, soldier_walkSbwd);
Load_Animation_BOB(&zombie, 6, 8, soldier_walkWfwd);
Load_Animation_BOB(&zombie, 7, 8, soldier_walkWbwd);
Load_Animation_BOB(&zombie, 8, 8, soldier_walkNEfwd);
Load_Animation_BOB(&zombie, 9, 8, soldier_walkNEbwd);
Load_Animation_BOB(&zombie, 10, 8, soldier_walkSEfwd);
Load_Animation_BOB(&zombie, 11, 8, soldier_walkSEbwd);
Load_Animation_BOB(&zombie, 12, 8, soldier_walkSWfwd);
Load_Animation_BOB(&zombie, 13, 8, soldier_walkSWbwd);
Load_Animation_BOB(&zombie, 14, 8, soldier_walkNWfwd);
Load_Animation_BOB(&zombie, 15, 8, soldier_walkNWbwd);
Load_Animation_BOB(&zombie, 16, 3, soldier_dying);


// Setup initial values for enemy soldiers
Set_Animation_BOB(&enemysoldier, 0);
Set_Anim_Speed_BOB(&enemysoldier, 4);
Set_Anim_Speed_BOB(&zombiesoldier, 4);
Set_Anim_Speed_BOB(&mainchar, 4);
Set_Vel_BOB(&enemysoldier, 0, 0);

gunshot = DSound_Load_WAV("resources/gunshot.wav");
for(index = 0; index < 64; index++)
{
	soldiershot[index] = DSound_Load_WAV("resources/gunshot.wav");
	DSound_Set_Freq(soldiershot[index], 22050);
	DSound_Set_Volume(soldiershot[index], 60);
}


death_sounds[0] = DSound_Load_WAV("resources/death1.wav");
death_sounds[1] = DSound_Load_WAV("resources/death2.wav");
death_sounds[2] = DSound_Load_WAV("resources/death3.wav");
death_sounds[3] = DSound_Load_WAV("resources/death4.wav");
death_sounds[4] = DSound_Load_WAV("resources/death5.wav");
death_sounds[5] = DSound_Load_WAV("resources/death6.wav");
death_sounds[6] = DSound_Load_WAV("resources/death7.wav");
death_sounds[7] = DSound_Load_WAV("resources/death8.wav");
death_sounds[8] = DSound_Load_WAV("resources/death9.wav");
DSound_Set_Freq(gunshot, 22050);
for(int x=0; x < 7; x++)
{
	DSound_Set_Freq(death_sounds[x], 22050);
	DSound_Set_Volume(death_sounds[x], 70);
}
DSound_Set_Freq(death_sounds[7], 22050);
DSound_Set_Freq(death_sounds[8], 22050);

hurt = DSound_Load_WAV("resources/hurt.wav");
DSound_Set_Freq(hurt, 22050);

// generate scenery

texturePTR->type = 2;


for (int index = SCENERY_LOW; index < SCENERY_HIGH; index++)
{
	Scenery[index].object_ptr = new BOB;
}
////////////// END SCENERY ////////////////////

// initialize enemy attributes
for (index = ENEMY_LOW; index < ENEMY_HIGH; index++)
{
	EnemyPos[index].object_ptr = new BOB;	// Create pointer to BOB
	Clone_BOB(&enemysoldier, EnemyPos[index].object_ptr);	// Clone enemysoldier BOB
	EnemyPos[index].object_ptr->curr_frame = 10;
}

// initialize friend attributes
for (index = FRIEND_LOW; index < FRIEND_HIGH; index++)
{
	FriendPos[index].object_ptr = new BOB;
	Clone_BOB(&mainchar, FriendPos[index].object_ptr);
}

//for(int x = 0; x < WORLD_TILES; x++)
//	for(int y = 0; y < WORLD_WIDTH; y++)
//		world_ptrs[x][y] = new BOB;
// return success
return(1);

} // end Game_Init

///////////////////////////////////////////////////////////

int Game_Shutdown(void *parms)
{
// this function is where you shutdown your game and
// release all resources that you allocated

// shut everything down

// release all your resources created for the game here....
// kill texture memory
Destroy_BOB(&textures);
Destroy_BOB(&mainchar);
Destroy_BOB(&enemysoldier);
Destroy_BOB(&zombie);
Destroy_BOB(&zombiesoldier);
Destroy_BOB(&sandbags);
Destroy_BOB(&barbedwire);
Destroy_BOB(&barbedwireblood);
Destroy_BOB(&bush);
Destroy_BOB(&rock);
Destroy_BOB(&twistedmetal);
for(int x = ENEMY_LOW; x < ENEMY_HIGH; x++)
	Destroy_BOB(EnemyPos[x].object_ptr);
for(int x = FRIEND_LOW; x < FRIEND_HIGH; x++)
	Destroy_BOB(FriendPos[x].object_ptr);
if(BUILDING_HIGH > 0)
{
	Destroy_BOB(&buildings);
	for(int x = 0; x < BUILDING_HIGH; x++)
		Destroy_BOB(Buildings[x].object_ptr);
}
Destroy_BOB(Player.object_ptr);
Destroy_BOB(&titlescreen);
Destroy_BOB(&menu1);
Destroy_BOB(&menu2);
Destroy_BOB(&menuchoice);

// now directsound
DSound_Stop_All_Sounds();
DSound_Delete_All_Sounds();
DSound_Shutdown();

// directmusic
DMusic_Delete_All_MIDI();
DMusic_Shutdown();

// shut down directinput
DInput_Release_Keyboard();

DInput_Shutdown();

// shutdown directdraw last
DDraw_Shutdown();

// return success
return(1);
} // end Game_Shutdown

//////////////////////////////////////////////////////////

int Game_Main(void *parms)
{
// this is the workhorse of your game it will be called
// continuously in real-time this is like main() in C
// all the calls for you game go here!

int index, index_x, index_y; // looping var
int start_map_x,start_map_y,  // map positions
    end_map_x,end_map_y; 

int offset_x, offset_y;       // pixel offsets within cell

int width, height, type, x0, y0, x1, y1; // for extracting values from EnemyPos

bool move = true;

// check of user is trying to exit
if (KEY_DOWN(VK_ESCAPE) || keyboard_state[DIK_ESCAPE])
{
    PostMessage(main_window_handle, WM_DESTROY,0,0);
} 

// start the timing clock
Start_Clock();

// clear the drawing surface 
DDraw_Fill_Surface(lpddsback, 0);

// read keyboard and other devices here
DInput_Read_Keyboard();

// MOUSE INPUT 
DInput_Read_Mouse();

if(Player.object_ptr->curr_frame == 122)
{
	if(lives > 0)
	{
		if(Player.deathanim > 75)
		{
			Player.object_ptr = new BOB;
			Clone_BOB(&mainchar, Player.object_ptr);
			Player.object_ptr->type = 0;
			Player.object_ptr->life = 3;
			Set_Animation_BOB(Player.object_ptr, 0);

			bool placed = false;
			for(int x = 0; x < 60; x++)
			{
				int tempx = random_range(world_x, (world_x + WINDOW_WIDTH - 32));
				if((world_ptrs[tempx][Player.y+300] == NULL) && (world_ptrs[tempx+16][Player.y+316] == NULL))
				{
					Player.x = tempx;
					Player.y += 300;
					placed = true;
					x = 60;
				}
			}
			if(placed == false)
			{
				for(int x = 0; x < 60; x++)
				{
					int tempx = random_range(world_x, (world_x + WINDOW_WIDTH - 32));
					if((world_ptrs[tempx][Player.y+200] == NULL) && (world_ptrs[tempx+16][Player.y+200] == NULL))
					{
						Player.x = tempx;
						Player.y += 200;
						placed = true;
						x = 60;
					}
				}
			}
			if(placed == false)
			{
				for(int x = 0; x < 60; x++)
				{
					int tempx = random_range(world_x, (world_x + WINDOW_WIDTH - 32));
					if((world_ptrs[tempx][Player.y+100] == NULL) && (world_ptrs[tempx+16][Player.y+100] == NULL))
					{
						Player.x = tempx;
						Player.y += 100;
						placed = true;
						x = 60;
					}
				}
			}
			if(placed == false)
			{
				for(int x = 0; x < 60; x++)
				{
					int tempx = random_range(world_x, (world_x + WINDOW_WIDTH - 32));
					if((world_ptrs[tempx][Player.y+50] == NULL) && (world_ptrs[tempx+16][Player.y+50] == NULL))
					{
						Player.x = tempx;
						Player.y += 50;
						placed = true;
						x = 60;
					}
				}
			}

			if(Player.y >= WORLD_MAX_HEIGHT)
				Player.y = WORLD_MAX_HEIGHT - 32;
			

			world_y = Player.y - WINDOW_HEIGHT/2 + 32;
			world_x = Player.x - WINDOW_WIDTH/2 + 32;
			if(world_y < 0)
				world_y = 0;
			else if(world_y > WORLD_MAX_HEIGHT - WINDOW_HEIGHT)
				world_y = WORLD_MAX_HEIGHT - WINDOW_HEIGHT;
			
			if(world_x < 0)
				world_x = 0;
			else if(world_x > WORLD_MAX_WIDTH - WINDOW_WIDTH)
				world_x = WORLD_MAX_WIDTH - WINDOW_WIDTH;

			for(int x = 0; x < 9; x++)
			{
				int tempx = random_range(world_x, (world_x + WINDOW_WIDTH - 32));
				int tempy = random_range(world_y + WINDOW_HEIGHT/2, world_y + WINDOW_HEIGHT - 32);
				if((world_ptrs[tempx][tempy] == NULL) && (world_ptrs[tempx+16][tempy+16] == NULL))
					Add_Friend(tempx, tempy);
				else
					x--;
			}

			lives--;
			Player.deathanim = 0;
		}
		else
			Player.deathanim++;
	}
}

// CLEAR OUT POINTER ARRAY ////
int tempx = world_x-32;
int tempy = world_y-32;
if(tempx < 0)
	tempx = 0;
if(tempy < 0)
	tempy = 0;

for(int x = tempx; x < (world_x + WINDOW_WIDTH + 32); x++)
	for(int y = tempy; y < (world_y + WINDOW_HEIGHT + 32); y++)
		world_ptrs[x][y] = NULL;


// compute starting map indices by dividing position by size of cell
start_map_x = world_x/64; // use >> 6 for speed, but this is clearer
start_map_y = world_y/64; 

// compute end of map rectangle for best cast i.e. aligned on 64x64 boundary
end_map_x = start_map_x + (WINDOW_WIDTH/64);
end_map_y = start_map_y + (WINDOW_HEIGHT/64);

// now compute number of pixels in x,y we are within the tile, i.e
// how much is scrolled off the edge?
offset_x = -(world_x % 64);
offset_y = -(world_y % 64);

// adjust end_map_x,y for offsets
if (offset_x)
   end_map_x++;

if (offset_y)
   end_map_y++;

// set starting position of first upper lh texture
int texture_x = offset_x;
int texture_y = offset_y;

// DRAW BACKGROUND TEXTURES
	for (index_y = start_map_y; index_y <= end_map_y; index_y++)
    {
		for (index_x = start_map_x; index_x <= end_map_x; index_x++)
			{
			// set position to blit
			textures.x = texture_x;
			textures.y = texture_y;
	        
			// set frame
			textures.curr_frame = world[index_y][index_x] - 0;

			if(level == 1)
			{
				if((textures.curr_frame == 0) && (world_y < 2500))
				{
					texturePTR->type = 3;
					tempx = (texture_x + world_x);
					tempy = (texture_y + world_y);
					for(int x = tempx; x < tempx+64; x++)
						for(int y = tempy; y < tempy+64; y++)
							world_ptrs[x][y] = texturePTR;
				}
				else if((textures.curr_frame == 1) && (world_y < 3500))
				{
					texturePTR->type = 3;
					tempx = (texture_x + world_x);
					tempy = (texture_y + world_y);
					for(int x = tempx; x < tempx+64; x++)
						for(int y = tempy; y < tempy+36; y++)
							world_ptrs[x][y] = texturePTR;
				}
				else if((textures.curr_frame == 2) && (world_y < 3500))
				{
					texturePTR->type = 3;
					tempx = (texture_x + world_x);
					tempy = (texture_y + world_y+20);
					for(int x = tempx; x < tempx+64; x++)
						for(int y = tempy; y < tempy+64; y++)
							world_ptrs[x][y] = texturePTR;
				}
				else if(textures.curr_frame == 3) 
				{
					tempx = (texture_x + world_x+10);
					tempy = (texture_y + world_y);
					for(int x = tempx; x < tempx+64; x++)
						for(int y = tempy; y < tempy+64; y++)
							world_ptrs[x][y] = texturePTR;
				}
				else if(textures.curr_frame == 4)
				{
					tempx = (texture_x + world_x);
					tempy = (texture_y + world_y);
					for(int x = tempx; x < tempx+44; x++)
						for(int y = tempy; y < tempy+64; y++)
							world_ptrs[x][y] = texturePTR;
				}
				else if((textures.curr_frame >= 18) && (textures.curr_frame <= 21))
				{
					tempx = (texture_x + world_x);
					tempy = (texture_y + world_y);
					for(int x = tempx; x < tempx+64; x++)
						for(int y = tempy; y < tempy+64; y++)
							world_ptrs[x][y] = texturePTR;
				}
				else if(textures.curr_frame > 21)
				{
					texturePTR->type = 2;
					tempx = (texture_x + world_x);
					tempy = (texture_y + world_y);
					for(int x = tempx; x < tempx+64; x++)
						for(int y = tempy; y < tempy+54; y++)
							world_ptrs[x][y] = texturePTR;
				}
			
			}
			else if(level == 2)
			{
				if(textures.curr_frame == 17)
				{
					tempx = (texture_x + world_x);
					tempy = (texture_y + world_y);

					if((tempx -= 5) < 0)
						tempx = 0;
					if((tempy -= 5) < 0)
						tempy = 0;

					for(int x = tempx; x < tempx+69; x++)
						for(int y = tempy; y < tempy+69; y++)
							world_ptrs[x][y] = texturePTR;
				}
				else if((textures.curr_frame == 1) || (textures.curr_frame == 6) || (textures.curr_frame == 18) || (textures.curr_frame == 22) || (textures.curr_frame == 26))
				{
					tempx = (texture_x + world_x+10);
					tempy = (texture_y + world_y);
					for(int x = tempx; x < tempx+64; x++)
						for(int y = tempy; y < tempy+64; y++)
							world_ptrs[x][y] = texturePTR;
				}
				else if((textures.curr_frame == 2) || (textures.curr_frame == 5) || (textures.curr_frame == 19) || (textures.curr_frame == 23) || (textures.curr_frame == 27))
				{
					tempx = (texture_x + world_x);
					tempy = (texture_y + world_y);
					for(int x = tempx; x < tempx+44; x++)
						for(int y = tempy; y < tempy+64; y++)
							world_ptrs[x][y] = texturePTR;
				}
				else if((textures.curr_frame == 3) || (textures.curr_frame == 7) || (textures.curr_frame == 20) || (textures.curr_frame == 24) || (textures.curr_frame == 28))
				{
					tempx = (texture_x + world_x);
					tempy = (texture_y + world_y+10);
					for(int x = tempx; x < tempx+64; x++)
						for(int y = tempy; y < tempy+64; y++)
							world_ptrs[x][y] = texturePTR;
				}
				else if((textures.curr_frame == 4) || (textures.curr_frame == 8) || (textures.curr_frame == 21) || (textures.curr_frame == 25) || (textures.curr_frame == 29))
				{
					tempx = (texture_x + world_x);
					tempy = (texture_y + world_y);
					for(int x = tempx; x < tempx+64; x++)
						for(int y = tempy; y < tempy+44; y++)
							world_ptrs[x][y] = texturePTR;
				}
				else if(textures.curr_frame == 9)
				{
					tempx = (texture_x + world_x);
					tempy = (texture_y + world_y);
					for(int x = tempx; x < tempx+64; x++)
						for(int y = tempy; y < tempy+64; y++)
							world_ptrs[x][y] = texturePTR;

					for(int x = tempx+45; x < tempx+64; x++)
						for(int y = tempy; y < tempy + 20; y++)
							world_ptrs[x][y] = NULL;
				}
				else if(textures.curr_frame == 10)
				{
					tempx = (texture_x + world_x);
					tempy = (texture_y + world_y);
					for(int x = tempx; x < tempx+64; x++)
						for(int y = tempy; y < tempy+64; y++)
							world_ptrs[x][y] = texturePTR;

					for(int x = tempx; x < tempx+20; x++)
						for(int y = tempy; y < tempy + 20; y++)
							world_ptrs[x][y] = NULL;
				}
				else if(textures.curr_frame == 11)
				{
					tempx = (texture_x + world_x);
					tempy = (texture_y + world_y);
					for(int x = tempx; x < tempx+64; x++)
						for(int y = tempy; y < tempy+64; y++)
							world_ptrs[x][y] = texturePTR;

					for(int x = tempx+45; x < tempx+64; x++)
						for(int y = tempy+45; y < tempy + 64; y++)
							world_ptrs[x][y] = NULL;
				}
				else if(textures.curr_frame == 12)
				{
					tempx = (texture_x + world_x);
					tempy = (texture_y + world_y);
					for(int x = tempx; x < tempx+64; x++)
						for(int y = tempy; y < tempy+64; y++)
							world_ptrs[x][y] = texturePTR;

					for(int x = tempx; x < tempx+20; x++)
						for(int y = tempy+45; y < tempy + 64; y++)
							world_ptrs[x][y] = NULL;
				}
				else if(textures.curr_frame == 13)
				{
					tempx = (texture_x + world_x);
					tempy = (texture_y + world_y);
					for(int x = tempx; x < tempx+44; x++)
						for(int y = tempy; y < tempy+44; y++)
							world_ptrs[x][y] = texturePTR;
				}
				else if(textures.curr_frame == 14)
				{
					tempx = (texture_x + world_x + 10);
					tempy = (texture_y + world_y);
					for(int x = tempx; x < tempx+64; x++)
						for(int y = tempy; y < tempy+44; y++)
							world_ptrs[x][y] = texturePTR;
				}
				else if(textures.curr_frame == 15)
				{
					tempx = (texture_x + world_x + 10);
					tempy = (texture_y + world_y + 10);
					for(int x = tempx; x < tempx+64; x++)
						for(int y = tempy; y < tempy+64; y++)
							world_ptrs[x][y] = texturePTR;
				}
				else if(textures.curr_frame == 16)
				{
					tempx = (texture_x + world_x);
					tempy = (texture_y + world_y + 10);
					for(int x = tempx; x < tempx+44; x++)
						for(int y = tempy; y < tempy+64; y++)
							world_ptrs[x][y] = texturePTR;
				}
				

			}

			// draw the texture
			Draw_BOB16(&textures,lpddsback);

			// update texture position
			texture_x+=64;

			} // end for map_x

    // reset x postion, update y
    texture_x =  offset_x;
    texture_y += 64;

    } // end for map_y


if((mouse_x + mouse_state.lX) < world_x)
	mouse_x = world_x;
else if((mouse_x + mouse_state.lX) > world_x + WINDOW_WIDTH)
	mouse_x = world_x + WINDOW_WIDTH;
else
{
	mouse_x += mouse_state.lX;
	cursor.x = mouse_x - world_x - 16;
}

if((mouse_y + mouse_state.lY) < world_y)
	mouse_y = world_y;
else if((mouse_y + mouse_state.lY) > world_y + WINDOW_HEIGHT)
	mouse_y = world_y + WINDOW_HEIGHT;
else
{
	mouse_y += mouse_state.lY;
	cursor.y = mouse_y - world_y - 16;
}

float mx1 = (mouse_x - Player.x - 16);
float my1 = -(mouse_y - Player.y - 16);
int quad;

if(mx1 > 0)
{
	if(my1 >= 0)
		quad = 1;
	else if(my1 < 0)
		quad = 4;
}
else if(mx1 <= 0)
{
	if(my1 > 0)
		quad = 2;
	else if(my1 <= 0)
		quad = 3;
}

float angle;
if((mx1 != 0) || (my1 != 0))
	angle = Get_Angle(mx1, my1, quad);

if(((angle >= 330) || (angle <= 30)) && (face != "E"))
{
	Player.object_ptr->curr_animation = 2;
	face = "E";
}
else if((angle > 30) && (angle < 60) && (face != "NE"))
{
	Player.object_ptr->curr_animation = 8;
	face = "NE";
}
else if((angle >= 60) && (angle <= 120) && (face != "N"))
{
	Player.object_ptr->curr_animation = 0;
	face = "N";
}
else if((angle > 120) && (angle < 150) && (face != "NW"))
{
	Player.object_ptr->curr_animation = 14;
	face = "NW";
}
else if((angle >= 150) && (angle <= 210) && (face != "W"))
{
	Player.object_ptr->curr_animation = 6;
	face = "W";
}
else if((angle > 210) && (angle < 240) && (face != "SW"))
{
	Player.object_ptr->curr_animation = 12;
	face = "SW";
}
else if((angle >= 240) && (angle <= 300) && (face != "S"))
{
	Player.object_ptr->curr_animation = 4;
	face = "S";
}
else if((angle > 300) && (angle < 330) && (face != "SE"))
{
	Player.object_ptr->curr_animation = 10;
	face = "SE";
}
/////// ******* GAME LOGIC ******** /////////

Set_Anim_Speed_BOB(Player.object_ptr, 4); // Set default speed

	// DRAW SCENERY 
	for (index = SCENERY_LOW; index < SCENERY_HIGH; index++)
		{
		// get the object position
		x0 = Scenery[index].x;
		y0 = Scenery[index].y;

		// now translate to screen coords, could have done above, but clearer
		x0 = x0 - world_x;
		y0 = y0 - world_y;
	    
		// compute size
		width = Scenery[index].object_ptr->width;
		height = Scenery[index].object_ptr->height;

		// compute extents based on width,height
		x1 = x0 + width - 1;
		y1 = y0 + height - 1;

		// do clip trivial clip
		if ( (x0 >= WINDOW_WIDTH) || (x1 < 0) || (y0 >= WINDOW_HEIGHT) || (y1 < 0))
			continue; // don't need to render this one
		else
		{
		// render this object
				Scenery[index].object_ptr->x = x0;
				Scenery[index].object_ptr->y = y0;


				for(int x = Scenery[index].x + 5; x < Scenery[index].x + 20; x++)
					for(int y = Scenery[index].y + 5; y < (Scenery[index].y + 20); y++)
						world_ptrs[x][y] = Scenery[index].object_ptr;

				Draw_BOB16(Scenery[index].object_ptr, lpddsback);
		}
		   
		} // end for 

	// DRAW BUILDINGS
	if(level == 3)
	{
		for (index = 0; index < BUILDING_HIGH; index++)
		{
			// get the object position
			x0 = Buildings[index].x;
			y0 = Buildings[index].y;

			// now translate to screen coords, could have done above, but clearer
			x0 = x0 - world_x;
			y0 = y0 - world_y;
		    
			// compute size
			width = 841;
			height = 1177;

			// compute extents based on width,height
			x1 = x0 + width - 1;
			y1 = y0 + height - 1;

			// do clip trivial clip
			if ( (x0 >= WINDOW_WIDTH) || (x1 < 0) || (y0 >= WINDOW_HEIGHT) || (y1 < 0))
				continue; // don't need to render this one
			else
			{
			// render this object
				Buildings[index].object_ptr->x = x0;
				Buildings[index].object_ptr->y = y0;
				
				if(Buildings[index].object_ptr->curr_frame == 0)
				{
					for(int x = Buildings[index].x + 235; x < Buildings[index].x + 831; x++)
					{	for(int y = Buildings[index].y + 550; y < Buildings[index].y + 1167; y++)
						{
							if((x >= 0) && (y >= 0))
								world_ptrs[x][y] = Buildings[index].object_ptr;
						}
					}
				}
				else if(Buildings[index].object_ptr->curr_frame == 1)
				{
					for(int x = Buildings[index].x + 439; x < Buildings[index].x + 831; x++)
					{	for(int y = Buildings[index].y + 550; y < Buildings[index].y + 1167; y++)
						{
							if((x >= 0) && (y >= 0))
								world_ptrs[x][y] = Buildings[index].object_ptr;
						}
					}
				}
				else if(Buildings[index].object_ptr->curr_frame == 2)
				{
					for(int x = Buildings[index].x + 435; x < Buildings[index].x + 831; x++)
					{	for(int y = Buildings[index].y + 796; y < Buildings[index].y + 1167; y++)
						{
							if((x >= 0) && (y >= 0))
								world_ptrs[x][y] = Buildings[index].object_ptr;
						}
					}
				}
				else if(Buildings[index].object_ptr->curr_frame == 3)
				{
					for(int x = Buildings[index].x + 484; x < Buildings[index].x + 831; x++)
					{	for(int y = Buildings[index].y + 644; y < Buildings[index].y + 1167; y++)
						{
							if((x >= 0) && (y >= 0))
								world_ptrs[x][y] = Buildings[index].object_ptr;
						}
					}
				}
				else if(Buildings[index].object_ptr->curr_frame == 4)
				{
					for(int x = Buildings[index].x + 235; x < Buildings[index].x + 831; x++)
					{	for(int y = Buildings[index].y + 714; y < Buildings[index].y + 1167; y++)
						{
							if((x >= 0) && (y >= 0))
								world_ptrs[x][y] = Buildings[index].object_ptr;
						}
					}
				}
				else if(Buildings[index].object_ptr->curr_frame == 5)
				{
					for(int x = Buildings[index].x + 424; x < Buildings[index].x + 831; x++)
					{	for(int y = Buildings[index].y + 750; y < Buildings[index].y + 1167; y++)
						{
							if((x >= 0) && (y >= 0))
								world_ptrs[x][y] = Buildings[index].object_ptr;
						}
					}
				}
				else if(Buildings[index].object_ptr->curr_frame == 6)
				{
					for(int x = Buildings[index].x; x < Buildings[index].x + 392; x++)
					{	for(int y = Buildings[index].y + 550; y < Buildings[index].y + 1167; y++)
						{
							if((x >= 0) && (y >= 0))
								world_ptrs[x][y] = Buildings[index].object_ptr;
						}
					}
				}
				else if(Buildings[index].object_ptr->curr_frame == 7)
				{
					for(int x = Buildings[index].x; x < Buildings[index].x + 1066; x++)
					{	for(int y = Buildings[index].y + 550; y < Buildings[index].y + 1167; y++)
						{
							if((x >= 0) && (y >= 0))
								world_ptrs[x][y] = Buildings[index].object_ptr;
						}
					}
				}
				else if(Buildings[index].object_ptr->curr_frame == 8)
				{
					for(int x = Buildings[index].x; x < Buildings[index].x + 347; x++)
					{	for(int y = Buildings[index].y + 644; y < Buildings[index].y + 1167; y++)
						{
							if((x >= 0) && (y >= 0))
								world_ptrs[x][y] = Buildings[index].object_ptr;
						}
					}
				}
				else if(Buildings[index].object_ptr->curr_frame == 9)
				{
					for(int x = Buildings[index].x; x < Buildings[index].x + 396; x++)
					{	for(int y = Buildings[index].y + 796; y < Buildings[index].y + 1167; y++)
						{
							if((x >= 0) && (y >= 0))
								world_ptrs[x][y] = Buildings[index].object_ptr;
						}
					}
				}
				else if(Buildings[index].object_ptr->curr_frame == 10)
				{
					for(int x = Buildings[index].x; x < Buildings[index].x + 407; x++)
					{	for(int y = Buildings[index].y + 750; y < Buildings[index].y + 1167; y++)
						{
							if((x >= 0) && (y >= 0))
								world_ptrs[x][y] = Buildings[index].object_ptr;
						}
					}
				}
				else if(Buildings[index].object_ptr->curr_frame == 11)
				{
					for(int x = Buildings[index].x; x < Buildings[index].x + 596; x++)
					{	for(int y = Buildings[index].y + 714; y < Buildings[index].y + 1167; y++)
						{
							if((x >= 0) && (y >= 0))
								world_ptrs[x][y] = Buildings[index].object_ptr;
						}
					}
				}

				Draw_BOB16(Buildings[index].object_ptr, lpddsback);
			}
			   
		} // end for 
	}

// ADD PLAYER TO POINTER ARRAY //
	if(Player.object_ptr->curr_frame != 122)
	{
		for(int x = Player.x + 7; x < Player.x + 20; x++)
			for(int y = Player.y + 6; y < Player.y + 20; y++)
				world_ptrs[x][y] = Player.object_ptr;
	}

// DRAW FRIENDS TO ARRAY
	for (index = FRIEND_LOW; index < FRIEND_HIGH; index++)
    {
    // get the object position
    x0 = FriendPos[index].x;
    y0 = FriendPos[index].y;

    // now translate to screen coords, could have done above, but clearer
    x0 = x0 - world_x;
    y0 = y0 - world_y;
    
    // compute size
    width = enemysoldier.width;
	height = enemysoldier.height;

    // compute extents based on width,height
    x1 = x0 + width - 1;
    y1 = y0 + height - 1;

    // do clip trivial clip
    if ( (x0 >= WINDOW_WIDTH) || (x1 < 0) || (y0 >= WINDOW_HEIGHT) || (y1 < 0))
       continue; // don't need to render this one
    else
       {
			if(FriendPos[index].object_ptr->curr_frame != 122)
			{
				for(int x = FriendPos[index].x + 7; x < (FriendPos[index].x + 20); x++)
					for(int y = FriendPos[index].y + 6; y < (FriendPos[index].y + 20); y++)
						world_ptrs[x][y] = FriendPos[index].object_ptr;
			}
			else
			{
			   FriendPos[index].object_ptr->x = x0;
			   FriendPos[index].object_ptr->y = y0;
			   Draw_BOB16(FriendPos[index].object_ptr, lpddsback);
		    }
			
	   } // end else

    } // end for index
	
// DRAW ENEMIES TO ARRAY
	for (index = ENEMY_LOW; index < ENEMY_HIGH; index++)
    {
    // get the object position
    x0 = EnemyPos[index].x;
    y0 = EnemyPos[index].y;

    // now translate to screen coords, could have done above, but clearer
    x0 = x0 - world_x;
    y0 = y0 - world_y;
    
    // compute size
    width = enemysoldier.width;
	height = enemysoldier.height;

    // compute extents based on width,height
    x1 = x0 + width - 1;
    y1 = y0 + height - 1;

    // do clip trivial clip
    if ( (x0 >= WINDOW_WIDTH) || (x1 < 0) || (y0 >= WINDOW_HEIGHT) || (y1 < 0))
       continue; // don't need to render this one
    else
       {

		   if(EnemyPos[index].object_ptr->curr_frame != 122)
			{
				for(int x = EnemyPos[index].x + 7; x < (EnemyPos[index].x + 20); x++)
					for(int y = EnemyPos[index].y + 6; y < (EnemyPos[index].y + 20); y++)
						world_ptrs[x][y] = EnemyPos[index].object_ptr;
			}
		   else 
			{
			   EnemyPos[index].object_ptr->x = x0;
			   EnemyPos[index].object_ptr->y = y0;
			   Draw_BOB16(EnemyPos[index].object_ptr, lpddsback);
		    }
	   
	   } // end else

    } // end for index



// DRAW FRIENDS
	numFriends = 0;
	bool generateFriend = true;
	for (index = FRIEND_LOW; index < FRIEND_HIGH; index++)
    {
    // get the object position
    x0 = FriendPos[index].x;
    y0 = FriendPos[index].y;

    // now translate to screen coords, could have done above, but clearer
    x0 = x0 - world_x;
    y0 = y0 - world_y;
    
    // compute size
    width = enemysoldier.width;
	height = enemysoldier.height;

    // compute extents based on width,height
    x1 = x0 + width - 1;
    y1 = y0 + height - 1;

    // do clip trivial clip
    if ( (x0 >= WINDOW_WIDTH) || (x1 < 0) || (y0 >= WINDOW_HEIGHT) || (y1 < 0))
       continue; // don't need to render this one
    else
       {
       // render this object
			FriendPos[index].object_ptr->x = x0;
			FriendPos[index].object_ptr->y = y0;

			if(FriendPos[index].object_ptr->curr_frame == 120)
			{
				Draw_BOB16(FriendPos[index].object_ptr, lpddsback);       
				if(FriendPos[index].deathanim++ >= 2)
					FriendPos[index].object_ptr->curr_frame = 121;
			}
			else if(FriendPos[index].object_ptr->curr_frame == 121)
			{
				Draw_BOB16(FriendPos[index].object_ptr, lpddsback);       
				if(FriendPos[index].deathanim++ >= 4)
					FriendPos[index].object_ptr->curr_frame = 122;
			}
			else if(FriendPos[index].object_ptr->curr_frame == 122)
			{
				//Draw_BOB16(FriendPos[index].object_ptr, lpddsback);
			}
			else
			{
//				generateFriend = false;
				numFriends++;
				Soldier_Action(FriendPos[index]);
				Animate_BOB(FriendPos[index].object_ptr);

				if(FriendPos[index].object_ptr->curr_frame != 122)
					Draw_BOB16(FriendPos[index].object_ptr, lpddsback);
			}

	   
	   } // end else

    } // end for index

	//if(generateFriend == true)
	//{
	//	for(int x = 0; x < (random_range(1, 5)); x++)
	//		Add_Friend(random_range(world_x, (world_x + WINDOW_WIDTH - 32)), world_y + WINDOW_HEIGHT - 31);
	//}

// DRAW ENEMIES
	numEnemies = 0;
	bool generateEnemy = true;
	for (index = ENEMY_LOW; index < ENEMY_HIGH; index++)
    {
    // get the object position
    x0 = EnemyPos[index].x;
    y0 = EnemyPos[index].y;

    // now translate to screen coords, could have done above, but clearer
    x0 = x0 - world_x;
    y0 = y0 - world_y;
    
    // compute size
    width = enemysoldier.width;
	height = enemysoldier.height;

    // compute extents based on width,height
    x1 = x0 + width - 1;
    y1 = y0 + height - 1;

    // do clip trivial clip
    if ( (x0 >= WINDOW_WIDTH) || (x1 < 0) || (y0 >= WINDOW_HEIGHT) || (y1 < 0))
       continue; // don't need to render this one
    else
       {
       // render this object
			EnemyPos[index].object_ptr->x = x0;
			EnemyPos[index].object_ptr->y = y0;

			if(EnemyPos[index].object_ptr->curr_frame == 120)
			{
				Draw_BOB16(EnemyPos[index].object_ptr, lpddsback);       
				if(EnemyPos[index].deathanim++ >= 2)
					EnemyPos[index].object_ptr->curr_frame = 121;
			}
			else if(EnemyPos[index].object_ptr->curr_frame == 121)
			{
				Draw_BOB16(EnemyPos[index].object_ptr, lpddsback);       
				if(EnemyPos[index].deathanim++ >= 4)
				{
					EnemyPos[index].object_ptr->curr_frame = 122;
					if(((level == 2) || (level == 3)) && (endLevel == true))
					{
						if((enemycounter -= 1) < 0)
							enemycounter = 0;
					}
				}
			}
			else if(EnemyPos[index].object_ptr->curr_frame == 122)
			{
				//Draw_BOB16(EnemyPos[index].object_ptr, lpddsback);
			}
			else
			{
				//generateEnemy = false;
				numEnemies++;
				Soldier_Action(EnemyPos[index]);
				Animate_BOB(EnemyPos[index].object_ptr);

				if(EnemyPos[index].object_ptr->curr_frame != 122)
					Draw_BOB16(EnemyPos[index].object_ptr, lpddsback);
			} 
	   } // end else

    } // end for index

///////////////// MOVE PLAYER ////////////////////
if(Player.object_ptr->life <= 0)
{
	if(Player.object_ptr->curr_frame == 120)
	{
		Draw_BOB16(Player.object_ptr, lpddsback);       
		if(Player.deathanim++ >= 2)
			Player.object_ptr->curr_frame = 121;
	}
	else if(Player.object_ptr->curr_frame == 121)
	{
		Draw_BOB16(Player.object_ptr, lpddsback);       
		if(Player.deathanim++ >= 4)
			Player.object_ptr->curr_frame = 122;
	}

}
else
{
	if (mouse_state.rgbButtons[0])  ///////////////// ******************* IF SHOOTING ******************* ///////////////////////
	{
		Set_Anim_Speed_BOB(Player.object_ptr, 2);

		if ((keyboard_state[DIK_UP] && keyboard_state[DIK_RIGHT]) || (keyboard_state[DIK_W] && keyboard_state[DIK_D]))
		{
			moving = '1';

			if(face == "N")
			{
				if(Player.object_ptr->curr_animation != 20)
					Set_Animation_BOB(Player.object_ptr, 20); 
			}
			else if(face == "S")
			{
				if(Player.object_ptr->curr_animation != 22)
					Set_Animation_BOB(Player.object_ptr, 22); 
			}
			else if(face == "E")
			{
				if(Player.object_ptr->curr_animation != 21)
					Set_Animation_BOB(Player.object_ptr, 21); 
			}
			else if(face == "W")
			{
				if(Player.object_ptr->curr_animation != 23)
					Set_Animation_BOB(Player.object_ptr, 23); 
			}
			else if(face == "NE")
			{
				if(Player.object_ptr->curr_animation != 28)
					Set_Animation_BOB(Player.object_ptr, 28); 
			}
			else if(face == "SE")
			{
				if(Player.object_ptr->curr_animation != 29)
					Set_Animation_BOB(Player.object_ptr, 29); 
			}
			else if(face == "SW")
			{
				if(Player.object_ptr->curr_animation != 30)
					Set_Animation_BOB(Player.object_ptr, 30); 
			}
			else if(face == "NW")
			{
				if(Player.object_ptr->curr_animation != 31)
					Set_Animation_BOB(Player.object_ptr, 31); 
			}

			for(int x = (Player.x + 3); x < (Player.x + 24); x++)
			{
				if(world_ptrs[x][(Player.y-6) - 2] != NULL)
				{
					move = false;
					break;
				}
			}
			if(move == true)
			{
				if (world_y == WORLD_MAX_HEIGHT - WINDOW_HEIGHT)	// if camera cannot go up any more
				{
					if(Player.object_ptr->y <= (WINDOW_HEIGHT/2)-16)			// When character is back in the middle, just move the camera
						world_y -= 2;
				}
				else if ((world_y-=2) < 0)							// if camera is at the bottom
				world_y = 0;										// move character back toward center of screen
				if((Player.y -= 2) < 0)
					Player.y = 0;
			}
			move = true;
			for(int y = (Player.y - 6); y < (Player.y + 24); y++)
			{
				if(world_ptrs[(Player.x+29) + 2][y] != NULL)
				{
					move = false;
					break;
				}
			}

			if(move == true)
			{
				if (world_x == 0)
				{
					if(Player.object_ptr->x >= (WINDOW_WIDTH/2)-32)
						world_x += 2;
				}
				else if ((world_x+=2) >= (WORLD_MAX_WIDTH - WINDOW_WIDTH))
				world_x = (WORLD_MAX_WIDTH - WINDOW_WIDTH);

				if((Player.x += 2) > (WORLD_MAX_WIDTH - 32))
					Player.x = WORLD_MAX_WIDTH - 32;
			}
			Animate_BOB(Player.object_ptr);
		}
		else if ((keyboard_state[DIK_UP] && keyboard_state[DIK_LEFT]) || (keyboard_state[DIK_W] && keyboard_state[DIK_A]))
		{
			moving = '4';

			if(face == "N")
			{
				if(Player.object_ptr->curr_animation != 20)
					Set_Animation_BOB(Player.object_ptr, 20); 
			}
			else if(face == "S")
			{
				if(Player.object_ptr->curr_animation != 22)
					Set_Animation_BOB(Player.object_ptr, 22); 
			}
			else if(face == "E")
			{
				if(Player.object_ptr->curr_animation != 21)
					Set_Animation_BOB(Player.object_ptr, 21); 
			}
			else if(face == "W")
			{
				if(Player.object_ptr->curr_animation != 23)
					Set_Animation_BOB(Player.object_ptr, 23); 
			}
			else if(face == "NE")
			{
				if(Player.object_ptr->curr_animation != 28)
					Set_Animation_BOB(Player.object_ptr, 28); 
			}
			else if(face == "SE")
			{
				if(Player.object_ptr->curr_animation != 29)
					Set_Animation_BOB(Player.object_ptr, 29); 
			}
			else if(face == "SW")
			{
				if(Player.object_ptr->curr_animation != 30)
					Set_Animation_BOB(Player.object_ptr, 30); 
			}
			else if(face == "NW")
			{
				if(Player.object_ptr->curr_animation != 31)
					Set_Animation_BOB(Player.object_ptr, 31); 
			}


			for(int x = (Player.x + 3); x < (Player.x + 24); x++)
			{
				if(world_ptrs[x][(Player.y-6) - 2] != NULL)
				{
					move = false;
					break;
				}
			}
			if(move == true)
			{
				if (world_y == WORLD_MAX_HEIGHT - WINDOW_HEIGHT)	// if camera cannot go up any more
				{
					if(Player.object_ptr->y <= (WINDOW_HEIGHT/2)-16)			// When character is back in the middle, just move the camera
						world_y -= 2;
				}
				else if ((world_y-=2) < 0)							// if camera is at the bottom
				world_y = 0;										// move character back toward center of screen
				if((Player.y -= 2) < 0)
					Player.y = 0;
			}
			move = true;
			for(int y = (Player.y - 6); y < (Player.y + 24); y++)
			{
				if(world_ptrs[(Player.x -3) - 2][y] != NULL)
				{
					move = false;
					break;
				}
			}
			if(move == true)
			{
				if (world_x == (WORLD_MAX_WIDTH - WINDOW_WIDTH))
				{
					if(Player.object_ptr->x <= (WINDOW_WIDTH/2)-32)
						world_x -= 2;
				}
				else if ((world_x-=2) < 0)
				world_x = 0;
				   
				if((Player.x -= 2) < 0)
					Player.x = 0;
			}
			Animate_BOB(Player.object_ptr);
		}
		else if ((keyboard_state[DIK_DOWN] && keyboard_state[DIK_RIGHT]) || (keyboard_state[DIK_S] && keyboard_state[DIK_D]))
		{
			moving = '2';

			if(face == "N")
			{
				if(Player.object_ptr->curr_animation != 20)
					Set_Animation_BOB(Player.object_ptr, 20); 
			}
			else if(face == "S")
			{
				if(Player.object_ptr->curr_animation != 22)
					Set_Animation_BOB(Player.object_ptr, 22); 
			}
			else if(face == "E")
			{
				if(Player.object_ptr->curr_animation != 21)
					Set_Animation_BOB(Player.object_ptr, 21); 
			}
			else if(face == "W")
			{
				if(Player.object_ptr->curr_animation != 23)
					Set_Animation_BOB(Player.object_ptr, 23); 
			}
			else if(face == "NE")
			{
				if(Player.object_ptr->curr_animation != 28)
					Set_Animation_BOB(Player.object_ptr, 28); 
			}
			else if(face == "SE")
			{
				if(Player.object_ptr->curr_animation != 29)
					Set_Animation_BOB(Player.object_ptr, 29); 
			}
			else if(face == "SW")
			{
				if(Player.object_ptr->curr_animation != 30)
					Set_Animation_BOB(Player.object_ptr, 30); 
			}
			else if(face == "NW")
			{
				if(Player.object_ptr->curr_animation != 31)
					Set_Animation_BOB(Player.object_ptr, 31); 
			}

			for(int x = Player.x + 3; x < (Player.x + 24); x++)
			{
				if(world_ptrs[x][(Player.y+28) + 2] != NULL)
				{
					move = false;
					break;
				}
			}
			if(move == true)
			{
				if (world_y == 0)									// if camera cannot go down any more
				{
					if(Player.object_ptr->y >= (WINDOW_HEIGHT/2)-16)
						world_y += 2;
				}
				else if ((world_y+=2) >= (WORLD_MAX_HEIGHT - WINDOW_HEIGHT))
				world_y = (WORLD_MAX_HEIGHT - WINDOW_HEIGHT);

				if((Player.y += 2) >= WORLD_MAX_HEIGHT - 32)
					Player.y = WORLD_MAX_HEIGHT - 32;
			}
			  
			move = true;
			for(int y = (Player.y - 6); y < (Player.y + 24); y++)
			{
				if(world_ptrs[(Player.x+29) + 2][y] != NULL)
				{
					move = false;
					break;
				}
			}
			if(move == true)
			{

				if (world_x == 0)
				{
					if(Player.object_ptr->x >= (WINDOW_WIDTH/2)-32)
						world_x += 2;
				}
				else if ((world_x+=2) >= (WORLD_MAX_WIDTH - WINDOW_WIDTH))
				world_x = (WORLD_MAX_WIDTH - WINDOW_WIDTH);
				   
				if((Player.x += 2) >= WORLD_MAX_WIDTH - 32)
					Player.x = WORLD_MAX_WIDTH - 32;
			}
			Animate_BOB(Player.object_ptr);
		}
		else if ((keyboard_state[DIK_DOWN] && keyboard_state[DIK_LEFT]) || (keyboard_state[DIK_S] && keyboard_state[DIK_A]))
		{
			moving = '3';

			if(face == "N")
			{
				if(Player.object_ptr->curr_animation != 20)
					Set_Animation_BOB(Player.object_ptr, 20); 
			}
			else if(face == "S")
			{
				if(Player.object_ptr->curr_animation != 22)
					Set_Animation_BOB(Player.object_ptr, 22); 
			}
			else if(face == "E")
			{
				if(Player.object_ptr->curr_animation != 21)
					Set_Animation_BOB(Player.object_ptr, 21); 
			}
			else if(face == "W")
			{
				if(Player.object_ptr->curr_animation != 23)
					Set_Animation_BOB(Player.object_ptr, 23); 
			}
			else if(face == "NE")
			{
				if(Player.object_ptr->curr_animation != 28)
					Set_Animation_BOB(Player.object_ptr, 28); 
			}
			else if(face == "SE")
			{
				if(Player.object_ptr->curr_animation != 29)
					Set_Animation_BOB(Player.object_ptr, 29); 
			}
			else if(face == "SW")
			{
				if(Player.object_ptr->curr_animation != 30)
					Set_Animation_BOB(Player.object_ptr, 30); 
			}
			else if(face == "NW")
			{
				if(Player.object_ptr->curr_animation != 31)
					Set_Animation_BOB(Player.object_ptr, 31); 
			}

			for(int x = Player.x + 3; x < (Player.x + 24); x++)
			{
				if(world_ptrs[x][(Player.y+28) + 2] != NULL)
				{
					move = false;
					break;
				}
			}
			if(move == true)
			{
				if (world_y == 0)									// if camera cannot go down any more
				{
					if(Player.object_ptr->y >= (WINDOW_HEIGHT/2)-16)
						world_y += 2;
				}
				else if ((world_y+=2) >= (WORLD_MAX_HEIGHT - WINDOW_HEIGHT))
					world_y = (WORLD_MAX_HEIGHT - WINDOW_HEIGHT);

				if((Player.y += 2) >= WORLD_MAX_HEIGHT - 32)
					Player.y = WORLD_MAX_HEIGHT - 32;
			}
			move = true;
			for(int y = (Player.y - 6); y < (Player.y + 24); y++)
			{
				if(world_ptrs[(Player.x -3) - 2][y] != NULL)
				{
					move = false;
					break;
				}
			}
			if(move == true)
			{
				if (world_x == (WORLD_MAX_WIDTH - WINDOW_WIDTH))
				{
					if(Player.object_ptr->x <= (WINDOW_WIDTH/2)-32)
						world_x -= 2;
				}
				else if ((world_x-=2) < 0)
				world_x = 0;

				if((Player.x -= 2) < 0)
					Player.x = 0;
			}
			Animate_BOB(Player.object_ptr);
		}
		else if (keyboard_state[DIK_RIGHT] || keyboard_state[DIK_D])
		{
			moving = 'R';
			if(face == "N")
			{
				if(Player.object_ptr->curr_animation != 20)
					Set_Animation_BOB(Player.object_ptr, 20); 
			}
			else if(face == "S")
			{
				if(Player.object_ptr->curr_animation != 22)
					Set_Animation_BOB(Player.object_ptr, 22); 
			}
			else if(face == "E")
			{
				if(Player.object_ptr->curr_animation != 21)
					Set_Animation_BOB(Player.object_ptr, 21); 
			}
			else if(face == "W")
			{
				if(Player.object_ptr->curr_animation != 23)
					Set_Animation_BOB(Player.object_ptr, 23); 
			}
			else if(face == "NE")
			{
				if(Player.object_ptr->curr_animation != 28)
					Set_Animation_BOB(Player.object_ptr, 28); 
			}
			else if(face == "SE")
			{
				if(Player.object_ptr->curr_animation != 29)
					Set_Animation_BOB(Player.object_ptr, 29); 
			}
			else if(face == "SW")
			{
				if(Player.object_ptr->curr_animation != 30)
					Set_Animation_BOB(Player.object_ptr, 30); 
			}
			else if(face == "NW")
			{
				if(Player.object_ptr->curr_animation != 31)
					Set_Animation_BOB(Player.object_ptr, 31); 
			}

			for(int y = (Player.y - 6); y < (Player.y + 24); y++)
			{
				if(world_ptrs[(Player.x+29) + 4][y] != NULL)
				{
					move = false;
					break;
				}
			}
			if(move == true)
			{
				if (world_x == 0)
				{
					if(Player.object_ptr->x >= (WINDOW_WIDTH/2)-32)
						world_x += 4;
				}
				else if ((world_x+=4) >= (WORLD_MAX_WIDTH - WINDOW_WIDTH))
				world_x = (WORLD_MAX_WIDTH - WINDOW_WIDTH);
				
				if((Player.x += 4) >= WORLD_MAX_WIDTH - 32)
					Player.x = WORLD_MAX_WIDTH - 32;
			}
			Animate_BOB(Player.object_ptr);
		} // end if
		else if (keyboard_state[DIK_LEFT] || keyboard_state[DIK_A])
		{
			moving = 'L';
			if(face == "N")
			{
				if(Player.object_ptr->curr_animation != 20)
					Set_Animation_BOB(Player.object_ptr, 20); 
			}
			else if(face == "S")
			{
				if(Player.object_ptr->curr_animation != 22)
					Set_Animation_BOB(Player.object_ptr, 22); 
			}
			else if(face == "E")
			{
				if(Player.object_ptr->curr_animation != 21)
					Set_Animation_BOB(Player.object_ptr, 21); 
			}
			else if(face == "W")
			{
				if(Player.object_ptr->curr_animation != 23)
					Set_Animation_BOB(Player.object_ptr, 23); 
			}
			else if(face == "NE")
			{
				if(Player.object_ptr->curr_animation != 28)
					Set_Animation_BOB(Player.object_ptr, 28); 
			}
			else if(face == "SE")
			{
				if(Player.object_ptr->curr_animation != 29)
					Set_Animation_BOB(Player.object_ptr, 29); 
			}
			else if(face == "SW")
			{
				if(Player.object_ptr->curr_animation != 30)
					Set_Animation_BOB(Player.object_ptr, 30); 
			}
			else if(face == "NW")
			{
				if(Player.object_ptr->curr_animation != 31)
					Set_Animation_BOB(Player.object_ptr, 31); 
			}
		    
			for(int y = (Player.y - 6); y < (Player.y + 24); y++)
			{
				if(world_ptrs[(Player.x -3) - 4][y] != NULL)
				{
					move = false;
					break;
				}
			}

			if(move == true)
			{
				if (world_x == (WORLD_MAX_WIDTH - WINDOW_WIDTH))
				{
					if(Player.object_ptr->x <= (WINDOW_WIDTH/2)-32)
						world_x -= 4;
				}
				else if ((world_x-=4) < 0)
					world_x = 0;

				if((Player.x -= 4) < 0)
					Player.x = 0;
			}
			Animate_BOB(Player.object_ptr);
		} // end if
		else if (keyboard_state[DIK_UP] || keyboard_state[DIK_W])
		{
			moving = 'U';

			if(face == "N")
			{
				if(Player.object_ptr->curr_animation != 20)
					Set_Animation_BOB(Player.object_ptr, 20); 
			}
			else if(face == "S")
			{
				if(Player.object_ptr->curr_animation != 22)
					Set_Animation_BOB(Player.object_ptr, 22); 
			}
			else if(face == "E")
			{
				if(Player.object_ptr->curr_animation != 21)
					Set_Animation_BOB(Player.object_ptr, 21); 
			}
			else if(face == "W")
			{
				if(Player.object_ptr->curr_animation != 23)
					Set_Animation_BOB(Player.object_ptr, 23); 
			}
			else if(face == "NE")
			{
				if(Player.object_ptr->curr_animation != 28)
					Set_Animation_BOB(Player.object_ptr, 28); 
			}
			else if(face == "SE")
			{
				if(Player.object_ptr->curr_animation != 29)
					Set_Animation_BOB(Player.object_ptr, 29); 
			}
			else if(face == "SW")
			{
				if(Player.object_ptr->curr_animation != 30)
					Set_Animation_BOB(Player.object_ptr, 30); 
			}
			else if(face == "NW")
			{
				if(Player.object_ptr->curr_animation != 31)
					Set_Animation_BOB(Player.object_ptr, 31); 
			}

			for(int x = (Player.x + 3); x < (Player.x + 24); x++)
			{
				if(world_ptrs[x][(Player.y-6) - 4] != NULL)
				{
					move = false;
					break;
				}
			}

			if(move == true)
			{
				if (world_y == WORLD_MAX_HEIGHT - WINDOW_HEIGHT)	// if camera cannot go up any more
				{
					if(Player.object_ptr->y <= (WINDOW_HEIGHT/2)-16)			// When character is back in the middle, just move the camera
						world_y -= 4;		
				}
				else if ((world_y-=4) < 0)							// if camera is at the bottom
				world_y = 0;										// move character back toward center of screen

				if((Player.y -= 4) < 0)								// move character on the screen
					Player.y = 0;
			}
			Animate_BOB(Player.object_ptr);
		} // end if
		else if (keyboard_state[DIK_DOWN] || keyboard_state[DIK_S])
		{
			moving = 'D';

			if(face == "N")
			{
				if(Player.object_ptr->curr_animation != 20)
					Set_Animation_BOB(Player.object_ptr, 20); 
			}
			else if(face == "S")
			{
				if(Player.object_ptr->curr_animation != 22)
					Set_Animation_BOB(Player.object_ptr, 22); 
			}
			else if(face == "E")
			{
				if(Player.object_ptr->curr_animation != 21)
					Set_Animation_BOB(Player.object_ptr, 21); 
			}
			else if(face == "W")
			{
				if(Player.object_ptr->curr_animation != 23)
					Set_Animation_BOB(Player.object_ptr, 23); 
			}
			else if(face == "NE")
			{
				if(Player.object_ptr->curr_animation != 28)
					Set_Animation_BOB(Player.object_ptr, 28); 
			}
			else if(face == "SE")
			{
				if(Player.object_ptr->curr_animation != 29)
					Set_Animation_BOB(Player.object_ptr, 29); 
			}
			else if(face == "SW")
			{
				if(Player.object_ptr->curr_animation != 30)
					Set_Animation_BOB(Player.object_ptr, 30); 
			}
			else if(face == "NW")
			{
				if(Player.object_ptr->curr_animation != 31)
					Set_Animation_BOB(Player.object_ptr, 31); 
			}


			for(int x = Player.x + 3; x < (Player.x + 24); x++)
			{
				if(world_ptrs[x][(Player.y+28) + 4] != NULL)
				{
					move = false;
					break;
				}
			}
			
			if(move == true)
			{
				if (world_y == 0)									// if camera cannot go down any more
				{
					if(Player.object_ptr->y >= (WINDOW_HEIGHT/2)-16)
						world_y += 4;	
				}
				else if ((world_y+=4) >= (WORLD_MAX_HEIGHT - WINDOW_HEIGHT))
				world_y = (WORLD_MAX_HEIGHT - WINDOW_HEIGHT);

				if((Player.y += 4) >= WORLD_MAX_HEIGHT - 32)
					Player.y = WORLD_MAX_HEIGHT - 32;
			}
			Animate_BOB(Player.object_ptr);
		} // end if
		else
		{
			if(Player.object_ptr->curr_animation != 16 || 17 || 18 || 19 || 24 || 25 || 26 || 27)
			{
				if(Player.object_ptr->curr_animation <= 1 || Player.object_ptr->curr_animation == 20)
					Set_Animation_BOB(Player.object_ptr, 16);
				else if(Player.object_ptr->curr_animation <= 3 || Player.object_ptr->curr_animation == 21)
					Set_Animation_BOB(Player.object_ptr, 17);
				else if(Player.object_ptr->curr_animation <= 5 || Player.object_ptr->curr_animation == 22)
					Set_Animation_BOB(Player.object_ptr, 18);
				else if(Player.object_ptr->curr_animation <= 7 || Player.object_ptr->curr_animation == 23)
					Set_Animation_BOB(Player.object_ptr, 19);
				else if(Player.object_ptr->curr_animation <= 9 || Player.object_ptr->curr_animation == 28)
					Set_Animation_BOB(Player.object_ptr, 24);
				else if(Player.object_ptr->curr_animation <= 11 || Player.object_ptr->curr_animation == 29)
					Set_Animation_BOB(Player.object_ptr, 25);
				else if(Player.object_ptr->curr_animation <= 13 || Player.object_ptr->curr_animation == 30)
					Set_Animation_BOB(Player.object_ptr, 26);
				else if(Player.object_ptr->curr_animation <= 15 || Player.object_ptr->curr_animation == 31)
					Set_Animation_BOB(Player.object_ptr, 27);
			}
			Set_Anim_Speed_BOB(Player.object_ptr, 2);
			Animate_BOB(Player.object_ptr);	
		}
		
		if(play_gunshot == 2)
		{	
			DSound_Play(gunshot);
			play_gunshot = 0;		
			if(face == "N")
				Shot_Line(Player.x + 16, Player.y + 1, mouse_x, mouse_y, 1);
			if(face == "E")
				Shot_Line(Player.x + 29, Player.y + 16, mouse_x, mouse_y, 1);
			if(face == "S")
				Shot_Line(Player.x + 16, Player.y + 29, mouse_x, mouse_y, 1);
			if(face == "W")
				Shot_Line(Player.x + 2, Player.y + 16, mouse_x, mouse_y, 1);
			if(face == "NE")
				Shot_Line(Player.x + 29, Player.y + 2, mouse_x, mouse_y, 1);
			if(face == "SE")
				Shot_Line(Player.x + 29, Player.y + 29, mouse_x, mouse_y, 1);
			if(face == "SW")
				Shot_Line(Player.x + 2, Player.y + 29, mouse_x, mouse_y, 1);
			if(face == "NW")
				Shot_Line(Player.x + 2, Player.y + 2, mouse_x, mouse_y, 1);
		}
		else
			play_gunshot++;

	} ///////////////////// ************* END SHOOTING *************** /////////////////////////////
	else if ((keyboard_state[DIK_UP] && keyboard_state[DIK_RIGHT]) || (keyboard_state[DIK_W] && keyboard_state[DIK_D]))
	{
		moving = '1';

		if(face == "N")
		{
			if(Player.object_ptr->curr_animation != 0)
				Set_Animation_BOB(Player.object_ptr, 0); 
		}
		else if(face == "S")
		{
			if(Player.object_ptr->curr_animation != 5)
				Set_Animation_BOB(Player.object_ptr, 5); 
		}
		else if(face == "E")
		{
			if(Player.object_ptr->curr_animation != 3)
				Set_Animation_BOB(Player.object_ptr, 3); 
		}
		else if(face == "W")
		{
			if(Player.object_ptr->curr_animation != 6)
				Set_Animation_BOB(Player.object_ptr, 6); 
		}
		else if(face == "NE")
		{
			if(Player.object_ptr->curr_animation != 9)
				Set_Animation_BOB(Player.object_ptr, 9); 
		}
		else if(face == "SE")
		{
			if(Player.object_ptr->curr_animation != 10)
				Set_Animation_BOB(Player.object_ptr, 10); 
		}
		else if(face == "SW")
		{
			if(Player.object_ptr->curr_animation != 13)
				Set_Animation_BOB(Player.object_ptr, 13); 
		}
		else if(face == "NW")
		{
			if(Player.object_ptr->curr_animation != 15)
				Set_Animation_BOB(Player.object_ptr, 15); 
		}

		for(int x = (Player.x + 3); x < (Player.x + 24); x++)
		{
			if(world_ptrs[x][(Player.y-6) - 2] != NULL)
			{
				move = false;
				break;
			}
		}
		if(move == true)
		{
			if (world_y == WORLD_MAX_HEIGHT - WINDOW_HEIGHT)	// if camera cannot go up any more
			{
				if(Player.object_ptr->y <= (WINDOW_HEIGHT/2)-16)			// When character is back in the middle, just move the camera
					world_y -= 2;
			}
			else if ((world_y-=2) < 0)							// if camera is at the bottom
				world_y = 0;									// move character back toward center of screen
			
			if((Player.y -= 2) < 0)
				Player.y = 0;
		}
		move = true;
		for(int y = (Player.y - 6); y < (Player.y + 24); y++)
		{
			if(world_ptrs[(Player.x+29) + 2][y] != NULL)
			{
				move = false;
				break;
			}
		}

		if(move == true)
		{
			if (world_x == 0)
			{
				if(Player.object_ptr->x >= (WINDOW_WIDTH/2)-32)
					world_x += 2;
			}
			else if ((world_x+=2) >= (WORLD_MAX_WIDTH - WINDOW_WIDTH))
				world_x = (WORLD_MAX_WIDTH - WINDOW_WIDTH);

			if((Player.x += 2) > (WORLD_MAX_WIDTH - 32))
				Player.x = WORLD_MAX_WIDTH - 32;
		}
		Animate_BOB(Player.object_ptr);
	}
	else if ((keyboard_state[DIK_UP] && keyboard_state[DIK_LEFT]) || (keyboard_state[DIK_W] && keyboard_state[DIK_A]))
	{
		moving = '4';

		if(face == "N")
		{
			if(Player.object_ptr->curr_animation != 0)
				Set_Animation_BOB(Player.object_ptr, 0); 
		}
		else if(face == "S")
		{
			if(Player.object_ptr->curr_animation != 5)
				Set_Animation_BOB(Player.object_ptr, 5); 
		}
		else if(face == "E")
		{
			if(Player.object_ptr->curr_animation != 3)
				Set_Animation_BOB(Player.object_ptr, 3); 
		}
		else if(face == "W")
		{
			if(Player.object_ptr->curr_animation != 6)
				Set_Animation_BOB(Player.object_ptr, 6); 
		}
		else if(face == "NE")
		{
			if(Player.object_ptr->curr_animation != 9)
				Set_Animation_BOB(Player.object_ptr, 9); 
		}
		else if(face == "SE")
		{
			if(Player.object_ptr->curr_animation != 11)
				Set_Animation_BOB(Player.object_ptr, 11); 
		}
		else if(face == "SW")
		{
			if(Player.object_ptr->curr_animation != 13)
				Set_Animation_BOB(Player.object_ptr, 13); 
		}
		else if(face == "NW")
		{
			if(Player.object_ptr->curr_animation != 14)
				Set_Animation_BOB(Player.object_ptr, 14); 
		}


		for(int x = (Player.x + 3); x < (Player.x + 24); x++)
		{
			if(world_ptrs[x][(Player.y-6) - 2] != NULL)
			{
				move = false;
				break;
			}
		}
		if(move == true)
		{
			if (world_y == WORLD_MAX_HEIGHT - WINDOW_HEIGHT)	// if camera cannot go up any more
			{
				if(Player.object_ptr->y <= (WINDOW_HEIGHT/2)-16)			// When character is back in the middle, just move the camera
					world_y -= 2;
			}
			else if ((world_y-=2) < 0)							// if camera is at the bottom
			world_y = 0;										// move character back toward center of screen
			if((Player.y -= 2) < 0)
				Player.y = 0;
		}
		move = true;
		for(int y = (Player.y - 6); y < (Player.y + 24); y++)
		{
			if(world_ptrs[(Player.x -3) - 2][y] != NULL)
			{
				move = false;
				break;
			}
		}
		if(move == true)
		{
			if (world_x == (WORLD_MAX_WIDTH - WINDOW_WIDTH))
			{
				if(Player.object_ptr->x <= (WINDOW_WIDTH/2)-32)
					world_x -= 2;
			}
			else if ((world_x-=2) < 0)
			world_x = 0;
			   
			if((Player.x -= 2) < 0)
				Player.x = 0;
		}
		Animate_BOB(Player.object_ptr);
	}
	else if ((keyboard_state[DIK_DOWN] && keyboard_state[DIK_RIGHT]) || (keyboard_state[DIK_S] && keyboard_state[DIK_D]))
	{
		moving = '2';

		if(face == "N")
		{
			if(Player.object_ptr->curr_animation != 1)
				Set_Animation_BOB(Player.object_ptr, 1); 
		}
		else if(face == "S")
		{
			if(Player.object_ptr->curr_animation != 4)
				Set_Animation_BOB(Player.object_ptr, 4); 
		}
		else if(face == "E")
		{
			if(Player.object_ptr->curr_animation != 2)
				Set_Animation_BOB(Player.object_ptr, 2); 
		}
		else if(face == "W")
		{
			if(Player.object_ptr->curr_animation != 7)
				Set_Animation_BOB(Player.object_ptr, 7); 
		}
		else if(face == "NE")
		{
			if(Player.object_ptr->curr_animation != 9)
				Set_Animation_BOB(Player.object_ptr, 9); 
		}
		else if(face == "SE")
		{
			if(Player.object_ptr->curr_animation != 10)
				Set_Animation_BOB(Player.object_ptr, 10); 
		}
		else if(face == "SW")
		{
			if(Player.object_ptr->curr_animation != 13)
				Set_Animation_BOB(Player.object_ptr, 13); 
		}
		else if(face == "NW")
		{
			if(Player.object_ptr->curr_animation != 15)
				Set_Animation_BOB(Player.object_ptr, 15); 
		}

		for(int x = Player.x + 3; x < (Player.x + 24); x++)
		{
			if(world_ptrs[x][(Player.y+28) + 2] != NULL)
			{
				move = false;
				break;
			}
		}
		if(move == true)
		{
			if (world_y == 0)									// if camera cannot go down any more
			{
				if(Player.object_ptr->y >= (WINDOW_HEIGHT/2)-16)
					world_y += 2;
			}
			else if ((world_y+=2) >= (WORLD_MAX_HEIGHT - WINDOW_HEIGHT))
			world_y = (WORLD_MAX_HEIGHT - WINDOW_HEIGHT);

			if((Player.y += 2) >= WORLD_MAX_HEIGHT - 32)
				Player.y = WORLD_MAX_HEIGHT - 32;
		}
		  
		move = true;
		for(int y = (Player.y - 6); y < (Player.y + 24); y++)
		{
			if(world_ptrs[(Player.x+29) + 2][y] != NULL)
			{
				move = false;
				break;
			}
		}
		if(move == true)
		{

			if (world_x == 0)
			{
				if(Player.object_ptr->x >= (WINDOW_WIDTH/2)-32)
					world_x += 2;
			}
			else if ((world_x+=2) >= (WORLD_MAX_WIDTH - WINDOW_WIDTH))
			world_x = (WORLD_MAX_WIDTH - WINDOW_WIDTH);
			   
			if((Player.x += 2) >= WORLD_MAX_WIDTH - 32)
				Player.x = WORLD_MAX_WIDTH - 32;
		}
		Animate_BOB(Player.object_ptr);
	}
	else if ((keyboard_state[DIK_DOWN] && keyboard_state[DIK_LEFT]) || (keyboard_state[DIK_S] && keyboard_state[DIK_A]))
	{
		moving = '3';

		if(face == "N")
		{
			if(Player.object_ptr->curr_animation != 1)
				Set_Animation_BOB(Player.object_ptr, 1); 
		}
		else if(face == "S")
		{
			if(Player.object_ptr->curr_animation != 4)
				Set_Animation_BOB(Player.object_ptr, 4); 
		}
		else if(face == "E")
		{
			if(Player.object_ptr->curr_animation != 3)
				Set_Animation_BOB(Player.object_ptr, 3); 
		}
		else if(face == "W")
		{
			if(Player.object_ptr->curr_animation != 6)
				Set_Animation_BOB(Player.object_ptr, 6); 
		}
		else if(face == "NE")
		{
			if(Player.object_ptr->curr_animation != 9)
				Set_Animation_BOB(Player.object_ptr, 9); 
		}
		else if(face == "SE")
		{
			if(Player.object_ptr->curr_animation != 11)
				Set_Animation_BOB(Player.object_ptr, 11); 
		}
		else if(face == "SW")
		{
			if(Player.object_ptr->curr_animation != 13)
				Set_Animation_BOB(Player.object_ptr, 13); 
		}
		else if(face == "NW")
		{
			if(Player.object_ptr->curr_animation != 14)
				Set_Animation_BOB(Player.object_ptr, 14); 
		}

		for(int x = Player.x + 3; x < (Player.x + 24); x++)
		{
			if(world_ptrs[x][(Player.y+28) + 2] != NULL)
			{
				move = false;
				break;
			}
		}
		if(move == true)
		{
			if (world_y == 0)									// if camera cannot go down any more
			{
				if(Player.object_ptr->y >= (WINDOW_HEIGHT/2)-16)
					world_y += 2;
			}
			else if ((world_y+=2) >= (WORLD_MAX_HEIGHT - WINDOW_HEIGHT))
				world_y = (WORLD_MAX_HEIGHT - WINDOW_HEIGHT);

			if((Player.y += 2) >= WORLD_MAX_HEIGHT - 32)
				Player.y = WORLD_MAX_HEIGHT - 32;
		}
		move = true;
		for(int y = (Player.y - 6); y < (Player.y + 24); y++)
		{
			if(world_ptrs[(Player.x -3) - 2][y] != NULL)
			{
				move = false;
				break;
			}
		}
		if(move == true)
		{
			if (world_x == (WORLD_MAX_WIDTH - WINDOW_WIDTH))
			{
				if(Player.object_ptr->x <= (WINDOW_WIDTH/2)-32)
					world_x -= 2;
			}
			else if ((world_x-=2) < 0)
			world_x = 0;

			if((Player.x -= 2) < 0)
				Player.x = 0;
		}
		Animate_BOB(Player.object_ptr);
	}
	else if (keyboard_state[DIK_RIGHT] || keyboard_state[DIK_D])
	{
		moving = 'R';
		if(face == "E")
		{
			if(Player.object_ptr->curr_animation != 2)
				Set_Animation_BOB(Player.object_ptr, 2); 
		}
		else if(face == "W")
		{
			if(Player.object_ptr->curr_animation != 7)
				Set_Animation_BOB(Player.object_ptr, 7);
		}
		else if(face == "N")
		{
			if(Player.object_ptr->curr_animation != 1)
				Set_Animation_BOB(Player.object_ptr, 1);
		}
		else if(face == "S")
		{
			if(Player.object_ptr->curr_animation != 4)
				Set_Animation_BOB(Player.object_ptr, 4);
		}
		else if(face == "NE")
		{
			if(Player.object_ptr->curr_animation != 9)
				Set_Animation_BOB(Player.object_ptr, 9);
		}
		else if(face == "SE")
		{
			if(Player.object_ptr->curr_animation != 10)
				Set_Animation_BOB(Player.object_ptr, 10);
		}
		else if(face == "SW")
		{
			if(Player.object_ptr->curr_animation != 12)
				Set_Animation_BOB(Player.object_ptr, 12);
		}
		else if(face == "NW")
		{
			if(Player.object_ptr->curr_animation != 15)
				Set_Animation_BOB(Player.object_ptr, 15);
		}

		for(int y = (Player.y - 6); y < (Player.y + 24); y++)
		{
			if(world_ptrs[(Player.x+29) + 4][y] != NULL)
			{
				move = false;
				break;
			}
		}
		if(move == true)
		{
			if (world_x == 0)
			{
				if(Player.object_ptr->x >= (WINDOW_WIDTH/2)-32)
					world_x += 4;
			}
			else if ((world_x+=4) >= (WORLD_MAX_WIDTH - WINDOW_WIDTH))
			world_x = (WORLD_MAX_WIDTH - WINDOW_WIDTH);
			
			if((Player.x += 4) >= WORLD_MAX_WIDTH - 32)
				Player.x = WORLD_MAX_WIDTH - 32;
		}
		Animate_BOB(Player.object_ptr);
	} // end if
	else if (keyboard_state[DIK_LEFT] || keyboard_state[DIK_A])
	{
		moving = 'L';
		if(face == "W")
		{
			if(Player.object_ptr->curr_animation != 6)
				Set_Animation_BOB(Player.object_ptr, 6); 
		}
		else if(face == "E")
		{
			if(Player.object_ptr->curr_animation != 3)
				Set_Animation_BOB(Player.object_ptr, 3);
		}
		else if(face == "N")
		{
			if(Player.object_ptr->curr_animation != 0)
				Set_Animation_BOB(Player.object_ptr, 0);
		}
		else if(face == "S")
		{
			if(Player.object_ptr->curr_animation != 5)
				Set_Animation_BOB(Player.object_ptr, 5);
		}
		else if(face == "NE")
		{
			if(Player.object_ptr->curr_animation != 8)
				Set_Animation_BOB(Player.object_ptr, 8);
		}
		else if(face == "SE")
		{
			if(Player.object_ptr->curr_animation != 11)
				Set_Animation_BOB(Player.object_ptr, 11);
		}
		else if(face == "SW")
		{
			if(Player.object_ptr->curr_animation != 13)
				Set_Animation_BOB(Player.object_ptr, 13);
		}
		else if(face == "NW")
		{
			if(Player.object_ptr->curr_animation != 14)
				Set_Animation_BOB(Player.object_ptr, 14);
		}
	    
		for(int y = (Player.y - 6); y < (Player.y + 24); y++)
		{
			if(world_ptrs[(Player.x -3) - 4][y] != NULL)
			{
				move = false;
				break;
			}
		}

		if(move == true)
		{
			if (world_x == (WORLD_MAX_WIDTH - WINDOW_WIDTH))
			{
				if(Player.object_ptr->x <= (WINDOW_WIDTH/2)-32)
					world_x -= 4;
			}
			else if ((world_x-=4) < 0)
				world_x = 0;

			if((Player.x -= 4) < 0)
				Player.x = 0;
		}
		Animate_BOB(Player.object_ptr);
	} // end if
	else if (keyboard_state[DIK_UP] || keyboard_state[DIK_W])
	{
		moving = 'U';

		if(face == "N")
		{
			if(Player.object_ptr->curr_animation != 0)
				Set_Animation_BOB(Player.object_ptr, 0); 
		}
		else if(face == "S")
		{
			if(Player.object_ptr->curr_animation != 5)
				Set_Animation_BOB(Player.object_ptr, 5);
		}
		else if(face == "E")
		{
			if(Player.object_ptr->curr_animation != 3)
				Set_Animation_BOB(Player.object_ptr, 3);
		}
		else if(face == "W")
		{
			if(Player.object_ptr->curr_animation != 7)
				Set_Animation_BOB(Player.object_ptr, 7);
		}
		else if(face == "NE")
		{
			if(Player.object_ptr->curr_animation != 8)
				Set_Animation_BOB(Player.object_ptr, 8);
		}
		else if(face == "SE")
		{
			if(Player.object_ptr->curr_animation != 11)
				Set_Animation_BOB(Player.object_ptr, 11);
		}
		else if(face == "SW")
		{
			if(Player.object_ptr->curr_animation != 13)
				Set_Animation_BOB(Player.object_ptr, 13);
		}
		else if(face == "NW")
		{
			if(Player.object_ptr->curr_animation != 14)
				Set_Animation_BOB(Player.object_ptr, 14);
		}

		for(int x = (Player.x + 3); x < (Player.x + 24); x++)
		{
			if(world_ptrs[x][(Player.y-6) - 4] != NULL)
			{
				move = false;
				break;
			}
		}

		if(move == true)
		{
			if (world_y == WORLD_MAX_HEIGHT - WINDOW_HEIGHT)	// if camera cannot go up any more
			{
				if(Player.object_ptr->y <= (WINDOW_HEIGHT/2)-16)			// When character is back in the middle, just move the camera
					world_y -= 4;		
			}
			else if ((world_y-=4) < 0)							// if camera is at the bottom
			world_y = 0;										// move character back toward center of screen

			if((Player.y -= 4) < 0)								// move character on the screen
				Player.y = 0;
		}
		Animate_BOB(Player.object_ptr);
	} // end if
	else if (keyboard_state[DIK_DOWN] || keyboard_state[DIK_S])
	{
		moving = 'D';

		if(face == "S")
		{
			if(Player.object_ptr->curr_animation != 4)
				Set_Animation_BOB(Player.object_ptr, 4);
		}
		else if(face == "N")
		{
			if(Player.object_ptr->curr_animation != 1)
				Set_Animation_BOB(Player.object_ptr, 1);
		}
		else if(face == "E")
		{
			if(Player.object_ptr->curr_animation != 2)
				Set_Animation_BOB(Player.object_ptr, 2);
		}
		else if(face == "W")
		{
			if(Player.object_ptr->curr_animation != 6)
				Set_Animation_BOB(Player.object_ptr, 6);
		}
		else if(face == "NE")
		{
			if(Player.object_ptr->curr_animation != 9)
				Set_Animation_BOB(Player.object_ptr, 9);
		}
		else if(face == "SE")
		{
			if(Player.object_ptr->curr_animation != 10)
				Set_Animation_BOB(Player.object_ptr, 10);
		}
		else if(face == "SW")
		{
			if(Player.object_ptr->curr_animation != 12)
				Set_Animation_BOB(Player.object_ptr, 12);
		}
		else if(face == "NW")
		{
			if(Player.object_ptr->curr_animation != 15)
				Set_Animation_BOB(Player.object_ptr, 15);
		}


		for(int x = Player.x + 3; x < (Player.x + 24); x++)
		{
			if(world_ptrs[x][(Player.y+28) + 4] != NULL)
			{
				move = false;
				break;
			}
		}
		
		if(move == true)
		{
			if (world_y == 0)									// if camera cannot go down any more
			{
				if(Player.object_ptr->y >= (WINDOW_HEIGHT/2)-16)
					world_y += 4;	
			}
			else if ((world_y+=4) >= (WORLD_MAX_HEIGHT - WINDOW_HEIGHT))
			world_y = (WORLD_MAX_HEIGHT - WINDOW_HEIGHT);

			if((Player.y += 4) >= WORLD_MAX_HEIGHT - 32)
				Player.y = WORLD_MAX_HEIGHT - 32;
		}
		Animate_BOB(Player.object_ptr);
	} // end if
	else
	{
		if(Player.object_ptr->curr_animation <= 1 || Player.object_ptr->curr_animation == 16 || Player.object_ptr->curr_animation == 20)
			Player.object_ptr->curr_frame = 0;
		else if(Player.object_ptr->curr_animation <= 3 || Player.object_ptr->curr_animation == 17 || Player.object_ptr->curr_animation == 21)
			Player.object_ptr->curr_frame = 5;
		else if(Player.object_ptr->curr_animation <= 5 || Player.object_ptr->curr_animation == 18 || Player.object_ptr->curr_animation == 22)
			Player.object_ptr->curr_frame = 10;
		else if(Player.object_ptr->curr_animation <= 7 || Player.object_ptr->curr_animation == 19 || Player.object_ptr->curr_animation == 23)
			Player.object_ptr->curr_frame = 15;
		else if(Player.object_ptr->curr_animation <= 9 || Player.object_ptr->curr_animation == 24 || Player.object_ptr->curr_animation == 28)
			Player.object_ptr->curr_frame = 20;
		else if(Player.object_ptr->curr_animation <= 11 || Player.object_ptr->curr_animation == 25 || Player.object_ptr->curr_animation == 29)
			Player.object_ptr->curr_frame = 25;
		else if(Player.object_ptr->curr_animation <= 13 || Player.object_ptr->curr_animation == 26 || Player.object_ptr->curr_animation == 30)
			Player.object_ptr->curr_frame = 30;
		else if(Player.object_ptr->curr_animation <= 15 || Player.object_ptr->curr_animation == 27 || Player.object_ptr->curr_animation == 31)
			Player.object_ptr->curr_frame = 35;
		Set_Animation_BOB(Player.object_ptr, Player.object_ptr->curr_animation);
		play_gunshot = 2;
	}
}

// SET UP END LEVEL ENEMY POSITIONS
if(level == 1)
{
	if(endLevel == false)
	{
		if(world_y < 1216)
		{
			endLevel = true;
			for(int x=0; x < 128; x++)
			{
				Add_Enemy(random_range(512, 2144), random_range(64, 970), random_range(1,2));
			}
		}
	}
	else
	{
		if((world_y <= 32) && (world_x >= 680) && (world_x <= 900) && (numEnemies == 0))
		{
			endMission = true;
		}
	}
}
else if(level == 2)
{
	if(endLevel == false)
	{
		if(world_y < 1964)
		{
			endLevel = true;
			enemycounter = 150;
			for(int x=0; x < 32; x++)
			{
				Add_Enemy(random_range(128, 256), random_range(160, 1984), random_range(2,3));
			}
			for(int x=0; x < 32; x++)
			{
				Add_Enemy(random_range(704, 832), random_range(160, 1984), random_range(2,3));
			}
			for(int x=0; x < 32; x++)
			{
				Add_Enemy(random_range(1280, 1536), random_range(160, 1984), random_range(2,3));
			}
			for(int x=0; x < 32; x++)
			{
				Add_Enemy(random_range(1984, 2048), random_range(160, 1984), random_range(2,3));
			}
			for(int x=0; x < 32; x++)
			{
				Add_Enemy(random_range(2496, 2624), random_range(160, 1984), random_range(2,3));
			}
		}
	}
	else
	{
		if(enemycounter <= 0)
			endMission = true;

		sprintf(buffer, "Enemies Remaining: %d", enemycounter);
		Draw_Text_GDI(buffer,8,16,RGB(0,255,0),lpddsback);
	}
}
else if(level == 3)
{
	if(endLevel == false)
	{
		if(world_y < 960)
		{
			endLevel = true;
			enemycounter = 150;
			for(int x=0; x < 200; x++)
			{
				Add_Enemy(random_range(0, 2816), random_range(512, 960), random_range(1,3));
			}
		}
	}
	else
	{
		if(enemycounter <= 0)
			endMission = true;

		sprintf(buffer, "Enemies Remaining: %d", enemycounter);
		Draw_Text_GDI(buffer,8,16,RGB(0,255,0),lpddsback);
	}
}

if(level == 1)
{
	if(moving == 'X')
	{
		if((numEnemies < 50) && (endLevel == false))
		{
			if((random_range(1, 50)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x, world_x + WINDOW_WIDTH - 32);
					if((world_ptrs[tempx][world_y] == NULL) && (world_ptrs[tempx+16][world_y] == NULL))
					{
						Add_Enemy(tempx, world_y-16, 1);
						x = 5;
					}
				}
			}
		}
		
		if(numFriends < 25)
		{
			if((random_range(1, 50)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x, world_x + WINDOW_WIDTH - 32);
					if((world_ptrs[tempx][(world_y + WINDOW_HEIGHT)] == NULL) && (world_ptrs[tempx+16][(world_y + WINDOW_HEIGHT)]==NULL))
					{
						Add_Friend(tempx, world_y+WINDOW_HEIGHT-2);
						x = 5;
					}
				}
			}
		}
	}
	else if((moving == 'U') || (moving == '1') || (moving == '4'))
	{
		if((numEnemies < 50) && (endLevel == false))
		{
			if((random_range(1,10)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x, world_x + WINDOW_WIDTH - 32);
					if((world_ptrs[tempx][world_y] == NULL) && (world_ptrs[tempx+16][world_y] == NULL))
					{
						Add_Enemy(tempx, world_y-16, 1);
						x = 5;
					}
				}
			}
		}
	}
	else if((moving == 'D') || (moving == '2') || (moving == '3'))
	{
		if(numFriends < 35)
		{
			if((random_range(1, 10)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x, world_x + WINDOW_WIDTH - 32);
					if((world_ptrs[tempx][(world_y + WINDOW_HEIGHT)] == NULL) && (world_ptrs[tempx+16][(world_y + WINDOW_HEIGHT)]==NULL))
					{
						Add_Friend(tempx, world_y+WINDOW_HEIGHT-2);
						x = 5;
					}
				}
			}
		}
	}
	else if(moving == 'L')
	{
		if((numEnemies < 50) && (endLevel == false))
		{
			if((random_range(1, 20)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x, world_x + WINDOW_WIDTH/2);
					if((world_ptrs[tempx][world_y] == NULL) && (world_ptrs[tempx+16][world_y] == NULL))
					{
						Add_Enemy(tempx, world_y-16, 1);
						x = 5;
					}
				}
			}
		}
		
		if(numFriends < 25)
		{
			if((random_range(1, 20)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x, world_x + WINDOW_WIDTH/2);
					if((world_ptrs[tempx][(world_y + WINDOW_HEIGHT)] == NULL) && (world_ptrs[tempx+16][(world_y + WINDOW_HEIGHT)]==NULL))
						Add_Friend(tempx, world_y+WINDOW_HEIGHT-2);
					x = 5;
				}
			}
		}
	}
	else if(moving == 'R')
	{
		if((numEnemies < 50) && (endLevel == false))
		{
			if((random_range(1, 20)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x + WINDOW_WIDTH/2, world_x + WINDOW_WIDTH - 32);
					if((world_ptrs[tempx][world_y] == NULL) && (world_ptrs[tempx+16][world_y] == NULL))
					{
						Add_Enemy(tempx, world_y-16, 1);
						x = 5;
					}
				}
			}
		}
		
		if(numFriends < 25)
		{
			if((random_range(1, 20)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x + WINDOW_WIDTH/2, world_x + WINDOW_WIDTH - 32);
					if((world_ptrs[tempx][(world_y + WINDOW_HEIGHT)] == NULL) && (world_ptrs[tempx+16][(world_y + WINDOW_HEIGHT)]==NULL))
					{
						Add_Friend(tempx, world_y+WINDOW_HEIGHT-2);
						x = 5;
					}
				}
			}
		}
	}
}
else if(level == 2)
{
	if(moving == 'X')
	{
		if((numEnemies < 50) && (endLevel == false))
		{
			if((random_range(1, 50)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x, world_x + WINDOW_WIDTH - 32);
					if((world_ptrs[tempx][world_y] == NULL) && (world_ptrs[tempx+16][world_y] == NULL))
					{
						Add_Enemy(tempx, world_y-16, random_range(1,2));
						x = 5;
					}
				}
			}
		}
		
		if(numFriends < 25)
		{
			if((random_range(1, 50)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x, world_x + WINDOW_WIDTH - 32);
					if((world_ptrs[tempx][(world_y + WINDOW_HEIGHT)] == NULL) && (world_ptrs[tempx+16][(world_y + WINDOW_HEIGHT)]==NULL))
					{
						Add_Friend(tempx, world_y+WINDOW_HEIGHT-2);
						x = 5;
					}
				}
			}
		}
	}
	else if((moving == 'U') || (moving == '1') || (moving == '4'))
	{
		if((numEnemies < 50) && (endLevel == false))
		{
			if((random_range(1,10)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x, world_x + WINDOW_WIDTH - 32);
					if((world_ptrs[tempx][world_y] == NULL) && (world_ptrs[tempx+16][world_y] == NULL))
					{
						Add_Enemy(tempx, world_y-16, random_range(1,2));
						x = 5;
					}
				}
			}
		}
	}
	else if((moving == 'D') || (moving == '2') || (moving == '3'))
	{
		if(numFriends < 35)
		{
			if((random_range(1, 10)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x, world_x + WINDOW_WIDTH - 32);
					if((world_ptrs[tempx][(world_y + WINDOW_HEIGHT)] == NULL) && (world_ptrs[tempx+16][(world_y + WINDOW_HEIGHT)]==NULL))
					{
						Add_Friend(tempx, world_y+WINDOW_HEIGHT-2);
						x = 5;
					}
				}
			}
		}
	}
	else if(moving == 'L')
	{
		if((numEnemies < 50) && (endLevel == false))
		{
			if((random_range(1, 20)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x, world_x + WINDOW_WIDTH/2);
					if((world_ptrs[tempx][world_y] == NULL) && (world_ptrs[tempx+16][world_y] == NULL))
					{
						Add_Enemy(tempx, world_y-16, random_range(1,2));
						x = 5;
					}
				}
			}
		}
		
		if(numFriends < 25)
		{
			if((random_range(1, 20)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x, world_x + WINDOW_WIDTH/2);
					if((world_ptrs[tempx][(world_y + WINDOW_HEIGHT)] == NULL) && (world_ptrs[tempx+16][(world_y + WINDOW_HEIGHT)]==NULL))
						Add_Friend(tempx, world_y+WINDOW_HEIGHT-2);
					x = 5;
				}
			}
		}
	}
	else if(moving == 'R')
	{
		if((numEnemies < 50) && (endLevel == false))
		{
			if((random_range(1, 20)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x + WINDOW_WIDTH/2, world_x + WINDOW_WIDTH - 32);
					if((world_ptrs[tempx][world_y] == NULL) && (world_ptrs[tempx+16][world_y] == NULL))
					{
						Add_Enemy(tempx, world_y-16, random_range(1,2));
						x = 5;
					}
				}
			}
		}
		
		if(numFriends < 25)
		{
			if((random_range(1, 20)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x + WINDOW_WIDTH/2, world_x + WINDOW_WIDTH - 32);
					if((world_ptrs[tempx][(world_y + WINDOW_HEIGHT)] == NULL) && (world_ptrs[tempx+16][(world_y + WINDOW_HEIGHT)]==NULL))
					{
						Add_Friend(tempx, world_y+WINDOW_HEIGHT-2);
						x = 5;
					}
				}
			}
		}
	}
}
else if(level == 3)
{
	if(moving == 'X')
	{
		if((numEnemies < 50) && (endLevel == false))
		{
			if((random_range(1, 50)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x, world_x + WINDOW_WIDTH - 32);
					if((world_ptrs[tempx][world_y] == NULL) && (world_ptrs[tempx+16][world_y] == NULL))
					{
						Add_Enemy(tempx, world_y-16, random_range(1,3));
						x = 5;
					}
				}
			}
		}
		
		if(numFriends < 25)
		{
			if((random_range(1, 50)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x, world_x + WINDOW_WIDTH - 32);
					if((world_ptrs[tempx][(world_y + WINDOW_HEIGHT)] == NULL) && (world_ptrs[tempx+16][(world_y + WINDOW_HEIGHT)]==NULL))
					{
						Add_Friend(tempx, world_y+WINDOW_HEIGHT-2);
						x = 5;
					}
				}
			}
		}
	}
	else if((moving == 'U') || (moving == '1') || (moving == '4'))
	{
		if((numEnemies < 50) && (endLevel == false))
		{
			if((random_range(1,10)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x, world_x + WINDOW_WIDTH - 32);
					if((world_ptrs[tempx][world_y] == NULL) && (world_ptrs[tempx+16][world_y] == NULL))
					{
						Add_Enemy(tempx, world_y-16, random_range(1,3));
						x = 5;
					}
				}
			}
		}
	}
	else if((moving == 'D') || (moving == '2') || (moving == '3'))
	{
		if(numFriends < 35)
		{
			if((random_range(1, 10)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x, world_x + WINDOW_WIDTH - 32);
					if((world_ptrs[tempx][(world_y + WINDOW_HEIGHT)] == NULL) && (world_ptrs[tempx+16][(world_y + WINDOW_HEIGHT)]==NULL))
					{
						Add_Friend(tempx, world_y+WINDOW_HEIGHT-2);
						x = 5;
					}
				}
			}
		}
	}
	else if(moving == 'L')
	{
		if((numEnemies < 50) && (endLevel == false))
		{
			if((random_range(1, 20)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x, world_x + WINDOW_WIDTH/2);
					if((world_ptrs[tempx][world_y] == NULL) && (world_ptrs[tempx+16][world_y] == NULL))
					{
						Add_Enemy(tempx, world_y-16, random_range(1,3));
						x = 5;
					}
				}
			}
		}
		
		if(numFriends < 25)
		{
			if((random_range(1, 20)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x, world_x + WINDOW_WIDTH/2);
					if((world_ptrs[tempx][(world_y + WINDOW_HEIGHT)] == NULL) && (world_ptrs[tempx+16][(world_y + WINDOW_HEIGHT)]==NULL))
						Add_Friend(tempx, world_y+WINDOW_HEIGHT-2);
					x = 5;
				}
			}
		}
	}
	else if(moving == 'R')
	{
		if((numEnemies < 50) && (endLevel == false))
		{
			if((random_range(1, 20)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x + WINDOW_WIDTH/2, world_x + WINDOW_WIDTH - 32);
					if((world_ptrs[tempx][world_y] == NULL) && (world_ptrs[tempx+16][world_y] == NULL))
					{
						Add_Enemy(tempx, world_y-16, random_range(1,3));
						x = 5;
					}
				}
			}
		}
		
		if(numFriends < 25)
		{
			if((random_range(1, 20)) == 10)
			{
				for(int x = 0; x < 5; x++)
				{
					int tempx = random_range(world_x + WINDOW_WIDTH/2, world_x + WINDOW_WIDTH - 32);
					if((world_ptrs[tempx][(world_y + WINDOW_HEIGHT)] == NULL) && (world_ptrs[tempx+16][(world_y + WINDOW_HEIGHT)]==NULL))
					{
						Add_Friend(tempx, world_y+WINDOW_HEIGHT-2);
						x = 5;
					}
				}
			}
		}
	}
}


moving = 'X';




// Draw Character BOB
Player.object_ptr->x = Player.x - world_x;
Player.object_ptr->y = Player.y - world_y;

Draw_BOB16(Player.object_ptr, lpddsback);
	
Draw_BOB16(&cursor, lpddsback);

if(endMission == true)
{
	if(missionComplete > 0)
	{
		Draw_BOB16(&missionAccomplished, lpddsback);
		missionComplete--;
	}
	else
	{
		if(level == 1)
		{
			endLevel = false;
			endMission = false;
			Load_Level_Two();
		}
		else if(level == 2)
		{
			endLevel = false;
			endMission = false;
			Load_Level_Three();
		}
		//else if (level == 3)
			//load end scene
	}
}

sprintf(buffer, "Soldiers Remaining: %d", lives);
Draw_Text_GDI(buffer,8,screen_height - 32 - 24,RGB(0,255,0),lpddsback);

// flip the surfaces
DDraw_Flip();

// sync to 30ish fps
Wait_Clock(30);

// return success
return(1);
 
} // end Game_Main

//////////////////////////////////////////////////////////


void Add_Enemy(int xpos, int ypos, int Etype)
{
	EnemyPos[addEnemy].x = xpos;
	EnemyPos[addEnemy].y = ypos;
	EnemyPos[addEnemy].deathanim = 0;
	EnemyPos[addEnemy].soldier_face = "S";
	EnemyPos[addEnemy].playshot = 2;

	// set type
	if(Etype == 1)
	{
		EnemyPos[addEnemy].object_ptr = new BOB;	// Create pointer to BOB
		Clone_BOB(&enemysoldier, EnemyPos[addEnemy].object_ptr);	// Clone enemysoldier BOB
		EnemyPos[addEnemy].object_ptr->life = 3;
		EnemyPos[addEnemy].object_ptr->type = 1;
		EnemyPos[addEnemy].type = 1;
		EnemyPos[addEnemy].action = "walking";
		EnemyPos[addEnemy].action_timer = random_range(30, 100);
	}
	else if(Etype == 2)
	{
		EnemyPos[addEnemy].object_ptr = new BOB;	// Create pointer to BOB
		Clone_BOB(&zombie, EnemyPos[addEnemy].object_ptr);	// Clone enemysoldier BOB
		EnemyPos[addEnemy].object_ptr->life = 9;
		EnemyPos[addEnemy].object_ptr->type = 1;
		EnemyPos[addEnemy].type = 2;
		EnemyPos[addEnemy].action_timer = 0;
	}
	else if(Etype == 3)
	{
		EnemyPos[addEnemy].object_ptr = new BOB;	// Create pointer to BOB
		Clone_BOB(&zombiesoldier, EnemyPos[addEnemy].object_ptr);	// Clone enemysoldier BOB
		EnemyPos[addEnemy].object_ptr->life = 9;
		EnemyPos[addEnemy].object_ptr->type = 1;
		EnemyPos[addEnemy].type = 1;
		EnemyPos[addEnemy].action = "walking";
		EnemyPos[addEnemy].action_timer = random_range(30, 100);
	}

	if((addEnemy += 1) >= 256)
		addEnemy = 0;

	if((ENEMY_HIGH += 1) >= 256)
		ENEMY_HIGH = 255;
}
void Add_Friend(int xpos, int ypos)
{
	FriendPos[addFriend].x = xpos;
	FriendPos[addFriend].y = ypos;
	FriendPos[addFriend].deathanim = 0;
	FriendPos[addFriend].soldier_face = "N";
	FriendPos[addFriend].action = "walking";
	FriendPos[addFriend].action_timer = random_range(30, 100);
	FriendPos[addFriend].playshot = 2;

	// set type
	FriendPos[addFriend].object_ptr = new BOB;
	Clone_BOB(&mainchar, FriendPos[addFriend].object_ptr);
	FriendPos[addFriend].object_ptr->life = 3;
	FriendPos[addFriend].object_ptr->type = 0;
	FriendPos[addFriend].type = 1;

	if((addFriend += 1) >= 256)
		addFriend = 0;

	if((FRIEND_HIGH += 1) >= 256)
		FRIEND_HIGH = 255;
}
int Title_Screen(void *parms)
{	
	int menuTimer = 0;
	menuchoice.x = 257, menuchoice.y = 379;
	menu1.x = 305, menu1.y = 350;
	menu2.x = 96, menu2.y = 475;
	char menu1Array[3] = {'t', 'n', 'c'};
	char menu2Array[3] = {'1', '2', '3'};
	int arrayNum = 1;
	int menuNum = 1;
	char menu = 'n';

	int temp = 0;
	while(temp == 0)
	{
		//sprintf(buffer, "Title placeholder");
		//Draw_Text_GDI(buffer,8,WINDOW_HEIGHT - 32 - 24,RGB(0,255,0),lpddsprimary);

		DInput_Read_Keyboard();

		Draw_Scaled_BOB16(&titlescreen, WINDOW_WIDTH, WINDOW_HEIGHT, lpddsback);
		Draw_BOB16(&menuchoice, lpddsback);
		Draw_BOB16(&menu1, lpddsback);
		if(menuNum == 2)
			Draw_BOB16(&menu2, lpddsback);
		
		if(keyboard_state[DIK_ESCAPE])
		{
			Game_Shutdown();
		}

		if(keyboard_state[DIK_RETURN])
		{
			switch(menu)
			{
				case't' : tutorial();
						  temp = 1;
						  break;
				case'n' : Load_Level_One();
						  temp = 1;
						  break;
				case'c' : menuNum = 2;
						  arrayNum = 0;
						  menuchoice.x = 22, menuchoice.y = 464;
						  break;
				case'1' : Load_Level_One();
						  temp = 1;
						  break;
				case'2' : Load_Level_Two();
						  temp = 1;
						  break;
				case'3' : Load_Level_Three();
						  temp = 1;
						  break;
				default : break;
			}
		}
		else if(keyboard_state[DIK_DOWN])
		{
			if(menuTimer == 10)
			{
				if(menuNum == 1)
				{
					if((arrayNum += 1) > 2)
					{
						arrayNum = 0;
						menuchoice.y = 339;
					}
					else
						menuchoice.y += 40;

					menu = menu1Array[arrayNum];
					menuTimer = 0;
						
				}
			}
		}
		else if(keyboard_state[DIK_UP])
		{
			if(menuTimer == 10)
			{
				if(menuNum == 1)
				{
					if((arrayNum -= 1) < 0)
					{
						arrayNum = 2;
						menuchoice.y = 419;
					}
					else
						menuchoice.y -= 40;

					menu = menu1Array[arrayNum];
					menuTimer = 0;
						
				}
			}
		}
		else if(keyboard_state[DIK_RIGHT])
		{
			if(menuTimer == 10)
			{
				if(menuNum == 2)
				{
					if((arrayNum += 1) > 2)
					{
						arrayNum = 0;
						menuchoice.x = 22;
					}
					else
						menuchoice.x += 235;

					menu = menu2Array[arrayNum];
					menuTimer = 0;
						
				}
			}
		}
		else if(keyboard_state[DIK_LEFT])
		{
			if(menuTimer == 10)
			{
				if(menuNum == 2)
				{
					if((arrayNum -= 1) < 0)
					{
						arrayNum = 2;
						menuchoice.x = 492;
					}
					else
						menuchoice.x -= 235;

					menu = menu2Array[arrayNum];
					menuTimer = 0;
						
				}
			}
		}
	
		if(menuTimer < 10)
			menuTimer++;

		DDraw_Flip();
		Wait_Clock(30);
	}
	
	return(0);
}

void tutorial()
{		
	int temp = 0; // temporary integer used for cutscene display
	int cutTimer = 50; // countdown timer for the cutscene
	char buffer[256]; // used to print text


	// show cutscene for the tutorial	

    while(temp == 0)
	{		
		cutTimer--;

		if(cutTimer < 0)
			cutTimer = 0;

		DInput_Read_Keyboard();

		Draw_Scaled_BOB16(&titlescreen, WINDOW_WIDTH, WINDOW_HEIGHT, lpddsback);
		sprintf(buffer, "Keys:");
		Draw_Text_GDI(buffer,64,screen_height - 320,RGB(0,255,0),lpddsback);

		sprintf(buffer, "W or up arrow: move forward");
		Draw_Text_GDI(buffer,64,screen_height - 300,RGB(0,255,0),lpddsback);

		sprintf(buffer, "A or left arrow: strafe left");
		Draw_Text_GDI(buffer,64,screen_height - 280,RGB(0,255,0),lpddsback);

		sprintf(buffer, "S or down arrow: move backward");
		Draw_Text_GDI(buffer,64,screen_height - 260,RGB(0,255,0),lpddsback);

		sprintf(buffer, "D or right arrow: strafe right");
		Draw_Text_GDI(buffer,64,screen_height - 240,RGB(0,255,0),lpddsback);

		sprintf(buffer, "left mouse button: fire machine gun");
		Draw_Text_GDI(buffer,64,screen_height - 220,RGB(0,255,0),lpddsback);

		sprintf(buffer, "Stay close to your squadmates, or you will be quickly outgunned by the enemy!");
		Draw_Text_GDI(buffer,64,screen_height - 180,RGB(0,255,0),lpddsback);



		if(cutTimer == 0 && keyboard_state[DIK_RETURN])
		{
			temp = 1;
		}

		DDraw_Flip();
		Wait_Clock(30);
	}	
	
	Wait_Clock(30);
	Title_Screen();
}

int Load_Level_One(void *parms)
{
	int index; // temporary integer used in for loop index variable
	int temp = 0; // temporary integer used for cutscene display
	int cutTimer = 50; // countdown timer for the cutscene
	char buffer[256]; // used to print text
	endLevel = false;


	// show cutscene before the first level	

    while(temp == 0)
	{		
		cutTimer--;

		if(cutTimer < 0)
			cutTimer = 0;

		DInput_Read_Keyboard();

		Draw_Scaled_BOB16(&titlescreen, WINDOW_WIDTH, WINDOW_HEIGHT, lpddsback);
		sprintf(buffer, "The year is 2241.  The Allied Republic has waged war upon the Neo Terra Coalition since time");
		Draw_Text_GDI(buffer,64,screen_height - 320,RGB(0,255,0),lpddsback);

		sprintf(buffer, "immemorial.  This is a glorious day for you and your Allied Republic countrymen, as today you");
		Draw_Text_GDI(buffer,64,screen_height - 300,RGB(0,255,0),lpddsback);

		sprintf(buffer, "march upon the final stronghold of the enemy in a spearhead manuever.  Little did anyone");
		Draw_Text_GDI(buffer,64,screen_height - 280,RGB(0,255,0),lpddsback);

		sprintf(buffer, "suspect that this great enemy nation had been experimenting with biological warfare in the");
		Draw_Text_GDI(buffer,64,screen_height - 260,RGB(0,255,0),lpddsback);

		sprintf(buffer, "form of the risen dead.  The stakes have been risen once again - you, along with your ");
		Draw_Text_GDI(buffer,64,screen_height - 240,RGB(0,255,0),lpddsback);

		sprintf(buffer, "squadmates, will be the very first to battle this new threat, or be the first to watch the");
		Draw_Text_GDI(buffer,64,screen_height - 220,RGB(0,255,0),lpddsback);

		sprintf(buffer, "rest of the world fall to the undead.");
		Draw_Text_GDI(buffer,64,screen_height - 200,RGB(0,255,0),lpddsback);

		sprintf(buffer, "The invasion has begun!  Storm the beach and gain access to the lab.  (Press enter to continue)");
		Draw_Text_GDI(buffer,64,screen_height - 150,RGB(0,255,0),lpddsback);



		if(cutTimer == 0 && keyboard_state[DIK_RETURN])
		{
			temp = 1;
		}

		DDraw_Flip();
		Wait_Clock(30);
	}

	level = 1;
	WORLD_TILES = 58;
	WORLD_WIDTH = 40;     // add an extra column to the world so the program doesn't crash
	WORLD_MAX_WIDTH = ((WORLD_WIDTH) * 64);  // always keep world_width -1 so the program doesn't crash
	WORLD_MAX_HEIGHT = ((WORLD_TILES-1) * 64); // always keep world_tiles -1 so the program doesn't crash

	world_x = ((WORLD_MAX_WIDTH/2) - (WINDOW_WIDTH/2));
	world_y = (WORLD_MAX_HEIGHT - WINDOW_HEIGHT); // current position of viewing window

	Player.x = (WORLD_MAX_WIDTH/2)-32;
	Player.y = (WORLD_MAX_HEIGHT - (WINDOW_HEIGHT/2) - 16);
	Player.deathanim = 0;
	Player.object_ptr = new BOB;
	Clone_BOB(&mainchar, Player.object_ptr);
	Player.object_ptr->life = 3;
	Player.object_ptr->type = 0;
	face = "N";
	mouse_x = WORLD_MAX_WIDTH/2 - 16;
	mouse_y = WORLD_MAX_HEIGHT - (WINDOW_HEIGHT/2) - 16;

	
	///////////////************ BACKGROUND TILES *************////////////////////
	// load in texture maps
	Load_Bitmap_File(&bitmap16bit, "resources/backgroundone.bmp");

	// create the texture bob	
	if (FAILED(Create_BOB(&textures,0,0,64,64,26, BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME, DDSCAPS_VIDEOMEMORY,0,16)))
	{
		return(0);
	}

	// load each texture bitmap into the texture BOB object
	for (index = 0; index < 26; index++)
		Load_Frame_BOB16(&textures,&bitmap16bit,index,index%4,index/4,BITMAP_EXTRACT_MODE_CELL); 

	// unload the texture map bitmap
	Unload_Bitmap_File(&bitmap16bit);


	/////////////******** SCENERY SPRITES *****************//////////////
	Load_Bitmap_File(&bitmap16bit, "resources/sceneryone.bmp");

	// create normal barbed wire bob
	if (FAILED(Create_BOB(&barbedwire,0,0,32,32,3, BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME, DDSCAPS_SYSTEMMEMORY,RGB16Bit565(255,255,255),16)))
	{
		return(0);
	}

	// load barbed wire bob with the three frames of it
	for (index = 0; index < 3; index++)
	{
		Load_Frame_BOB16(&barbedwire, &bitmap16bit, index, index, 0, BITMAP_EXTRACT_MODE_CELL);
	}

	// create bloodied barbed wire bob
	if (FAILED(Create_BOB(&barbedwireblood,0,0,32,32,3, BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME, DDSCAPS_SYSTEMMEMORY,RGB16Bit565(255,255,255),16)))
	{
		return(0);
	}

	// load bloodied barbed wire bob with the three frames of it
	for (index = 3; index < 6; index++)
	{
		int framenumind = index - 3; // calculates the frame number based on loop index
		Load_Frame_BOB16(&barbedwireblood, &bitmap16bit, framenumind, index, 0, BITMAP_EXTRACT_MODE_CELL);
	}

	// create sandbags bob
	if (FAILED(Create_BOB(&sandbags,0,0,32,32,2, BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME, DDSCAPS_SYSTEMMEMORY,RGB16Bit565(255,255,255),16)))
	{
		return(0);
	}

	// load sandbags bob with the two frames of it
	Load_Frame_BOB16(&sandbags, &bitmap16bit, 0, 6, 0, BITMAP_EXTRACT_MODE_CELL);
	Load_Frame_BOB16(&sandbags, &bitmap16bit, 1, 7, 0, BITMAP_EXTRACT_MODE_CELL);

	// create bob to hold both rock scenery props
	if (FAILED(Create_BOB(&rock,0,0,32,32,2, BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME, DDSCAPS_SYSTEMMEMORY,RGB16Bit565(255,255,255),16)))
	{
		return(0);
	}

	// load rock bob with the two frames of it
	Load_Frame_BOB16(&rock, &bitmap16bit, 0, 4, 1, BITMAP_EXTRACT_MODE_CELL);
	Load_Frame_BOB16(&rock, &bitmap16bit, 1, 5, 1, BITMAP_EXTRACT_MODE_CELL);

	// create bob to hold both bush scenery props
	if (FAILED(Create_BOB(&bush,0,0,32,32,2, BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME, DDSCAPS_SYSTEMMEMORY,RGB16Bit565(255,255,255),16)))
	{
		return(0);
	}

	// load bush bob with the two frames of it
	Load_Frame_BOB16(&bush, &bitmap16bit, 0, 0, 1, BITMAP_EXTRACT_MODE_CELL);
	Load_Frame_BOB16(&bush, &bitmap16bit, 1, 3, 1, BITMAP_EXTRACT_MODE_CELL);

	// create bob to hold both twisted metal scenery props
	if (FAILED(Create_BOB(&twistedmetal,0,0,32,32,2, BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME, DDSCAPS_SYSTEMMEMORY,RGB16Bit565(255,255,255),16)))
	{
		return(0);
	}

	// load twisted metal bob with the two frames of it
	Load_Frame_BOB16(&twistedmetal, &bitmap16bit, 0, 1, 1, BITMAP_EXTRACT_MODE_CELL);
	Load_Frame_BOB16(&twistedmetal, &bitmap16bit, 1, 6, 1, BITMAP_EXTRACT_MODE_CELL);


	for (index = 0; index < 256; index++)
	{
		Scenery[index].x = WORLD_MAX_WIDTH + 32;
		Scenery[index].y = WORLD_MAX_HEIGHT + 32; // these statements effectively 'clear' the array
		                                          // which holds scenery objects
	}

	for (index = 0; index < 256; index++)
	{
		EnemyPos[index].x = WORLD_MAX_WIDTH + 32;
		EnemyPos[index].y = WORLD_MAX_HEIGHT + 32; // these statements effectively 'clear' the array
		                                           // which holds enemy monster objects
	}

	for (index = 0; index < 256; index++)
	{
		FriendPos[index].x = WORLD_MAX_WIDTH + 32;
		FriendPos[index].y = WORLD_MAX_HEIGHT + 32; // these statements effectively 'clear' the array
		                                           // which holds friendly soldier objects
	}


// BEGIN PLACING SCENERY INTO ARRAY
	for(index = 0; index < 18; index++)
	{
		Clone_BOB(&rock, Scenery[index].object_ptr);
		Scenery[index].x = random_range(0, WORLD_MAX_WIDTH);
		Scenery[index].y = random_range(0, WORLD_MAX_HEIGHT - 300);
		Scenery[index].object_ptr->curr_frame = 0;
		Scenery[index].object_ptr->type = 2;
	}

	for(index = 18; index < 30; index++)
	{
		Clone_BOB(&rock, Scenery[index].object_ptr);
		Scenery[index].x = random_range(0, WORLD_MAX_WIDTH);
		Scenery[index].y = random_range(0, WORLD_MAX_HEIGHT - 300);
		Scenery[index].object_ptr->curr_frame = 1;
		Scenery[index].object_ptr->type = 2;
	}

	for(index = 30; index < 40; index++)
	{
		Clone_BOB(&bush, Scenery[index].object_ptr);
		Scenery[index].x = random_range(0, WORLD_MAX_WIDTH);
		Scenery[index].y = random_range(0, WORLD_MAX_HEIGHT - 300);
		Scenery[index].object_ptr->curr_frame = 0;
		Scenery[index].object_ptr->type = 3;
	}


	for(index = 40; index < 50; index++)
	{
		Clone_BOB(&bush, Scenery[index].object_ptr);
		Scenery[index].x = random_range(0, WORLD_MAX_WIDTH);
		Scenery[index].y = random_range(0, WORLD_MAX_HEIGHT - 300);
		Scenery[index].object_ptr->curr_frame = 1;
		Scenery[index].object_ptr->type = 3;
	}

	int tempx = 50;

	for(index = 50; index < 108; index++)
	{
		Clone_BOB(&twistedmetal, Scenery[index].object_ptr);
		Scenery[index].x = tempx;
		Scenery[index].y = WORLD_MAX_HEIGHT - 256;
		Scenery[index].object_ptr->curr_frame = 1;
		Scenery[index].object_ptr->type = 2;

		Clone_BOB(&twistedmetal, Scenery[index+=1].object_ptr);
		Scenery[index].x = tempx + 66;
		Scenery[index].y = WORLD_MAX_HEIGHT - 384;
		Scenery[index].object_ptr->curr_frame = 1;
		Scenery[index].object_ptr->type = 2;

		Clone_BOB(&twistedmetal, Scenery[index+=1].object_ptr);
		Scenery[index].x = tempx;
		Scenery[index].y = WORLD_MAX_HEIGHT - 512;
		Scenery[index].object_ptr->curr_frame = 1;
		Scenery[index].object_ptr->type = 2;

		tempx += 132;
	}

	for(index = 108; index < 114; index++)
	{
		Clone_BOB(&sandbags, Scenery[index].object_ptr);
		Scenery[index].x = 500 + (index-108)*32;
		Scenery[index].y = WORLD_MAX_HEIGHT - 1224;
		Scenery[index].object_ptr->curr_frame = index%2;
		Scenery[index].object_ptr->type = 2;
	}

	for(index = 114; index < 125; index++)
	{
		Clone_BOB(&sandbags, Scenery[index].object_ptr);
		Scenery[index].x = 1000 + (index-114)*32;
		Scenery[index].y = WORLD_MAX_HEIGHT - 1524;
		Scenery[index].object_ptr->curr_frame = index%2;
		Scenery[index].object_ptr->type = 2;
	}

	for(index = 125; index < 132; index++)
	{
		Clone_BOB(&sandbags, Scenery[index].object_ptr);
		Scenery[index].x = 1600 + (index-125)*32;
		Scenery[index].y = WORLD_MAX_HEIGHT - 1124;
		Scenery[index].object_ptr->curr_frame = index%2;
		Scenery[index].object_ptr->type = 2;
	}

	for(index = 132; index < 140; index++)
	{
		Clone_BOB(&sandbags, Scenery[index].object_ptr);
		Scenery[index].x = 1900 + (index-132)*32;
		Scenery[index].y = WORLD_MAX_HEIGHT - 1824;
		Scenery[index].object_ptr->curr_frame = index%2;
		Scenery[index].object_ptr->type = 2;
	}

	for(index = 140; index < 150; index++)
	{
		Clone_BOB(&sandbags, Scenery[index].object_ptr);
		Scenery[index].x = 1235 + (index-140)*32;
		Scenery[index].y = WORLD_MAX_HEIGHT - 1024;
		Scenery[index].object_ptr->curr_frame = index%2;
		Scenery[index].object_ptr->type = 2;
	}

	for(index = 150; index < 160; index++)
	{
		Clone_BOB(&sandbags, Scenery[index].object_ptr);
		Scenery[index].x = 635 + (index-150)*32;
		Scenery[index].y = WORLD_MAX_HEIGHT - 724;
		Scenery[index].object_ptr->curr_frame = index%2;
		Scenery[index].object_ptr->type = 2;
	}

	for(index = 160; index < 167; index++)
	{
		Clone_BOB(&sandbags, Scenery[index].object_ptr);
		Scenery[index].x = 2100 + (index-160)*32;
		Scenery[index].y = WORLD_MAX_HEIGHT - 1324;
		Scenery[index].object_ptr->curr_frame = index%2;
		Scenery[index].object_ptr->type = 2;
	}

// END PLACING SCENERY INTO ARRAY


	world.clear(); // clear the world vector

	vector<int> tempvec; // use a temporary vector for one line of the world vector
	tempvec.clear(); // clear it before use

	 // use a temporary array of integers to load the world vector
    int templevel1[58][40] = 
	{
		{22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,23,25,25,25,25,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22},
		{5,5,5,5,5,3,4,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,3,4,5,5,5,5,5},
		{5,5,5,5,5,3,4,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,3,4,5,5,5,5,5},
		{5,5,5,5,5,3,4,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,3,4,5,5,5,5,5},
		{5,5,5,5,5,3,4,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,3,4,5,5,5,5,5},
		{5,5,5,5,5,3,4,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,3,4,5,5,5,5,5},
		{5,5,5,5,5,3,4,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,3,4,5,5,5,5,5},
		{5,5,5,5,5,3,4,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,3,4,5,5,5,5,5},
		{5,5,5,5,5,3,4,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,3,4,5,5,5,5,5},
		{5,5,5,5,5,3,4,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,3,4,5,5,5,5,5},
		{5,5,5,5,5,3,4,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,3,4,5,5,5,5,5},
		{5,5,5,5,5,3,4,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,3,4,5,5,5,5,5},
		{5,5,5,5,5,3,4,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,3,4,5,5,5,5,5},
		{5,5,5,5,5,3,4,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,3,4,5,5,5,5,5},
		{5,5,5,5,5,3,4,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,3,4,5,5,5,5,5},
		{5,5,5,5,5,3,20,2,2,2,5,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,21,4,5,5,5,5,5},
		{5,5,5,5,5,18,1,1,1,1,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,19,5,5,5,5,5},
		{5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5},
		{5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5},
		{5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5},
		{5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5},
		{5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5},
		{5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5},
		{5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5},
		{5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5},
		{2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,5,5,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
		{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
		{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{5,5,5,5,5,5,5,5,6,15,7,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5},
		{5,5,5,5,5,5,5,5,13,11,12,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,7,5,5,5,5},
		{5,5,5,5,5,10,5,5,8,14,9,5,5,5,5,5,6,15,7,5,5,10,5,5,5,10,5,5,5,5,5,5,5,5,13,12,5,5,5,5},
		{5,5,6,7,5,5,5,5,5,5,5,5,5,5,5,5,8,14,9,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,8,9,5,5,5,5},
		{5,5,13,12,5,5,5,5,5,5,5,6,7,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,15,7,5,5,5,5,5,5,5,5,5,6},
		{7,5,8,9,5,5,5,5,5,5,5,8,9,5,5,5,5,5,5,5,5,5,5,5,5,5,5,13,11,12,5,5,5,10,5,5,5,5,5,13},
		{9,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,7,5,5,5,5,8,14,9,5,5,5,5,5,5,5,5,5,13},
		{5,5,5,5,5,10,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,13,12,5,5,5,5,5,5,5,5,5,5,5,5,5,10,5,5,8},
		{10,5,5,5,5,5,5,5,5,5,5,5,5,6,11,7,5,5,5,5,5,8,9,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5},
		{5,5,5,5,5,5,10,5,5,10,5,5,5,8,14,9,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,10,5,5,5,5,5,5,5},
		{5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,10,5,5,5,5,5,5,5,5,5,5,6,7,5,5,5,5,5,5,5,5,5,5},
		{5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,7,5,5,5,5,5,5,5,5,13,12,5,5,5,5,5,5,10,5,5,5},
		{5,5,10,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,8,9,5,5,5,5,10,5,5,5,8,9,5,5,5,5,5,5,5,5,5,5},
		{5,5,5,5,5,6,7,5,5,5,5,5,5,5,10,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,10,5},
		{5,5,5,5,5,13,12,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,10,5,5,5,5,5,5,10,5,5,5,5,5,5},
		{5,10,5,5,5,13,12,5,5,5,5,5,5,5,5,5,10,5,5,5,6,7,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5},
		{5,5,5,5,5,8,9,5,5,6,15,7,5,5,5,5,5,5,5,5,8,9,5,5,10,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5},
		{5,5,5,10,5,5,5,5,5,13,11,12,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,10,5,5,5,5,5,5,5,5,5,5},
		{5,10,5,5,5,5,5,5,5,8,14,9,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,15,15,15},
		{5,5,5,5,5,5,10,5,5,5,5,5,5,5,5,5,10,5,5,5,5,5,5,6,15,15,7,5,5,5,5,5,5,5,5,5,13,11,11,11},
		{5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,13,11,11,12,5,5,5,10,5,5,5,5,5,8,14,14,14},
		{5,5,6,7,5,5,5,5,5,5,10,5,5,5,5,5,5,5,5,5,5,10,5,13,11,11,12,5,5,5,5,10,5,5,5,5,5,5,5,5},
		{5,5,8,9,5,5,5,5,5,5,5,5,5,5,5,6,15,15,7,5,5,5,5,8,14,14,9,5,5,5,5,5,6,7,5,5,5,5,5,5},
		{5,5,5,5,5,5,5,5,10,5,5,5,5,5,5,8,14,14,9,5,5,5,5,5,5,5,5,5,5,5,5,5,13,12,5,5,5,5,5,5},
		{5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,8,9,5,5,5,5,5,5},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16},
		{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},// always include an extra row so the program doesn't crash
	};
	world.clear();

	for(int a = 0; a < WORLD_TILES; a++)
	{
		for(int b = 0; b < WORLD_WIDTH; b++)
		{
		    tempvec.push_back(templevel1[a][b]);
		}
		world.push_back(tempvec); // add this one dimensional vector to the world vector
		tempvec.clear(); // clear the temp vector
	}
	delete[] templevel1;

	// Generate starting friendlies
	for(int x = 0; x < 15; x++)
		Add_Friend(random_range(world_x, (world_x + WINDOW_WIDTH - 32)), random_range(world_y + WINDOW_HEIGHT/2, world_y + WINDOW_HEIGHT - 32));

	return(0);
}

int Load_Level_Two(void *parms)
{
	int index; // temporary integer used in for loop index variable
	int temp = 0; // temporary integer used for cutscene display
	int lives = 10;
	int cutTimer = 50; // countdown timer for the cutscene
	char buffer[256]; // used to print text
	endLevel = false;


	// show cutscene before the second level	

    while(temp == 0)
	{		
		cutTimer--;

		if(cutTimer < 0)
			cutTimer = 0;

		DInput_Read_Keyboard();

		Draw_Scaled_BOB16(&titlescreen, WINDOW_WIDTH, WINDOW_HEIGHT, lpddsback);

		sprintf(buffer, "You and your squadmates have survived the beach.  You push into the lab, ready to make");
		Draw_Text_GDI(buffer,64,screen_height - 320,RGB(0,255,0),lpddsback);

		sprintf(buffer, "them pay for their tampering with the dead.  Find the inner sanctum of the lab and");
		Draw_Text_GDI(buffer,64,screen_height - 300,RGB(0,255,0),lpddsback);

		sprintf(buffer, "destroy everything.  (Press enter to continue)");
		Draw_Text_GDI(buffer,64,screen_height - 280,RGB(0,255,0),lpddsback);	 


		if(cutTimer == 0 && keyboard_state[DIK_RETURN])
		{
			temp = 1;
		}

		DDraw_Flip();
		Wait_Clock(30);
	}

	level = 2;

	WORLD_TILES = 112;
	WORLD_WIDTH = 44;     // add an extra column to the world so the program doesn't crash
	WORLD_MAX_WIDTH = ((WORLD_WIDTH) * 64);  // always keep world_width -1 so the program doesn't crash
	WORLD_MAX_HEIGHT = ((WORLD_TILES-1) * 64); // always keep world_tiles -1 so the program doesn't crash

	world_x = ((WORLD_MAX_WIDTH/2) - (WINDOW_WIDTH/2));
	world_y = (WORLD_MAX_HEIGHT - WINDOW_HEIGHT); // current position of viewing window
	
	Player.x = (WORLD_MAX_WIDTH/2)-32;
	Player.y = (WORLD_MAX_HEIGHT - (WINDOW_HEIGHT/2) - 16);
	Player.deathanim = 0;
	Player.object_ptr = new BOB;
	Clone_BOB(&mainchar, Player.object_ptr);
	Player.object_ptr->life = 3;
	Player.object_ptr->type = 0;
	face = "N";
	mouse_x = WORLD_MAX_WIDTH/2 - 16;
	mouse_y = WORLD_MAX_HEIGHT - (WINDOW_HEIGHT/2) - 16;

	///////////////************ BACKGROUND TILES *************////////////////////
	// load in texture maps
	Load_Bitmap_File(&bitmap16bit, "resources/backgroundtwo.bmp");

	// create the texture bob	
	if (FAILED(Create_BOB(&textures,0,0,64,64,30, BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME, DDSCAPS_VIDEOMEMORY,0,16)))
	{
		return(0);
	}

	// load each texture bitmap into the texture BOB object
	for (index = 0; index < 30; index++)
		Load_Frame_BOB16(&textures,&bitmap16bit,index,index%4,index/4,BITMAP_EXTRACT_MODE_CELL); 

	// unload the texture map bitmap
	Unload_Bitmap_File(&bitmap16bit);

	for (int index = 0; index < 256; index++)
	{
		Scenery[index].x = WORLD_MAX_WIDTH + 32;
		Scenery[index].y = WORLD_MAX_HEIGHT + 32; // these statements effectively 'clear' the array
		                                          // which holds scenery objects
	}

	for (int index = 0; index < 256; index++)
	{
		EnemyPos[index].x = WORLD_MAX_WIDTH + 32;
		EnemyPos[index].y = WORLD_MAX_HEIGHT + 32; // these statements effectively 'clear' the array
		                                           // which holds enemy monster objects
	}

	for (int index = 0; index < 256; index++)
	{
		FriendPos[index].x = WORLD_MAX_WIDTH + 32;
		FriendPos[index].y = WORLD_MAX_HEIGHT + 32; // these statements effectively 'clear' the array
		                                           // which holds friendly soldier objects
	}

	world.clear(); // clear the world vector

	vector<int> tempvec; // use a temporary vector for one line of the world vector
	tempvec.clear(); // clear it before use

	int templevel2[112][44] = 
	{
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,11,21,29,29,29,21,29,29,29,21,29,29,29,21,29,29,29,21,29,29,29,29,29,29,21,29,29,29,21,29,29,29,21,29,29,29,21,29,29,29,21,12,17},
		{17,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,17},
		{17,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,26,17},
		{17,27,0,0,0,15,20,28,28,20,16,0,0,0,15,20,28,28,20,16,0,0,0,0,0,15,20,28,28,20,16,0,0,15,20,28,28,20,16,0,0,0,26,17},
		{17,27,0,0,0,18,17,17,17,17,19,0,0,0,18,17,17,17,17,19,0,0,0,0,0,18,17,17,17,17,19,0,0,18,17,17,17,17,19,0,0,0,26,17},
		{17,19,0,0,0,26,17,17,17,17,27,0,0,0,26,17,17,17,17,27,0,0,0,0,0,26,17,17,17,17,27,0,0,26,17,17,17,17,27,0,0,0,18,17},
		{17,27,0,0,0,26,17,17,17,17,27,0,0,0,26,17,17,17,17,27,0,0,0,0,0,26,17,17,17,17,27,0,0,26,17,17,17,17,27,0,0,0,26,17},
		{17,27,0,0,0,18,17,17,17,17,19,0,0,0,18,17,17,17,17,19,0,0,0,0,0,18,17,17,17,17,19,0,0,18,17,17,17,17,19,0,0,0,26,17},
		{17,27,0,0,0,14,21,29,29,21,13,0,0,0,14,21,29,29,21,13,0,0,0,0,0,14,21,29,29,21,13,0,0,14,21,29,29,21,13,0,0,0,26,17},
		{17,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,17},
		{17,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,26,17},
		{17,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,26,17},
		{17,27,0,0,0,15,20,28,28,20,16,0,0,0,15,20,28,28,20,16,0,0,0,0,0,15,20,28,28,20,16,0,0,15,20,28,28,20,16,0,0,0,26,17},
		{17,19,0,0,0,18,17,17,17,17,19,0,0,0,18,17,17,17,17,19,0,0,0,0,0,18,17,17,17,17,19,0,0,18,17,17,17,17,19,0,0,0,18,17},
		{17,27,0,0,0,26,17,17,17,17,27,0,0,0,26,17,17,17,17,27,0,0,0,0,0,26,17,17,17,17,27,0,0,26,17,17,17,17,27,0,0,0,26,17},
		{17,27,0,0,0,26,17,17,17,17,27,0,0,0,26,17,17,17,17,27,0,0,0,0,0,26,17,17,17,17,27,0,0,26,17,17,17,17,27,0,0,0,26,17},
		{17,27,0,0,0,18,17,17,17,17,19,0,0,0,18,17,17,17,17,19,0,0,0,0,0,18,17,17,17,17,19,0,0,18,17,17,17,17,19,0,0,0,26,17},
		{17,19,0,0,0,14,21,29,29,21,13,0,0,0,14,21,29,29,21,13,0,0,0,0,0,14,21,29,29,21,13,0,0,14,21,29,29,21,13,0,0,0,18,17},
		{17,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,26,17},
		{17,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,26,17},
		{17,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,26,17},
		{17,19,0,0,0,15,20,28,28,20,16,0,0,0,15,20,28,28,20,16,0,0,0,0,0,15,20,28,28,20,16,0,0,15,20,28,28,20,16,0,0,0,18,17},
		{17,27,0,0,0,18,17,17,17,17,19,0,0,0,18,17,17,17,17,19,0,0,0,0,0,18,17,17,17,17,19,0,0,18,17,17,17,17,19,0,0,0,26,17},
		{17,27,0,0,0,26,17,17,17,17,27,0,0,0,26,17,17,17,17,27,0,0,0,0,0,26,17,17,17,17,27,0,0,26,17,17,17,17,27,0,0,0,26,17},
		{17,27,0,0,0,26,17,17,17,17,27,0,0,0,26,17,17,17,17,27,0,0,0,0,0,26,17,17,17,17,27,0,0,26,17,17,17,17,27,0,0,0,26,17},
		{17,19,0,0,0,18,17,17,17,17,19,0,0,0,18,17,17,17,17,19,0,0,0,0,0,18,17,17,17,17,19,0,0,18,17,17,17,17,19,0,0,0,18,17},
		{17,27,0,0,0,14,21,29,29,21,13,0,0,0,14,21,29,29,21,13,0,0,0,0,0,14,21,29,29,21,13,0,0,14,21,29,29,21,13,0,0,0,26,17},
		{17,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,26,17},
		{17,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,26,17},
		{17,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,17},
		{17,9,20,28,28,28,20,28,28,28,20,28,28,28,20,16,0,0,15,3,3,3,3,3,3,16,0,0,15,20,28,28,28,20,28,28,28,20,28,28,28,20,10,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,1,17,17,17,17,17,17,2,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,1,17,17,17,17,17,17,2,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,11,4,4,4,4,4,4,13,0,0,14,4,4,4,4,4,4,13,0,0,14,4,4,4,4,4,4,12,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,2,0,0,0,15,3,3,3,7,3,3,3,7,3,3,7,3,3,3,7,3,3,3,16,0,0,0,1,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,5,0,0,0,6,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,5,0,0,0,6,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,5,0,0,0,6,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,5,0,0,0,6,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,5,0,0,0,6,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,5,0,0,0,6,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,5,0,0,0,6,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,5,0,0,0,6,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,1,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,11,4,4,13,0,0,0,14,4,4,4,8,4,4,21,21,21,21,21,21,4,4,8,4,4,4,13,0,0,0,14,4,4,12,17,17,17,17,17},
		{17,17,17,17,17,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,17,17,17,17,17},
		{17,17,17,17,17,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,17,17,17,17,17},
		{17,17,17,17,17,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,17,17,17,17,17},
		{17,17,17,17,17,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,17,17,17,17,17},
		{17,17,17,17,17,2,0,0,0,0,15,3,7,3,3,3,7,3,3,20,24,28,28,24,20,3,3,7,3,3,3,7,3,16,0,0,0,0,1,17,17,17,17,17},
		{17,17,17,17,17,2,0,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,0,1,17,17,17,17,17},
		{17,17,17,17,17,5,0,0,0,0,6,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,5,0,0,0,0,6,17,17,17,17,17},
		{17,17,17,17,17,2,0,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,0,1,17,17,17,17,17},
		{17,17,17,17,17,2,0,0,0,0,14,4,8,4,4,4,8,4,4,21,25,29,25,25,21,4,4,8,4,4,4,8,4,13,0,0,0,0,1,17,17,17,17,17},
		{17,17,17,17,17,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,17,17,17,17,17},
		{17,17,17,17,17,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,17,17,17,17,17},
		{17,17,17,17,17,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,17,17,17,17,17},
		{17,17,17,17,17,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,17,17,17,17,17},
		{17,17,17,17,17,9,3,3,7,3,3,3,7,3,3,3,7,3,3,16,0,0,0,0,15,3,3,7,3,3,3,7,3,3,3,7,3,3,10,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,5,0,0,0,0,6,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,5,0,0,0,0,6,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,11,21,29,21,21,25,21,13,0,0,0,0,14,21,29,21,21,25,21,12,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,26,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,19,0,0,0,0,0,0,15,20,24,24,20,16,0,0,0,0,0,0,18,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,27,0,0,0,0,0,0,18,17,17,17,17,19,0,0,0,0,0,0,26,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,19,0,0,0,0,0,0,22,17,17,17,17,27,0,0,0,0,0,0,18,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,19,0,0,0,0,0,0,26,17,17,17,17,27,0,0,0,0,0,0,18,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,27,0,0,0,0,0,0,18,17,17,17,17,19,0,0,0,0,0,0,26,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,19,0,0,0,0,0,0,14,21,29,25,21,13,0,0,0,0,0,0,18,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,22,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,9,20,24,20,20,28,20,16,0,0,0,0,15,20,24,20,20,24,20,10,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,5,0,0,0,0,6,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,5,0,0,0,0,6,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,11,4,13,0,0,0,0,14,4,12,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,0,0,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,5,0,0,0,0,0,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,0,0,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,0,0,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,0,0,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,9,3,16,0,0,0,0,15,7,10,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17},
		{17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,2,0,0,0,0,1,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17}  // always include an extra row so the program doesn't crash
	};

	for(int a = 0; a < WORLD_TILES; a++)
	{
		for(int b = 0; b < WORLD_WIDTH; b++)
		{
			tempvec.push_back(templevel2[a][b]);
		}
		world.push_back(tempvec); // add this one dimensional vector to the world vector
		tempvec.clear(); // clear the temp vector
	}
	delete[] templevel2;

	for(int x = 0; x < 15; x++)
	{
		Add_Friend(random_range(1152, 1580), random_range(6720, 6976));
	}

	return(0);
}

int Load_Level_Three(void *parms)
{
	int index; // temporary integer used in for loop index variable
	int lives = 10;
	int temp = 0; // temporary integer used for cutscene display
	int cutTimer = 50; // countdown timer for the cutscene
	char buffer[256]; // used to print text
	endLevel = false;


	// show cutscene before the third level	

    while(temp == 0)
	{		
		cutTimer--;

		if(cutTimer < 0)
			cutTimer = 0;

		DInput_Read_Keyboard();

		Draw_Scaled_BOB16(&titlescreen, WINDOW_WIDTH, WINDOW_HEIGHT, lpddsback);

		sprintf(buffer, "The enemy's bio-experimentation lab lies in ruin.  This will only setback their evil plans");
		Draw_Text_GDI(buffer,64,screen_height - 320,RGB(0,255,0),lpddsback);

		sprintf(buffer, "as long as the enemy capital still stands.  Conquer the enemy capital city!");
		Draw_Text_GDI(buffer,64,screen_height - 300,RGB(0,255,0),lpddsback);

		sprintf(buffer, "(Press enter to continue)");
		Draw_Text_GDI(buffer,64,screen_height - 280,RGB(0,255,0),lpddsback);
		 


		if(cutTimer == 0 && keyboard_state[DIK_RETURN])
		{
			temp = 1;
		}

		DDraw_Flip();
		Wait_Clock(30);
	}

	level = 3;

	WORLD_TILES = 69;
	WORLD_WIDTH = 46;     // add an extra column to the world so the program doesn't crash
	WORLD_MAX_WIDTH = ((WORLD_WIDTH - 1) * 64);  // always keep world_width -1 so the program doesn't crash
	WORLD_MAX_HEIGHT = ((WORLD_TILES-1) * 64); // always keep world_tiles -1 so the program doesn't crash

	world_x = 0;
	world_y = (WORLD_MAX_HEIGHT - WINDOW_HEIGHT); // current position of viewing window
	
	Player.x = 300;
	Player.y = (WORLD_MAX_HEIGHT - (WINDOW_HEIGHT/2) - 16);
	Player.deathanim = 0;
	Player.object_ptr = new BOB;
	Clone_BOB(&mainchar, Player.object_ptr);
	Player.object_ptr->life = 3;
	Player.object_ptr->type = 0;
	face = "N";
	mouse_x = WORLD_MAX_WIDTH/2 - 16;
	mouse_y = WORLD_MAX_HEIGHT - (WINDOW_HEIGHT/2) - 16;

	///////////////************ BACKGROUND TILES *************////////////////////
	// load in texture maps
	Load_Bitmap_File(&bitmap16bit, "resources/backgroundthree.bmp");

	// create the texture bob	
	if (FAILED(Create_BOB(&textures,0,0,64,64,15, BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME, DDSCAPS_VIDEOMEMORY,0,16)))
	{
		return(0);
	}

	// load each texture bitmap into the texture BOB object
	for (index = 0; index < 15; index++)
		Load_Frame_BOB16(&textures,&bitmap16bit,index,index%4,index/4,BITMAP_EXTRACT_MODE_CELL); 

	// unload the texture map bitmap
	Unload_Bitmap_File(&bitmap16bit);

	//////////////************* BUILDINGS *******************///////////////////
	Load_Bitmap_File(&bitmap16bit, "resources/buildings.bmp");

	// create the buildings bob
	if (FAILED(Create_BOB(&buildings,0,0,841,1177,12, BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME, DDSCAPS_SYSTEMMEMORY,RGB16Bit565(170,160,156),16)))
	{
		return(0);
	}

	// load each building into the BOB object
	for (index = 0; index < 6; index++)
		Load_Frame_BOB16(&buildings,&bitmap16bit,index,index%2,index/2,BITMAP_EXTRACT_MODE_CELL);

	Unload_Bitmap_File(&bitmap16bit);

	Load_Bitmap_File(&bitmap16bit, "resources/buildings2.bmp");

	for (index = 0; index < 6; index++)
		Load_Frame_BOB16(&buildings,&bitmap16bit,index+6,index%2,index/2,BITMAP_EXTRACT_MODE_CELL);

	Unload_Bitmap_File(&bitmap16bit);

	Buildings[0].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[0].object_ptr);
	Buildings[0].object_ptr->curr_frame = 0;
	Buildings[0].object_ptr->type = 2;
	Buildings[0].x = -264;
	Buildings[0].y = -729;

	Buildings[1].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[1].object_ptr);
	Buildings[1].object_ptr->curr_frame = 4;
	Buildings[1].object_ptr->type = 2;
	Buildings[1].x = 362;
	Buildings[1].y = -729;

	Buildings[2].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[2].object_ptr);
	Buildings[2].object_ptr->curr_frame = 3;
	Buildings[2].object_ptr->type = 2;
	Buildings[2].x = 765;
	Buildings[2].y = -729;

	Buildings[3].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[3].object_ptr);
	Buildings[3].object_ptr->curr_frame = 2;
	Buildings[3].object_ptr->type = 2;
	Buildings[3].x = 1200;
	Buildings[3].y = -729;

	Buildings[4].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[4].object_ptr);
	Buildings[4].object_ptr->curr_frame = 5;
	Buildings[4].object_ptr->type = 2;
	Buildings[4].x = 1632;
	Buildings[4].y = -729;

	Buildings[5].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[5].object_ptr);
	Buildings[5].object_ptr->curr_frame = 1;
	Buildings[5].object_ptr->type = 2;
	Buildings[5].x = 2064;
	Buildings[5].y = -729;

	Buildings[6].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[6].object_ptr);
	Buildings[6].object_ptr->curr_frame = 1;
	Buildings[6].object_ptr->type = 2;
	Buildings[6].x = -532;
	Buildings[6].y = 480;

	Buildings[7].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[7].object_ptr);
	Buildings[7].object_ptr->curr_frame = 2;
	Buildings[7].object_ptr->type = 2;
	Buildings[7].x = -580;
	Buildings[7].y = 1260;

	Buildings[8].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[8].object_ptr);
	Buildings[8].object_ptr->curr_frame = 4;
	Buildings[8].object_ptr->type = 2;
	Buildings[8].x = 10;
	Buildings[8].y = 1320;

	Buildings[9].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[9].object_ptr);
	Buildings[9].object_ptr->curr_frame = 3;
	Buildings[9].object_ptr->type = 2;
	Buildings[9].x = 366;
	Buildings[9].y = 1550;

	Buildings[10].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[10].object_ptr);
	Buildings[10].object_ptr->curr_frame = 0;
	Buildings[10].object_ptr->type = 2;
	Buildings[10].x = 366;
	Buildings[10].y = 2080;

	Buildings[11].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[11].object_ptr);
	Buildings[11].object_ptr->curr_frame = 1;
	Buildings[11].object_ptr->type = 2;
	Buildings[11].x = 366;
	Buildings[11].y = 2652;

	Buildings[12].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[12].object_ptr);
	Buildings[12].object_ptr->curr_frame = 10;
	Buildings[12].object_ptr->type = 2;
	Buildings[12].x = 1674;
	Buildings[12].y = 1325;

	Buildings[13].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[13].object_ptr);
	Buildings[13].object_ptr->curr_frame = 9;
	Buildings[13].object_ptr->type = 2;
	Buildings[13].x = 1674;
	Buildings[13].y = 1600;

	Buildings[14].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[14].object_ptr);
	Buildings[14].object_ptr->curr_frame = 8;
	Buildings[14].object_ptr->type = 2;
	Buildings[14].x = 1674;
	Buildings[14].y = 2170;

	Buildings[15].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[15].object_ptr);
	Buildings[15].object_ptr->curr_frame = 7;
	Buildings[15].object_ptr->type = 2;
	Buildings[15].x = 1674;
	Buildings[15].y = 2652;

	Buildings[16].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[16].object_ptr);
	Buildings[16].object_ptr->curr_frame = 9;
	Buildings[16].object_ptr->type = 2;
	Buildings[16].x = 585;
	Buildings[16].y = 177;

	Buildings[17].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[17].object_ptr);
	Buildings[17].object_ptr->curr_frame = 5;
	Buildings[17].object_ptr->type = 2;
	Buildings[17].x = 1150;
	Buildings[17].y = 482;

	Buildings[18].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[18].object_ptr);
	Buildings[18].object_ptr->curr_frame = 9;
	Buildings[18].object_ptr->type = 2;
	Buildings[18].x = 1204;
	Buildings[18].y = 482;

	Buildings[19].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[19].object_ptr);
	Buildings[19].object_ptr->curr_frame = 11;
	Buildings[19].object_ptr->type = 2;
	Buildings[19].x = 585;
	Buildings[19].y = 482;

	Buildings[20].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[20].object_ptr);
	Buildings[20].object_ptr->curr_frame = 3;
	Buildings[20].object_ptr->type = 2;
	Buildings[20].x = 1450;
	Buildings[20].y = 482;

	Buildings[21].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[21].object_ptr);
	Buildings[21].object_ptr->curr_frame = 7;
	Buildings[21].object_ptr->type = 2;
	Buildings[21].x = 2582;
	Buildings[21].y = 482;

	Buildings[22].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[22].object_ptr);
	Buildings[22].object_ptr->curr_frame = 0;
	Buildings[22].object_ptr->type = 2;
	Buildings[22].x = -264;
	Buildings[22].y = 3900;

	Buildings[23].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[23].object_ptr);
	Buildings[23].object_ptr->curr_frame = 4;
	Buildings[23].object_ptr->type = 2;
	Buildings[23].x = 362;
	Buildings[23].y = 3550;

	Buildings[24].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[24].object_ptr);
	Buildings[24].object_ptr->curr_frame = 3;
	Buildings[24].object_ptr->type = 2;
	Buildings[24].x = 765;
	Buildings[24].y = 3830;

	Buildings[25].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[25].object_ptr);
	Buildings[25].object_ptr->curr_frame = 2;
	Buildings[25].object_ptr->type = 2;
	Buildings[25].x = 1200;
	Buildings[25].y = 3500;

	Buildings[26].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[26].object_ptr);
	Buildings[26].object_ptr->curr_frame = 5;
	Buildings[26].object_ptr->type = 2;
	Buildings[26].x = 1632;
	Buildings[26].y = 3600;

	Buildings[27].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[27].object_ptr);
	Buildings[27].object_ptr->curr_frame = 1;
	Buildings[27].object_ptr->type = 2;
	Buildings[27].x = 2064;
	Buildings[27].y = 3850;

	Buildings[28].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[28].object_ptr);
	Buildings[28].object_ptr->curr_frame = 3;
	Buildings[28].object_ptr->type = 2;
	Buildings[28].x = -460;
	Buildings[28].y = 2652;

	Buildings[29].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[29].object_ptr);
	Buildings[29].object_ptr->curr_frame = 2;
	Buildings[29].object_ptr->type = 2;
	Buildings[29].x = -45;
	Buildings[29].y = 2652;

	Buildings[30].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[30].object_ptr);
	Buildings[30].object_ptr->curr_frame = 11;
	Buildings[30].object_ptr->type = 2;
	Buildings[30].x = 2684;
	Buildings[30].y = 2652;

	Buildings[31].object_ptr = new BOB;
	Clone_BOB(&buildings, Buildings[31].object_ptr);
	Buildings[31].object_ptr->curr_frame = 8;
	Buildings[31].object_ptr->type = 2;
	Buildings[31].x = 2314;
	Buildings[31].y = 2652;

	BUILDING_HIGH = 32;

	for (int index = 0; index < 256; index++)
	{
		Scenery[index].x = WORLD_MAX_WIDTH + 32;
		Scenery[index].y = WORLD_MAX_HEIGHT + 32; // these statements effectively 'clear' the array
		                                          // which holds scenery objects
	}

	for (int index = 0; index < 256; index++)
	{
		EnemyPos[index].x = WORLD_MAX_WIDTH + 32;
		EnemyPos[index].y = WORLD_MAX_HEIGHT + 32; // these statements effectively 'clear' the array
		                                           // which holds enemy monster objects
	}

	for (int index = 0; index < 256; index++)
	{
		FriendPos[index].x = WORLD_MAX_WIDTH + 32;
		FriendPos[index].y = WORLD_MAX_HEIGHT + 32; // these statements effectively 'clear' the array
		                                           // which holds friendly soldier objects
	}

	world.clear(); // clear the world vector

	vector<int> tempvec; // use a temporary vector for one line of the world vector
	tempvec.clear(); // clear it before use

	int templevel3[69][45] = 
	{
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
		{10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10},
		{10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10},
		{3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3},
		{2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
		{10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10},
		{10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10},
		{3,3,3,3,3,6,13,13,7,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,6,13,13,7,3,3,3,3,3},
		{8,8,8,8,8,0,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,1,8,8,8,8,8},
		{8,8,8,8,8,0,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,1,8,8,8,8,8},
		{8,8,8,8,8,0,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,1,8,8,8,8,8},
		{8,8,8,8,8,0,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,1,8,8,8,8,8},
		{8,8,8,8,8,0,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,1,8,8,8,8,8},
		{8,8,8,8,8,0,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,1,8,8,8,8,8},
		{8,8,8,8,8,0,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,1,8,8,8,8,8},
		{8,8,8,8,8,0,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,1,8,8,8,8,8},
		{8,8,8,8,8,0,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,1,8,8,8,8,8},
		{8,8,8,8,8,0,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,1,8,8,8,8,8},
		{8,8,8,8,8,0,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,1,8,8,8,8,8},
		{2,2,2,2,2,4,13,13,5,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,4,13,13,5,2,2,2,2,2},
		{10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10},
		{12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12},
		{10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10},
		{3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,6,13,13,13,13,13,7,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0,9,9,11,9,9,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,4,13,13,13,13,13,5,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
		{10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10},
		{12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12},
		{10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10},
		{3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
		{8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8},
	};

	for(int a = 0; a < WORLD_TILES; a++)
	{
		for(int b = 0; b < WORLD_WIDTH; b++)
		{
			tempvec.push_back(templevel3[a][b]);
		}
		world.push_back(tempvec); // add this one dimensional vector to the world vector
		tempvec.clear(); // clear the temp vector
	}
	delete[] templevel3;

	for(int x = 0; x < 30; x++)
	{
		Add_Friend(random_range(0, 400), random_range(3904, 4160));
	}

	for(int x = 0; x < 100; x++)
	{
		Add_Enemy(random_range(600, WORLD_MAX_WIDTH - 32), random_range(3904, 4160), random_range(1,3));
	}

	return 0;
}

int Shot_Line(int origin_x, int origin_y, int target_x, int target_y, int shoottype)
{
	int x = origin_x;
	int y = origin_y;
	int dx = target_x - origin_x;
	int dy = target_y - origin_y;
	int islope;
	float fslope;
	float decimal;
	float error = 0;

	if((dx == 0) && (dy == 0))		// if targeting the player just stop
		return(0);
	else if((dx == 0) && (dy > 0))	// shooting straight down
	{
		for(y; y < target_y; y++)
		{
			if(world_ptrs[x][y] != NULL)
			{
				if(world_ptrs[x][y]->type == shoottype)
					Damage_BOB(world_ptrs[x][y], random_range(1, 3));
				else if(world_ptrs[x][y]->type == 2)
					return(0);
			}
		}
	}
	else if((dx == 0) && (dy < 0))	// shooting straight up
	{
		for(y; y > target_y; y--) 
		{
			if(world_ptrs[x][y] != NULL)
			{
				if(world_ptrs[x][y]->type == shoottype)
					Damage_BOB(world_ptrs[x][y], random_range(1, 3));
				else if(world_ptrs[x][y]->type == 2)
					return(0);
			}
		}
	}
	else if((dy == 0) && (dx > 0)) // shooting due east
	{
		for(x; x < target_x; x++)
		{
			if(world_ptrs[x][y] != NULL)
			{
				if(world_ptrs[x][y]->type == shoottype)
					Damage_BOB(world_ptrs[x][y], random_range(1, 3));
				else if(world_ptrs[x][y]->type == 2)
					return(0);
			}
		}
	}
	else if((dy == 0) && (dx < 0)) // shooting due west
	{
		for(x; x > target_x; x--)
		{
			if(world_ptrs[x][y] != NULL)
			{
				if(world_ptrs[x][y]->type == shoottype)
					Damage_BOB(world_ptrs[x][y], random_range(1, 3));
				else if(world_ptrs[x][y]->type == 2)
					return(0);
			}
		}
	}		
	else if((dx > 0) && (dy > 0))
	{
		if(dx > dy)
		{
			if(dy != 0)
				fslope = dx/dy;
			else
				fslope = 0;

			islope = int(fslope);
			decimal = (fslope - float(islope));
			error += decimal;

			for(y; y < target_y; y++)
			{
				for(int tempx = 0; tempx < islope; tempx++)
				{
					if(error >= 1)
					{
						x++;
						if(world_ptrs[x][y] != NULL)
						{	
							if(world_ptrs[x][y]->type == shoottype)
								Damage_BOB(world_ptrs[x][y], random_range(1, 3));
							else if(world_ptrs[x][y]->type == 2)
								return(0);
						}
						error -= 1;
						tempx++;
					}

					if(world_ptrs[x][y] != NULL)
					{
						if(world_ptrs[x][y]->type == shoottype)
							Damage_BOB(world_ptrs[x][y], random_range(1, 3));
						else if(world_ptrs[x][y]->type == 2)
							return(0);
					}
					x++;
					error += decimal;
				}
			}
		}
		else
		{
			if(dx != 0)
				fslope = dy/dx;
			else
				fslope = 0;

			islope = int(fslope);
			decimal = (fslope - float(islope));
			error += decimal;

			for(x; x < target_x; x++)
			{
				for(int tempy = 0; tempy < islope; tempy++)
				{
					if(error >= 1)
					{
						y++;
						if(world_ptrs[x][y] != NULL)
						{
							if(world_ptrs[x][y]->type == shoottype)
								Damage_BOB(world_ptrs[x][y], random_range(1, 3));
							else if(world_ptrs[x][y]->type == 2)
								return(0);
						}
						error -= 1;
						tempy++;
					}

					if(world_ptrs[x][y] != NULL)
					{
						if(world_ptrs[x][y]->type == shoottype)
							Damage_BOB(world_ptrs[x][y], random_range(1, 3));
						else if(world_ptrs[x][y]->type == 2)
							return(0);
					}
					y++;
					error += decimal;
				}
			}
		}
	}
	else if((dx > 0) && (dy < 0))
	{
		if(dx > -dy)
		{
			if(dy != 0)
				fslope = dx/dy;
			else
				fslope = 0;

			islope = int(-fslope);
			decimal = (fslope - float(islope));
			error += decimal;

			for(y; y > target_y; y--)
			{
				for(int tempx = 0; tempx < islope; tempx++)
				{
					if(error >= 1)
					{
						x++;
						if(world_ptrs[x][y] != NULL)
						{	
							if(world_ptrs[x][y]->type == shoottype)
								Damage_BOB(world_ptrs[x][y], random_range(1, 3));
							else if(world_ptrs[x][y]->type == 2)
								return(0);
						}
						error -= 1;
						tempx++;
					}

					if(world_ptrs[x][y] != NULL)
					{
						if(world_ptrs[x][y]->type == shoottype)
							Damage_BOB(world_ptrs[x][y], random_range(1, 3));
						else if(world_ptrs[x][y]->type == 2)
							return(0);
					}
					x++;
					error += decimal;
				}
			}
		}
		else
		{
			if(dx != 0)
				fslope = dy/dx;
			else
				fslope = 0;

			islope = int(-fslope);
			decimal = (fslope - float(islope));
			error += decimal;

			for(x; x < target_x; x++)
			{
				for(int tempy = 0; tempy < islope; tempy++)
				{
					if(error >= 1)
					{
						y--;
						if(world_ptrs[x][y] != NULL)
						{
							if(world_ptrs[x][y]->type == shoottype)
								Damage_BOB(world_ptrs[x][y], random_range(1, 3));
							else if(world_ptrs[x][y]->type == 2)
								return(0);
						}
						error -= 1;
						tempy++;
					}

					if(world_ptrs[x][y] != NULL)
					{
						if(world_ptrs[x][y]->type == shoottype)
							Damage_BOB(world_ptrs[x][y], random_range(1, 3));
						else if(world_ptrs[x][y]->type == 2)
							return(0);
					}
					y--;
					error += decimal;
				}
			}
		}
	}
	else if((dx < 0) && (dy > 0))
	{
		if(dx < dy)
		{
			if(dy != 0)
				fslope = dx/dy;
			else
				fslope = 0;

			islope = int(-fslope);
			decimal = (fslope - float(islope));
			error += decimal;

			for(y; y < target_y; y++)
			{
				for(int tempx = 0; tempx < islope; tempx++)
				{
					if(error >= 1)
					{
						x--;
						if(world_ptrs[x][y] != NULL)
						{	
							if(world_ptrs[x][y]->type == shoottype)
								Damage_BOB(world_ptrs[x][y], random_range(1, 3));
							else if(world_ptrs[x][y]->type == 2)
								return(0);
						}
						error -= 1;
						tempx++;
					}

					if(world_ptrs[x][y] != NULL)
					{
						if(world_ptrs[x][y]->type == shoottype)
							Damage_BOB(world_ptrs[x][y], random_range(1, 3));
						else if(world_ptrs[x][y]->type == 2)
							return(0);
					}
					x--;
					error += decimal;
				}
			}
		}
		else
		{
			if(dx != 0)
				fslope = dy/dx;
			else
				fslope = 0;

			islope = int(fslope);
			decimal = (fslope - float(islope));
			error += decimal;

			for(x; x > target_x; x--)
			{
				for(int tempy = 0; tempy < islope; tempy++)
				{
					if(error >= 1)
					{
						y++;
						if(world_ptrs[x][y] != NULL)
						{
							if(world_ptrs[x][y]->type == shoottype)
								Damage_BOB(world_ptrs[x][y], random_range(1, 3));
							else if(world_ptrs[x][y]->type == 2)
								return(0);
						}
						error -= 1;
						tempy++;
					}

					if(world_ptrs[x][y] != NULL)
					{
						if(world_ptrs[x][y]->type == shoottype)
							Damage_BOB(world_ptrs[x][y], random_range(1, 3));
						else if(world_ptrs[x][y]->type == 2)
							return(0);
					}
					y++;
					error += decimal;
				}
			}
		}
	}
	else if((dx < 0) && (dy < 0))
	{
		if(dx < dy)
		{
			if(dy != 0)
				fslope = dx/dy;
			else
				fslope = 0;

			islope = int(fslope);
			decimal = (fslope - float(islope));
			error += decimal;

			for(y; y > target_y; y--)
			{
				for(int tempx = 0; tempx < islope; tempx++)
				{
					if(error >= 1)
					{
						x--;
						if(world_ptrs[x][y] != NULL)
						{	
							if(world_ptrs[x][y]->type == shoottype)
								Damage_BOB(world_ptrs[x][y], random_range(1, 3));
							else if(world_ptrs[x][y]->type == 2)
								return(0);
						}
						error -= 1;
						tempx++;
					}

					if(world_ptrs[x][y] != NULL)
					{
						if(world_ptrs[x][y]->type == shoottype)
							Damage_BOB(world_ptrs[x][y], random_range(1, 3));
						else if(world_ptrs[x][y]->type == 2)
							return(0);
					}
					x--;
					error += decimal;
				}
			}
		}
		else
		{
			if(dx != 0)
				fslope = dy/dx;
			else
				fslope = 0;

			islope = int(fslope);
			decimal = (fslope - float(islope));
			error += decimal;

			for(x; x > target_x; x--)
			{
				for(int tempy = 0; tempy < islope; tempy++)
				{
					if(error >= 1)
					{
						y--;
						if(world_ptrs[x][y] != NULL)
						{
							if(world_ptrs[x][y]->type == shoottype)
								Damage_BOB(world_ptrs[x][y], random_range(1, 3));
							else if(world_ptrs[x][y]->type == 2)
								return(0);
						}
						error -= 1;
						tempy++;
					}

					if(world_ptrs[x][y] != NULL)
					{
						if(world_ptrs[x][y]->type == shoottype)
							Damage_BOB(world_ptrs[x][y], random_range(1, 3));
						else if(world_ptrs[x][y]->type == 2)
							return(0);
					}
					y--;
					error += decimal;
				}
			}
		}
	}

	return(0);
}

void Soldier_Action(OBJECTS &Soldier)
{
	bool move = true;
	int next = random_range(0, 4);
	int closest = 0;
	int distance = 10000;

	if(Soldier.type == 1)
	{
		if(Soldier.action_timer > 0)
		{
			if(Soldier.action == "walking")
			{
				if(Soldier.soldier_face == "N")
				{
					for(int x = (Soldier.x + 3); x < (Soldier.x + 24); x++)
					{
						if(world_ptrs[x][(Soldier.y+6) - 2] != NULL)
						{
							move = false;
							Soldier.action_timer = 0;
						}
					}
					if(Soldier.object_ptr->curr_animation != 0)
						Set_Animation_BOB(Soldier.object_ptr, 0);
					if(move == true)
						Soldier.y -= 2;
				}
				else if(Soldier.soldier_face == "E")
				{
					for(int y = (Soldier.y - 6); y < (Soldier.y + 24); y++)
					{
						if(world_ptrs[(Soldier.x+21) + 2][y] != NULL)
						{
							move = false;
							Soldier.action_timer = 0;
						}
					}
					if(Soldier.object_ptr->curr_animation != 2)
						Set_Animation_BOB(Soldier.object_ptr, 2);
					if(move == true)
						Soldier.x += 2;
				}
				else if(Soldier.soldier_face == "S")
				{
					for(int x = Soldier.x + 3; x < (Soldier.x + 24); x++)
					{
						if(world_ptrs[x][(Soldier.y+28) + 2] != NULL)
						{
							move = false;
							Soldier.action_timer = 0;
						}
					}
					if(Soldier.object_ptr->curr_animation != 4)
						Set_Animation_BOB(Soldier.object_ptr, 4);
					if(move == true)
						Soldier.y += 2;
				}
				else if(Soldier.soldier_face == "W")
				{
					for(int y = (Soldier.y - 6); y < (Soldier.y + 24); y++)
					{
						if(world_ptrs[(Soldier.x -3) - 2][y] != NULL)
						{
							move = false;
							Soldier.action_timer = 0;
						}
					}
					if(Soldier.object_ptr->curr_animation != 6)
						Set_Animation_BOB(Soldier.object_ptr, 6);
					if(move == true)
						Soldier.x -= 2;
				}
			}
			else if(Soldier.action == "shooting")
			{
				float mx1 = (Soldier.target_x - Soldier.x - 16);
				float my1 = -(Soldier.target_y - Soldier.y - 16);
				int quad;

				if(mx1 > 0)
				{
					if(my1 >= 0)
						quad = 1;
					else if(my1 < 0)
						quad = 4;
				}
				else if(mx1 <= 0)
				{
					if(my1 > 0)
						quad = 2;
					else if(my1 <= 0)
						quad = 3;
				}

				float angle;
				if((mx1 != 0) || (my1 != 0))
					angle = Get_Angle(mx1, my1, quad);
				else
					angle = 90;
				
				if(((angle >= 330) || (angle <= 30)))
				{
					if(Soldier.object_ptr->curr_animation != 17)
						Set_Animation_BOB(Soldier.object_ptr, 17);
				}
				else if((angle > 30) && (angle < 60))
				{
					if(Soldier.object_ptr->curr_animation != 24)
						Set_Animation_BOB(Soldier.object_ptr, 24);
				}
				else if((angle >= 60) && (angle <= 120))
				{
					if(Soldier.object_ptr->curr_animation != 16)
						Set_Animation_BOB(Soldier.object_ptr, 16);
				}
				else if((angle > 120) && (angle < 150))
				{
					if(Soldier.object_ptr->curr_animation != 27)
						Set_Animation_BOB(Soldier.object_ptr, 27);
				}
				else if((angle >= 150) && (angle <= 210))
				{
					if(Soldier.object_ptr->curr_animation != 19)
						Set_Animation_BOB(Soldier.object_ptr, 19);
				}
				else if((angle > 210) && (angle < 240))
				{
					if(Soldier.object_ptr->curr_animation != 26)
						Set_Animation_BOB(Soldier.object_ptr, 26);
				}
				else if((angle >= 240) && (angle <= 300))
				{
					if(Soldier.object_ptr->curr_animation != 18)
						Set_Animation_BOB(Soldier.object_ptr, 18);
				}
				else if((angle > 300) && (angle < 330))
				{
					if(Soldier.object_ptr->curr_animation != 25)
						Set_Animation_BOB(Soldier.object_ptr, 25);
				}
					
				int safex = Soldier.target_x + random_range(-50, 50);
				int safey = Soldier.target_y + random_range(-50, 50);
				
				if(safex < 0)
					safex = 0;
				else if(safex >= WORLD_MAX_WIDTH)
					safex = WORLD_MAX_WIDTH - 1;
				
				if(safey < 0)
					safey = 0;
				else if(safey >= WORLD_MAX_HEIGHT)
					safey = WORLD_MAX_HEIGHT - 1;

				if(Soldier.playshot >= 2)
				{
					Soldier.playshot = 0;
					Soldier_Shot(soldiershotindex);
					if(Soldier.object_ptr->type == 0)
						Shot_Line(Soldier.x, Soldier.y, safex, safey, 1);
					else if(Soldier.object_ptr->type == 1)
						Shot_Line(Soldier.x, Soldier.y, safex, safey, 0);
				}
				else
					Soldier.playshot++;
			}



			if(Soldier.x <= world_x)
				Soldier.soldier_face = "E";
			else if(Soldier.x >= (world_x + SCREEN_WIDTH))
				Soldier.soldier_face = "W";
				
			if(Soldier.y <= world_y) 
				Soldier.soldier_face = "S";
			else if(Soldier.y >= (world_y + SCREEN_HEIGHT))
				Soldier.soldier_face = "N";

				Soldier.action_timer--;
		}
		else if(Soldier.action_timer <= 0)
		{
			Soldier.action_timer = random_range(30, 100);

			if(next == 0)
			{
				Soldier.soldier_face = "N";
				Soldier.action = "walking";
				Set_Anim_Speed_BOB(Soldier.object_ptr, 4);
			}
			else if(next == 1)
			{
				Soldier.soldier_face = "E";
				Soldier.action = "walking";
				Set_Anim_Speed_BOB(Soldier.object_ptr, 4);
			}
			else if(next == 2)
			{
				Soldier.soldier_face = "S";
				Soldier.action = "walking";
				Set_Anim_Speed_BOB(Soldier.object_ptr, 4);
			}
			else if(next == 3)
			{
				Soldier.soldier_face = "W";
				Soldier.action = "walking";
				Set_Anim_Speed_BOB(Soldier.object_ptr, 4);
			}
			
			if(next == 4)
			{
				if(Soldier.object_ptr->type == 0)
				{
					for(int index=ENEMY_LOW; index < ENEMY_HIGH; index++)
					{
						int x0 = EnemyPos[index].x;
						int y0 = EnemyPos[index].y;

						// now translate to screen coords, could have done above, but clearer
						x0 = x0 - world_x;
						y0 = y0 - world_y;
						
						// compute size
						int width = EnemyPos[index].object_ptr->width;
						int height = EnemyPos[index].object_ptr->height;

						// compute extents based on width,height
						int x1 = x0 + width - 1;
						int y1 = y0 + height - 1;

						// do clip trivial clip
						if ( (x0 >= WINDOW_WIDTH) || (x1 < 0) || (y0 >= WINDOW_HEIGHT) || (y1 < 0))
						continue; // don't need to render this one
						else
						{
							if(EnemyPos[index].object_ptr->curr_frame != 122)
							{
								int tempdistance = Fast_Distance_2D(Soldier.x - EnemyPos[index].x, Soldier.y - EnemyPos[index].y);
								if(tempdistance <= distance)
								{
									distance = tempdistance;
									closest = index;
								}
							}
						}
					}
					if(distance == 10000)
					{
						Soldier.action_timer = 0;
					}
					else
					{
						Soldier.target_x = EnemyPos[closest].x;
						Soldier.target_y = EnemyPos[closest].y;
					}

				}
				else if (Soldier.object_ptr->type == 1)
				{
					for(int index=FRIEND_LOW; index < FRIEND_HIGH; index++)
					{
						int x0 = FriendPos[index].x;
						int y0 = FriendPos[index].y;

						// now translate to screen coords, could have done above, but clearer
						x0 = x0 - world_x;
						y0 = y0 - world_y;
						
						// compute size
						int width = FriendPos[index].object_ptr->width;
						int height = FriendPos[index].object_ptr->height;

						// compute extents based on width,height
						int x1 = x0 + width - 1;
						int y1 = y0 + height - 1;

						// do clip trivial clip
						if ( (x0 >= WINDOW_WIDTH) || (x1 < 0) || (y0 >= WINDOW_HEIGHT) || (y1 < 0))
						continue; // don't need to render this one
						else
						{
							if(FriendPos[index].object_ptr->curr_frame != 122)
							{
								int tempdistance = Fast_Distance_2D(Soldier.x - FriendPos[index].x, Soldier.y - FriendPos[index].y);
								if(tempdistance <= distance)
								{
									distance = tempdistance;
									closest = index;
								}
							}
						}
					}

					int tempdistance = Fast_Distance_2D(Soldier.x - Player.x, Soldier.y - Player.y);
					
					if ((tempdistance <= distance) && (Player.object_ptr->curr_frame != 122))
					{
						Soldier.target_x = Player.x;
						Soldier.target_y = Player.y;
					}
					else
					{
						Soldier.target_x = FriendPos[closest].x;
						Soldier.target_y = FriendPos[closest].y;
					}
				}
				Soldier.action = "shooting";
				Soldier.playshot = 2;
				Set_Anim_Speed_BOB(Soldier.object_ptr, 2);
			}
				
		}


	}
	else if(Soldier.type == 2)
	{
		if(Soldier.action_timer > 0)
		{
			float mx1 = (Soldier.target_x - Soldier.x - 16);
			float my1 = -(Soldier.target_y - Soldier.y - 16);
			int quad;

			Soldier.action_timer--;

			if(mx1 > 0)
			{
				if(my1 >= 0)
					quad = 1;
				else if(my1 < 0)
					quad = 4;
			}
			else if(mx1 <= 0)
			{
				if(my1 > 0)
					quad = 2;
				else if(my1 <= 0)
					quad = 3;
			}

			float angle;
			if((mx1 != 0) || (my1 != 0))
				angle = Get_Angle(mx1, my1, quad);
			else
				angle = 90;
			
			if((angle >= 330) || (angle <= 30))
			{
				for(int x = (Soldier.x + 3); x < (Soldier.x + 24); x++)
				{
					if(world_ptrs[x][(Soldier.y+6) - 4] != NULL)
					{
						if(world_ptrs[x][Soldier.y - 4]->type == 0)
							Damage_BOB(world_ptrs[x][Soldier.y+6 - 4], 10);
						else
						{
							move = false;
							Soldier.action_timer = 0;
						}
					}
				}
				if(Soldier.object_ptr->curr_animation != 0)
					Set_Animation_BOB(Soldier.object_ptr, 0);
				if(move == true)
					Soldier.y -= 4;
			}
			else if((angle > 30) && (angle < 60))
			{
				for(int x = (Soldier.x + 3); x < (Soldier.x + 24); x++)
				{
					if(world_ptrs[x][(Soldier.y+6) - 2] != NULL)
					{
						if(world_ptrs[x][Soldier.y+6 - 2]->type == 0)
							Damage_BOB(world_ptrs[x][Soldier.y+6 - 2], 10);
						else
						{
							move = false;
							Soldier.action_timer = 0;
						}
					}
				}
				if(Soldier.object_ptr->curr_animation != 8)
					Set_Animation_BOB(Soldier.object_ptr, 8);
				if(move == true)
					Soldier.y -= 2;
				move = true;
				for(int y = (Soldier.y - 6); y < (Soldier.y + 24); y++)
				{
					if(world_ptrs[(Soldier.x+21) + 2][y] != NULL)
					{
						if(world_ptrs[Soldier.x+21 + 2][y]->type == 0)
							Damage_BOB(world_ptrs[Soldier.x+21 + 2][y], 10);
						else
						{
							move = false;
							Soldier.action_timer = 0;
						}
					}
				}
				if(move == true)
					Soldier.x += 2;
			}
			else if((angle >= 60) && (angle <= 120))
			{
				for(int y = (Soldier.y - 6); y < (Soldier.y + 24); y++)
				{
					if(world_ptrs[(Soldier.x+21) + 4][y] != NULL)
					{
						if(world_ptrs[Soldier.x+21 + 4][y]->type == 0)
							Damage_BOB(world_ptrs[Soldier.x+21 + 4][y], 10);
						else
						{
							move = false;
							Soldier.action_timer = 0;
						}
					}
				}
				if(Soldier.object_ptr->curr_animation != 2)
					Set_Animation_BOB(Soldier.object_ptr, 2);
				if(move == true)
					Soldier.x += 4;
			}
			else if((angle > 120) && (angle < 150))
			{
				for(int x = Soldier.x + 3; x < (Soldier.x + 24); x++)
				{
					if(world_ptrs[x][(Soldier.y+28) + 2] != NULL)
					{
						if(world_ptrs[x][Soldier.y+28 + 2]->type == 0)
							Damage_BOB(world_ptrs[x][Soldier.y+28 + 2], 10);
						else
						{
							move = false;
							Soldier.action_timer = 0;
						}
					}
				}
				if(Soldier.object_ptr->curr_animation != 10)
					Set_Animation_BOB(Soldier.object_ptr, 10);
				if(move == true)
					Soldier.y += 2;
				move = true;
				for(int y = (Soldier.y - 6); y < (Soldier.y + 24); y++)
				{
					if(world_ptrs[(Soldier.x+21) + 2][y] != NULL)
					{
						if(world_ptrs[Soldier.x+21 + 2][y]->type == 0)
							Damage_BOB(world_ptrs[Soldier.x+21 + 2][y], 10);
						else
						{
							move = false;
							Soldier.action_timer = 0;
						}
					}
				}
				if(move == true)
					Soldier.x += 2;
			}
			else if((angle >= 150) && (angle <= 210))
			{
				for(int x = Soldier.x + 3; x < (Soldier.x + 24); x++)
				{
					if(world_ptrs[x][(Soldier.y+28) + 4] != NULL)
					{
						if(world_ptrs[x][Soldier.y+28 + 4]->type == 0)
							Damage_BOB(world_ptrs[x][Soldier.y+28 + 4], 10);
						else
						{
							move = false;
							Soldier.action_timer = 0;
						}
					}
				}
				if(Soldier.object_ptr->curr_animation != 4)
					Set_Animation_BOB(Soldier.object_ptr, 4);
				if(move == true)
					Soldier.y += 4;
			}
			else if((angle > 210) && (angle < 240))
			{
				for(int y = (Soldier.y - 6); y < (Soldier.y + 24); y++)
				{
					if(world_ptrs[(Soldier.x +3) - 2][y] != NULL)
					{
						if(world_ptrs[Soldier.x+3 - 2][y]->type == 0)
							Damage_BOB(world_ptrs[Soldier.x+3 - 2][y], 10);
						else
						{
							move = false;
							Soldier.action_timer = 0;
						}
					}
				}
				if(Soldier.object_ptr->curr_animation != 12)
					Set_Animation_BOB(Soldier.object_ptr, 12);
				if(move == true)
					Soldier.x -= 2;
				move = true;
				for(int x = Soldier.x + 3; x < (Soldier.x + 24); x++)
				{
					if(world_ptrs[x][(Soldier.y+28) + 2] != NULL)
					{
						if(world_ptrs[x][Soldier.y+28 + 2]->type == 0)
							Damage_BOB(world_ptrs[x][Soldier.y+28 + 2], 10);
						else
						{
							move = false;
							Soldier.action_timer = 0;
						}
					}
				}
				if(move == true)
					Soldier.y += 2;
			}
			else if((angle >= 240) && (angle <= 300))
			{
				for(int y = (Soldier.y - 6); y < (Soldier.y + 24); y++)
				{
					if(world_ptrs[(Soldier.x +3) - 4][y] != NULL)
					{
						if(world_ptrs[Soldier.x + 3 - 4][y]->type == 0)
							Damage_BOB(world_ptrs[Soldier.x-3 - 4][y], 10);
						else
						{
							move = false;
							Soldier.action_timer = 0;
						}
					}
				}
				if(Soldier.object_ptr->curr_animation != 6)
					Set_Animation_BOB(Soldier.object_ptr, 6);
				if(move == true)
					Soldier.x -= 4;
			}
			else if((angle > 300) && (angle < 330))
			{
				for(int y = (Soldier.y - 6); y < (Soldier.y + 24); y++)
				{
					if(world_ptrs[(Soldier.x +3) - 2][y] != NULL)
					{
						if(world_ptrs[Soldier.x+3 - 2][y]->type == 0)
							Damage_BOB(world_ptrs[Soldier.x+3 - 2][y], 10);
						else
						{
							move = false;
							Soldier.action_timer = 0;
						}
					}
				}
				if(Soldier.object_ptr->curr_animation != 14)
					Set_Animation_BOB(Soldier.object_ptr, 14);
				if(move == true)
					Soldier.x -= 2;
				move = true;
				for(int x = (Soldier.x + 3); x < (Soldier.x + 24); x++)
				{
					if(world_ptrs[x][(Soldier.y+6) - 2] != NULL)
					{
						if(world_ptrs[x][Soldier.y+6 - 2]->type == 0)
							Damage_BOB(world_ptrs[x][Soldier.y+6 - 2], 10);
						else
						{
							move = false;
							Soldier.action_timer = 0;
						}
					}
				}
				if(move == true)
					Soldier.y -= 2;
			}

		}

		else if(Soldier.action_timer <= 0)
		{
			for(int index=FRIEND_LOW; index < FRIEND_HIGH; index++)
			{
				int x0 = FriendPos[index].x;
				int y0 = FriendPos[index].y;

				// now translate to screen coords, could have done above, but clearer
				x0 = x0 - world_x;
				y0 = y0 - world_y;
				
				// compute size
				int width = FriendPos[index].object_ptr->width;
				int height = FriendPos[index].object_ptr->height;

				// compute extents based on width,height
				int x1 = x0 + width - 1;
				int y1 = y0 + height - 1;

				// do clip trivial clip
				if ( (x0 >= WINDOW_WIDTH) || (x1 < 0) || (y0 >= WINDOW_HEIGHT) || (y1 < 0))
				continue; // don't need to render this one
				else
				{
					if(FriendPos[index].object_ptr->curr_frame != 122)
					{
						int tempdistance = Fast_Distance_2D(Soldier.x - FriendPos[index].x, Soldier.y - FriendPos[index].y);
						if(tempdistance <= distance)
						{
							distance = tempdistance;
							closest = index;
						}
					}
				}
			}

			int tempdistance = Fast_Distance_2D(Soldier.x - Player.x, Soldier.y - Player.y);
			
			if ((tempdistance <= distance) && (Player.object_ptr->curr_frame != 122))
			{
				Soldier.target_x = Player.x+16;
				Soldier.target_y = Player.y+16;
			}
			else
			{
				Soldier.target_x = FriendPos[closest].x + 16;
				Soldier.target_y = FriendPos[closest].y + 16;
			}

			Soldier.action_timer = random_range(1, 30);
		}
	}
}

void Damage_BOB(BOB_PTR xBob, int damage)
{
	xBob->life -= damage;
	if((xBob->life) <= 0)
	{
		xBob->curr_frame = 120;
		DSound_Play(death_sounds[random_range(0, 8)]);
	}
	else
		DSound_Play(hurt);
}

